--States and observe type:
---Sleeping(SL)
---Waking(C)
---Curious(A)
---Battling(P)
---Enraged(C)
---Bored(C)
---Hungry(C)
---Calm(C)
---Eating(PN)

--Inputs and meaning:
---N(Noise Detected)
---H(User Hungry)
---S(Strange Smell Detected)
---D(Dead Comrade Detected)
---E(Alive Enemy Seen)
---F(Friend Seen)
---DE(Dead Enemy Seen)
---SA(User Satisfied)
---T(User Tired)
---None(No Input Gotten)

--Observe types,meaning and inputs observed:
---SL(Sleeping; N, H, S, None)
---C(Casually Observable; N, H, S, D, E, F, DE, SA, T, None)
---A(All Possibly Observable; N, H, S, D, E, F, DE, SA, T, None)
---P(Observation Of People; D, E, F, DE, SA, T, None)
---PN(Observation Of People And Noise; N, D, E, F, DE, SA, T, None)


return {
    Sleeping={
        obs="SL",
        action="curiousAI",--sleepingAI",
        N={"Curious",1},
        H={"Hungry",1},
        S={"Curious",.5},
        D=nil,
        E={"Waking",1},
        F=nil,
        DE=nil,
        SA=nil,
        T=nil,
        None={"Bored",1},--nil,--make bored
    },
    Waking={
        obs="C",
        action="None",
        N={"Curious",.7},
        H={"Hungry",1},
        S={"Curious",.5},
        D={"Enraged",1},
        E={"Battling",1},
        F={"Bored",.3},
        DE={"Curious",.8},
        SA=nil,
        T={"Sleeping",1},
        None={"Bored",1},
        TH={"Throwing",1},
    },
    Curious={
        obs="A",
        action="curiousAI",
        N={"Curious",.9},
        H={"Hungry",.7},
        S={"Curious",.5},
        D={"Enraged",1},
        E={"Battling",1},
        F=nil,
        DE=nil,
        SA=nil,
        T={"Sleeping",.5},
        None={"Bored",.5},
        TH={"Throwing",1},
    },
    Battling={
        obs="P",
        action="battleAI",
        N=nil,
        H={"Hungry",.9},
        S=nil,
        D=nil,
        E=nil,
        F=nil,
        DE={"Calm",1},
        SA=nil,
        T={"Sleeping",.2},
        None=nil,
    },
    Dancing = {
        obs="P",
        action="dancingAI",
        N=nil,
        H={"Hungry",.2},
        S=nil,--{"Curious",.5},
        D={"Enraged",1},
        E={"Battling",1},
        F=nil,
        DE=nil,
        SA=nil,
        T={"Sleeping",.5},
        None={"Bored",.5},
        TH={"Throwing",1},
    },
    Throwing = {
        obs="P",
        action="throwAI",
        N=nil,
        H=nil,--{"Hungry",.2},
        S=nil,--{"Curious",.5},
        D={"Enraged",1},
        E={"Battling",1},
        F=nil,
        DE=nil,
        SA=nil,
        T={"Sleeping",.5},
        None={"Bored",.5},
    },
    Enraged={
        obs="C",
        action="battleAI",--enragedAI",
        N={"Curious",.3},
        H={"Hungry",.3},
        S={"Curious",.3},
        D=nil,
        E={"Battling",1},
        F=nil,
        DE={"Calm",.5},
        SA=nil,
        T={"Sleeping",.3},
        None={"Calm",.1},
    },
    Bored={
        obs="C",
        action="boredAI",
        N={"Curious",1},
        H={"Hungry",1},
        S={"Curious",1},
        D={"Enraged",1},
        E={"Battling",1},
        F=nil,
        DE={"Curious",1},
        SA=nil,
        T={"Sleeping",1},
        None=nil,
        TH={"Throwing",1},
    },
    Hungry={
        obs="C",
        action="hungryAI",
        N={"Curious",.5},
        H=nil,
        S={"Curious",.8},
        D={"Enraged",.8},
        E={"Battling",.8},
        F=nil,
        DE=nil,--though it depends if user isa carnivore
        FS={"Eating",1},
        SA={"Waking",1},
        T={"Sleeping",.5},
        None=nil,
        TH={"Throwing",1},
    },
    Calm={
        obs="C",
        action="calmAI",
        N={"Curious",1},
        H={"Hungry",1},
        S={"Curious",1},
        D={"Enraged",1},
        E={"Battling",1},
        F=nil,
        DE={"Curious",1},
        SA=nil,
        T={"Sleeping",1},
        None={"Bored",.5},
        TH={"Throwing",1},
    },
    Eating={
        obs="PN",
        action="eatingAI",
        N={"Curious",.3},
        H=nil,
        S=nil,
        D={"Enraged",.5},
        E={"Battling",.5},
        F=nil,
        DE=nil,
        SA={"Waking",1},
        T={"Sleeping",.2},
        None=nil,
        TH={"Throwing",1},
    },
}