local random = math.random --error(lume.distance(1,1,3,1))
local ai
ai = {

    battleAI = function(obj,target)
        --[[
                tooFarFromEnemy: can't use melee attack?
                tooCloseToPlayer: can use melee attack
                
                archer:
                        retreatProb -> returns 1(max)
                        chargeProb  -> returns 1(max)
                        
                animal:
                        tooCloseTo  -> returns false
                        tooFarFrom  -> returns true
                        chargeProb  -> returns 1(max)
                        
                        
        ]]
        
        local damage = obj:getDamage()
        local morale = obj.morale
        local target = target or obj.target--obj:getTarget() or target or obj.target or obj
        obj.target = target
        
        local elen = #obj.allEnemies
        if elen > 1 then
            local e = obj.allEnemies
            local best, target
            local n = "["..obj.name.."]"
            for x = 1, elen do
                local t = e[x]
                local dis = lume.distance(t.tile._x, t.tile._y, obj.tile._x, obj.tile._y)
                local val = 0
                
                if dis > (obj:getAttackRange()+2) then
                    val = val - dis
                end
                
                val = val + obj:getDislike(t)
                
                if obj.attacker == t then
                    val = val + obj.pettiness/2
                end
                
                n = n.."\n"..val..":"..t.name
                
                if not best or val > best then
                    target = t
                    best = val
                end
            end
            --error(n)
            obj.target = target
        end
        
        -- attack the one attacking you?
        if obj.attacker and obj.target ~= obj.attacker then
            --local a = obj.attacker
            --local at = lume.distance(obj.tile._x, obj.tile._y, a.tile._x, a.tile._y)
        end
        
        if obj:tooFarFromLeader() then obj:cry("Faaar")
            return obj:patrol()
        end
        
        if not obj.target then
            warn("Not obj.target!!!")
            obj.done = true
            return --obj:resetAI()
        end
        
        if obj.target then
        end
        

        if obj.target then
            local other = obj.target
            local victim = other.attacking and other.attacking ~= obj.team and other.attacking
            local attacking = other.attacker and other.attacker ~= obj.team and other.attacker
            
            if attacking and attacking.isCreature and attacking ~= obj and
               obj.team ~= attacking.team and
               obj:isEnemy(attacking) then
               
                obj:like(attacking, obj.gratitude)
                if obj:getDisliking(attacking) < obj.dislikeTrigger then
                    obj:speakText(obj.respectText, attacking)
                    if attacking.isPlayer then
                        attacking:addLog(string.format("%s is more friendly to %s",obj.title, attacking.title))
                    end
                else
                    obj:speakText(obj.respectText, attacking)
                    if attacking.isPlayer then
                        obj:addLog(string.format("%s notices the help of %s.",obj.title, attacking.title))
                    end
                end
            end
            
            obj:cry("trying attack "..obj.target.name)
            local canAttack = obj:canAttack(obj.target)
            obj:cry(tostring(canAtttack).."?")
            
            if obj.alerter >= 2 or (obj.alerter==1 and canAttack) then log("xc?")
                if (not obj.isSilent) and not obj.called[obj.tile.roomData] then
                    obj.called[obj.tile.roomData] = true
                    log("call?")
                    obj:callOthers()
                    return
                end
                
            end
            
            if obj.attacker and (obj:isCowardly()) or obj:tooCloseTo(obj.target) then
                log("run,")
                if not obj.ran then
                    obj.ran = true
                    local a = obj.attacker or obj.target
                    obj:addLog(string.format("%s is running away from %s!", obj.title, a.title or a.name))
                end
                
                obj:runAwayFrom(obj.attacker or obj.target)
                log("runned")
                return
            end
            
            obj.ran = false
            
            if canAttack then
                obj:cry("ATTACKING")
                log("att")
                obj:doAttack(obj.target)
                obj.huntingFood = nil
                --obj.done = 1
                return
            end
        else
            obj.called = {}
            obj.done = true
        end

    
        if obj.target and obj:tooFarFrom(obj.target) and not obj.immobile then
            obj:cry("pace!"..obj.target.name)
            if obj:tooFarFrom(obj.target) then
            --cwarn("far? green","green")
            end
            log("far from targ")
            obj:moveTo(obj.target)
            --assert(obj.boid.path)
        else
            log("missed , proceed "..tostring(obj.immobile)..tostring(obj.target and obj:tooFarFrom(obj.target))..tostring(obj.target and (obj.target._id or obj.target.name)))
            obj:cry("missed")
            obj.done = true
        end
    end,

    sleepingAI = function(obj)
        local trash = obj.sleep and obj:sleep()
        obj.done = true
    end,
    
    curiousAI = function(obj)
        if (obj:tooFarFromLeader()) then-- and obj:getLiking(obj.leader)>obj.foodLiking) then
            obj:patrol()
            return
        end
        
        --involves chasing down a noise
        if obj.noise then
            local tile = obj.room.nm:getSource(obj.noise)
            if tile then
                obj:moveTo(tile)
            else
                obj.done = true
                obj.noise = nil
            end
        else
            obj:patrol()--Dungeon()
        end
   end,
    
    calmAI = function(obj) error("!")
        obj.done = true
    end,
    
    dancingAI = function(obj)
        return obj:patrolRoom()
    end,
    
    enragedAI = function(obj)
        obj.done = true
    end,
    
    --equivalent to doing job
    boredAI = function(obj)
        if obj.waiting then
            obj:patrolRoom()
        else
            obj:patrol()--Room("nursery")
        end
    end,
    
    eatingAI = function(obj,target)
        obj.done = true
    end,
    
    throwAI = function(obj)
        local ob = obj.toThrow or obj:getRandomItem()
        
        if not ob then
            obj.currentState = "Bored"
            obj:patrolRoom()
            return
        end
        
        local throwTarget = obj.throwTarget or obj.tile.room:getRandomSpaceTile()
        
        if obj.throwTarget and lume.distance(obj.x/tw,obj.y/tw,throwTarget.x/tw,throwTarget.y/tw) > obj.throwDistance then
            obj:moveTo(throwTarget)
            
        elseif attacks.throwWillReach(ob, obj, throwTarget) then
            attacks.throwItem(ob, obj, throwTarget)
            obj.toThrow = nil
            obj.throwTarget = nil
            obj.throwDistance = nil
            obj.currentState = "Bored"
        else
            obj:patrolRoom()
        end
    end,
    
    hungryAI = function(obj)
        local target = obj.foodTarget
        
        if not target or (obj:tooFarFromLeader() and obj:getLiking(obj.leader)>obj.foodLiking) then
            obj:patrol()
            return
        end
        
        if target.isCreature then
            obj.huntingFood = true
            obj.liking[target] = -8 if pl then pl:cry("...pfid") end
            return ai.battleAI(obj, target)--obj:patrol()--done = true
        else
            local t = obj.tile
            local t2 = target.tile
            
            if lume.distance(t._x, t._y, t2._x, t2._y)<2 then
                if obj.carryFood or obj.grabFood then
                    local op = obj.canPickUpItems pl:cry("yes...clc")
                    if obj.room:moveObject(obj, getDir(target.x - obj.x), obj:getDir(target.y-obj.y)) then
                        obj:forceAddItem(target)
                        if obj.onGrabFood then
                            obj:onGrabFood(target)
                        end
                    end
                else
                    obj:eat(target)
                end
            else
                obj:moveTo(target.tile)
            end
        end
    end,
    
    None = function(obj)
        obj.done = true
    end,
    
}

return ai