
local a = {}
abilities = a
data.abilities = a

local function muncherHunger(self)
    return self.hungerRate > 0
end

a.suffocate = {
    events = {
        Attack = function(self, user, victim)
        
        end
    },
    once = function(self, user)
        user.getAttack = function(self, obj)
            user.room:removeCreature(user, true)
            --user.room:destroy_instance(user)
            user.__olddraw = user.__olddraw or user.__draw
            user.__draw = null
            user._oldSpriteDelay = user.sprite:getDelay()
            user.sprite:setFrame(1)
            user.sprite:setDelay(1000)
            
            obj.parasite = user
            
            user.drain.speed = self.speedDrain or .2
            user.drain.strength = self.strengthDrain or .2
            user.drain.health = self.healthDrain or 1
            
            user.clumsinessAdd = (self.clumsiness or 2)
            obj.clumsiness = obj.clumsiness + user.clumsinessAdd
            
            user:addLog(string.format("%s suffocates %s!", user.title, obj.title))
            
            if user.isSeen or obj.isSeen then
                user.parasite_x, user.parasite_y = user.x, user.y
                local function next()
                    user.parasite_x = nil
                    user.parasite_y = nil
                    user.room:playNextCreature()
                end
                user.room:tween(.2, user, {parasite_x=obj.x, parasite_y=obj.y}, "in-quad", next)
            else
                user.room:playNextCreature()
            end
        end
    end
}

a.vorpal_movement = {
    events = {
        Move = function(self, user, tile)
            local vorpal = {title = "some vorpal energy", name = "vorpal energy", attack = self.attack or user.stats.strength/2, parent = user, isItem = true}
            
            for d = 1, (self.range or 1) do
                for x = 1, 8 do
                    local dir = dirs8[x]
                    local t = tile.room:getTile(tile._x+dir[1]*d, tile._y+dir[2]*d)
                    if t and t.unit then
                        t.unit:getAttacked(vorpal, nil, nil, true, true, nil, nil, true)
                    elseif t and t.solid then
                        t:getAttacked(vorpal.attack)
                    end
                end
            end
            
            tile.room:addEnchantLight(tile, 5, self.color or "lightpurple", 2)
            if user.isSeen or 1 then
                local b = tile.room:shout(tile, ((self.range or 1)+1)*tw, self.color or "lightpurple", true)
                b.onlyLine = not user.isSeen
                b.depth = DEPTHS.WALLS+3
            end
            
        end
    },
}


a.vorpal_teleportation = {
    events = {
        Teleport = a.vorpal_movement.events.Move
    },
}


a.uncontrolled_teleportation = {
    events = {
        EndTurn = function(self, user)
            user._toTeleport = user._toTeleport or math.random(100)<(self.chance or 15)
            if user._toTeleport then
                user:shake(15,3,20)
            end
        end,
        
        Move = function(self, user)
            if user._toTeleport then
                user._toTeleport = nil
                user.toTeleport  = true
            end
        end
    }
}
    
a.split = {
    events = {
        Damaged = function(self, user, attacker, att)
            if attacker.isEntity then
                local clone = user:clone(nil, self.fullHp or self.ultimate)
            end
        end
    },
    info = "Splits into 2 when attacked.",
    -- magical = boolean
    -- ultimate = boolean
    -- fullHp = boolean
}

a.muncher = {
    events = {
        BeforeEat = function(self, user, victim)
            user.hungerRate = user.hungerRate - (victim.isTree and 2 or 1)
            
            if victim.isTree then
                if victim._id == "flamesprout" then
                    user:makeImmuneTo("burn")
                    user.light = user.light or {3*self.level, "lightorange"}
                    user.shell.color = "darkorange"
                end
                
            end
        end
    },
    
    info = "Eats and gains the ability of plants.",
    once = function(self, user)
        user.hungerRate = self.level * (math.random(3,7))
        user.isHungry = muncherHunger
    end
}

function ho()
    local r = pl.tile
    self:spawn("giant_snail",r)
    self:spawnItem("flamesprout",r)
    self:spawnItem("potion_of_haste",r)
end


a.revive = {
    events = {
        Death = function(self, user)
            local data = data.creatures[self.object or "orb"]
            local hocrux = Creature:new(data)
            hocrux.parent = user
            hocrux.toRevive = self.toRevive or 4
            user.room:spawn(hocrux, user.tile, user.team)
        end
    },
    
    info = "Chance to get back up",
    -- item = orb
}

a.steal = {
    events = {
        Attack = function(self, user, victim)
            local ll = self.level or self.intensity or 1
            if victim.allItems and #victim.allItems > 1 and math.random()<(.3*ll) then
                local l = lume.copy(victim.allItems)
                local i = lume.eliminate(l)
                while i.equipped do
                    if #l<1 then
                        break
                    end
                    i = lume.eliminate(l)
                end
                
                if not i then
                    user:addLog(string.format("%s tried to steal but failed!",user.title))
                else
                    user:addLog(string.format("%s stole %s from %s!",user.title,i.unspecific,victim.title))
                    victim:removeItem(i, true)
                    user.room:reloadInventoryUI()
                    user:forceAddItem(i)
                    i.stolen = true
                    user:wieldItem(i)
                    user:playSteal(user, victim, i)
                end
            end
        end
    }
}

a.thief = {
    events = {
        Attack = a.steal.events.Attack,
        Steal = function(data, self, victim, item)
            self.cowardice = 11
            self.closest = 10
            self.farthest = 100
        end
    },
}

a.adrenaline = {
    events = {
        Damaged = function(self, user)
            if (user:healthPercentage() <= 30 or user.stats.health <= (self.health or 1)) and not user.adrenalined then
                local i = self.intensity or self.level or 1
                local ba = buffs.adrenaline
                user:applyBuff("adrenaline",ba.getTime(i),ba.getValue(i))
                user.adrenalined = true
            end
        end
    }
}

a.burn = {
    events = {
        StartTurn = function(self, user)
            if user.tile:isFlammable() then
                Fire:new({source=user.tile, range=1, intensity=self.intensity or 1})
            end
        end,
        
        Attack = function(self, user, victim)
            if math.random()<((self.burnChance or 30)/100) then
                victim:applyBuff("burn",3,2)
            end
        end
    },
    
    once = function(self, user)
        user.light = user.light or {2, "orange"}
        user:makeImmuneTo("burn")
    end
}

a.float = {
    -- chance to bop around if not steady
    --steady = false
    
    once = function(self, user)
        user.flying = 10
        user.unsteady = not self.steady
    end
}

a.bezerk = {
    events = {
        Damaged = function(self, user)
            if (user:healthPercentage() <= 30 or user.stats.health <= 1) and not user.bezerk then
                user._bcolor = user._bcolor or user.color
                user._bmaxHealth = user._bmaxHealth or user.maxHealth
                user._bhealth = user._bhealth or user.stats.health
                user._bstrength = user._bstrength or user.strength
                user._battack = user._battack or user.attack
                user._blight = user.light
                
                if user.light then
                    user.room:removeLight(user.light)
                end
                
                local pp = .2 -- 20%
                
                user.attack = user.attack + 3
                user.strength = user.strength + 3
                user.stats.health = user.stats.health + user.maxHealth*pp
                user.maxHealth = user.maxHealth + user.maxHealth * pp
                user.light = {3,"red"}
                user.lightData = user.room:addLight(user.tile, user.light[1], user.light[2])
                user.color = "red" warn()
                
                user.shealth = 2
                
                user.bezerk = true
            end
        end
    },
    info = "Power increases at low health"
}