data.attacks = {}
attacks = data.attacks
local a = attacks


a.shoot = function(shooter, user, victim, inRange)
    local ammo, amount, attack = shooter:hasAmmo(user)

    if ammo then
        if user.isPyylayer then
        
        elseif inRange or user:inRange(victim, shooter.range) then
            for x = 1, amount-1 do
                user:removeItem(ammo, true)
            end
            local item = user.allInventoryItemsByType[ammo][#user.allInventoryItemsByType[ammo]]
            if user.isSeen or user.isPlayer or victim.isSeen or victim.isPlayer then
                if shooter.isGun then
                    shooter.angle = math.deg(user.tile:getAngle(victim.tile or victim))
                    user.name = shooter.angle
                    user:shootGun(shooter,shooter.bullet or "shell", victim, nil)
                    user.done = true
                    if user.isPlayer then
                        user.room:playNextCreature()
                    end
                else
                    a.throwItem(item, user, victim, attack or shooter.attack,nil,nil,nil,true)
                end
                return
            else
                local oa = item
                item.attack = attack or shooter.attack or item.attack
                if victim.getAttacked then
                    victim:getAttacked(item)
                end
                item.attack = oa
                user:removeItem(item, true)
            end
        end
    end
    
    return user.room:playNextCreature()
end

a.summon = function(user, creature, amount, tile, team)
    local cr
    
    if type(tile) == "string" then
        local tteam = team
        team = tile
        tile = tteam
    end
    
    if type(amount) == "table" and amount.isTile then
        local ttile = tile
        tile = amount
        amount = ttile or nil
    end
    
    amount = getValue(amount or 1)
    
    for x = 1, amount do
        cr = user.room:spawn(creature, tile or user.tile, team or user.team)
        user.summoned[#user.summoned+1] = cr
        cr.master = user
        cr.hostility = lume.max(cr.hostility, user.isPlayer and 3 or user.hostility or 3)
        cr.liking = lume.copy(user.liking)
    end
    
    if true then
        user:addLog(
            string.format("%s summoned %s %s%s.", user.title, amount == 1 and "a" or amount, creature.name, amount~=1 and "s" or ""), 
                        user.room.player:isAlly(user) and "lime" or user.isPlayer and "lime" or "red"
            
        )
     end
     
    user.done = true
    return cr
end

a.divineBlast = function(user, value, tile, buff)
    
    local x, y = user.room.camera:toWorldCoords(0,-100)
    local time = (lume.distance(tile.x, tile.y, tile.x, y)/(10*tw))*.7-- warn()
    local lw = 1
    local laser = Laser:new({x=tile.x,y=y,len=tw*50,w=tw*lw,h=tw*lw,target=tile or user.tile or user,time=time})
    laser.angle = math.deg(math.atan2(laser.y-tile.y,laser.x-tile.x))
    user.room:must_draw(laser)
    user.room.stall = true
    
        
    user.room:addLight(tile, 7, "maroon", time+3.55)
        
    user.room.timer:after(time+.5, function()
        if tile.unit then
            tile.unit:getAttacked(buff, 10, nil, true)
            user:addLog(
                string.format("A blast of divine energy surges down and blasts %s.",tile.unit.title),
                "crimson")
        elseif tile.item and tile.item.getAttacked then
            user:addLog(
                string.format("A blast of divine energy surges down and blasts %s.",tile.item.title),
                "crimson")
            tile.item:getAttacked(buff, 10, nil, true)
        else
            user:addLog("A blast of divine energy surges down.","crimson")
        end
        
        user.room.timer:tween(.2,laser, {image_alpha=0}, "out-quad", function()
            --user.done = true
            user.room.stall = false
        end)
    end)
end

local function sortThrow(tile)
    return tile.isTile--not tile.solid
end

a.throwWillReach = function(item, user, target, dis, ignoreDistanceCheck)
    do
        item = item or {}
        local i = item
        local tt = user.tile
        local tile = target.tile or target
        local touchedTiles = {}
        local tooFar
        
        local tiles, len = user.world:querySegment(tt.x+tw/2, tt.y+th/2, tile.x+tw/2, tile.y+th/2, sortThrow)
        local lastTile = tt
        for ii = 1, len do -- #add max throw range
            local t = tiles[ii]
            t.throwing = false
            if t.solid then
                break
            end
            
            if (not ignoreDistanceCheck) and dis and lume.distance(tt._x, tt._y, t._x, t._y) > dis then
                tooFar = true
                break
            end
            
            lastTile = t.item and item.isThrowObstacle and item and lastTile or (t.unit and i.unitBlocks and lastTile) or t
            
            touchedTiles[#touchedTiles+1] = lastTile
            
            if t.item and t.item.isThrowObstacle or (t.unit and t.unit~=user) then
                break
            end
            
        end
        
        return lastTile == tile 
        --or (tooFar and ignoreDistanceCheck)
        --or (not ignoreDistanceCheck and dis and lume.distance(lastTile._x, lastTile._y, tile._x, tile._y)<=dis)
        ,
        touchedTiles
    end
end

a.shootWebs = function(user, target, webStrength, webColor, fast, maxDis, compact, webSpread)
    local reach, tiles = attacks.throwWillReach(nil, user, target, maxDis, true)
   
    if reach then
        local web = {
            strength = webStrength or 2,
            color = webColor or "pink"
        }
        
        local tilesWebbed = {}
        local toWeb = {}
        local toWeb2 = {}
        
        fast = fast or (not user.isSeen and not target.isSeen)
        
        for x = 1, #tiles do
            local t = tiles[x]
            if not tilesWebbed[t] and t ~= user.tile and (not compact or x==#tiles) then
            
                if not fast then
                   toWeb[#toWeb+1] = t
                else
                    t:addWeb(web)
                end
                
                tilesWebbed[t] = true
            end 
            
            if  x == #tiles then
                
                for i = 1, 8 do
                    local d = dirs8[i]
                    
                    for xx = 1, (webSpread or 1) do
                        local newT = t.room:getTile(t._x+d[1]*xx, t._y+d[2]*xx)
                        if newT and not newT.solid and not tilesWebbed[newT] then
                    
                            if not fast then
                                local toeb = math.random()>.5 and toWeb or toWeb2
                                toeb[#toeb+1] = newT
                            else
                                newT:addWeb(web)
                            end
                        
                            tilesWebbed[newT] = true
                        end
                    end
                end
            end
        end
        
        if fast then
            user.done = true
        else
            local count = 0
            local len = #toWeb
            local webb
            
            local function stick()
                count = count + 1
                if count > len then
                    for x = 1, #toWeb2 do
                        toWeb2[x]:addWeb(web)
                    end
                    user.room.timer:cancel(webb)
                    user.done = true
                else
                    toWeb[count]:addWeb(web)
                end
            end
            
            webb = user.room.timer:every(.05, stick)
        end
        
        return true
    else
        user.done = true
    end
end

local plants = {
    flamesprout = 4,
    watersprout = 2,
    pooleaf = 5,
    frostflower = 4,
    cursed_flower = 1,
    poisonleaf = 2,
}


local plants2 = {
    flamesprout = 4,
    watersprout = 2,
    pooleaf = 5,
    frostflower = 4,
    poisonleaf = 3,
}

getRandomSeed = function()
    return string.format("%s_seed",lume.weightedchoice(plants2))
end

local noObstructivePlant = {
    --frostflower = 1,
    poisonleaf = 1,
}

a.vegetation = function(tile, grade)
    for x = 1, grade do
        for d = 1, 8 do
            local dx = dirs8[d][1]*x
            local dy = dirs8[d][2]*x
            
            local tile = tile.room:getTile(tile._x+dx, tile._y+dy)
            
            
            if tile then
                local doPlant = math.random(100)<(25+(20*(grade-1)))
                local growth = lume.min(math.random(10+(30*(grade-1)),75+(30*(grade-1))),100)/100
                if doPlant then
                    local plant = lume.weightedchoice((tile.item and tile.item.isObstacle or tile.unit) and noObstructivePlant or plants)
                    
                    local p
                    
                    if plant ~= "cursed_flower" then
                        p= tile.room:spawnItem(plant, tile)
                    else
                        p = tile.room:spawn(plant, tile)
                    end
                    
                    if p and p.growthTime then
                        p.toGrow = math.floor(p.growthTime*growth)
                    end
                else
                    tile.room:makeGrass(tile)
                end
            end
        end
    end
    
end

a.fireLightning = function(user, targ, att, color)
    return a.lightning(user, targ, att, color, true)
end

a.lightning = function(user, target, attack, color, fire_lightning)

    color = 
        color and (type(color)=="table" and type(color[1])=="number" and color or getValue(color))
        or fire_lightning and "orange"
        or getValue(user.lightningColor or user.lightningColors or "yellow")
    
    local ux, uy = (user.tile or user):get_center()
    local tx, ty = (target.tile or target):get_center()
    user.attackRange = 4
    
    local attack = attack or 1
    local attacker  = {parent = self, deathText="%s %s by lightning!"}
    
    local time = .4
    local s = tw*10
    local ang = math.atan2(ty-uy, tx-ux)
    local tiles, len = user.world:querySegment(ux, uy, ux+math.cos(ang)*s, uy+math.sin(ang)*s, sortThrow)
    local lastTile = tt
    -- edit enchanted light to be just added on (min, max)
    
    for ii = 1, len do -- #add max throw range
        local t = tiles[ii]
        if not t.solid then-- or ii == 1 or ii == len or tiles[ii+1].solid then
            user.room:addLight(t,5,color or "yellow",time)
        end
        
        tx, ty = t:get_center()
        
        if t.unit and t.unit.getAttacked and t.unit ~= user then
            t.unit:addLog(string.format("&colors.skyblue Lightning &colors.yellow @zapped ~ %s!", t.unit.title))
            t.unit:getAttacked(attacker, attack)
        end
        
        if fire_lightning and t.fires<1 and (attack>5 or t:isFlammable()) then
            Fire:new({
                    source = t,
                    intensity = not t:isFlammable() and .5 or attack<2 and attack/2 or (attack-1),
                })
            
        end
        
        if t.solid then
            break
        end
        
        
    end
    
    for x = 1,(fire_lightning and 4 or 1) do
    
    local l = Lightning:new({
        x  = ux,  y = uy,
        gx = tx, gy = ty,
        color = fire_lightning and math.random()>.6 and "red" or color,
        life = time,
        user =x==1 and user,
        thickness = fire_lightning and lume.min(attack+5, 20) or lume.min(attack+1,15)
    }) end
    
    user:play_sound("zap")
            
    --user.done = true
end

a.flame = function(user, target, attack)
    attack = attack or 1
    local puff = Item:new(items.firepuff)
    user.room:store_instance(puff)
    puff.attack = attack
    
    local ux, uy = user.tjile and user.tile.x or user.x, user.tilei and user.tile.y or user.y
    --ux = ux + (tw-ux)/2
    puff.debug = 1
    puff:center()--offset(0,0)
    puff:move_to(ux, uy)
    
    SmokeTrail(puff)
    
    -- user.attackRange = 7
    a.throwItem(puff, user, target, attack, true, .25)
end

a.iceShot = function(user, target, level)
    attack = attack or 1
    local puff = Item:new(items.icepuff)
    user.room:store_instance(puff)
    puff.attack = attack
    
    local ux, uy = user.tjile and user.tile.x or user.x, user.tilei and user.tile.y or user.y
    --ux = ux + (tw-ux)/2
    
    puff:center()--offset(0,0)
    puff:move_to(ux, uy)
    
    -- SmokeTrail(puff)
    puff.grade = level or 1
    
    a.throwItem(puff, user, target, attack, true, .25)
end


a.blast = function(user, target, buff, grade, color)
    local b = buffs[buff] or buff
    
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = color or b.color
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    puff.buff = buff
    puff.buffTime = b.getTime(grade)
    puff.intensity = b.getValue(grade)
    
    a.throwItem(puff, user, target, 0, true, .25)
end



a.poisonBlast = function(user, target, time)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = gasColors.poison
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    puff.buff = "poison"
    puff.buffTime = time
    
    a.throwItem(puff, user, target, 0, true, .25)
end



a.tunnel = function(user, target, level)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "olive"
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.llife = level
    
    puff.onDestroyed = function(self, ...)
        
    
        od(self, ...)
    end
    
    a.tunnelThrough(puff, user, target, 0, true, .1)
end

a.gasBlast = function(user, target, level)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "olive"
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        Gas:new({
            tile=self.tile or error("no tile for gas on death"),
            intensity = level*2,
            flammability = 2,
            color = gasColors.stinky,
            range = 2+level,
            lifeBonus = -1+(level/2)
        })
    
        od(self, ...)
    end
    
    a.throwItem(puff, user, target, 0, true, .25)
end

a.mindSwitchBlast = function(user, target, level)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "lightorange"
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        if self.tile.unit then
            user:mindSwitch(self.tile.unit, level)
        end
    
        od(self, ...)
    end
    
    a.throwItem(puff, user, target, 0, true, .25)
end

a.switchPlaceBlast = function(user, target, level)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "cyan"
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        if self.tile.unit then
            self.room:switchPlaces(user, self.tile.unit)
        end
    
    
        od(self, ...)
    end
    
    a.throwItem(puff, user, target, 0, true, .25)
end

a.enslavementBlast = function(user, target, level)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "lightbrown"
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        if self.tile.unit then
            self.tile.unit:getEnslavedTo(user, level)
        elseif self.tile.item then
            user:addLog(string.format("%s enslaved %s?", user.title, self,item.unspecific))
        else
            user:addLog(string.format("%s%s enslaved some dirt!",user.isPlayer and "#Congratulations! ~ " or "", user.title))
        end
        
        od(self, ...)
    end
    
    a.throwItem(puff, user, target, 0, true, .25)
end

a.enslave = function(user, target, level)

end


a.shootExplosion = function(user, target, level)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "tan"
    puff.light = {2,"yellow"}
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        Fire:new({
            tile=self.tile or error("no tile for gas on death"),
            explode = true,
            range = level,
        })
    
        od(self, ...)
    end
    
    a.throwItem(puff, user, target, 0, true, .25)
end


a.shootSummon = function(user, target, level, summon)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "lightpink"
    puff.light = {2,"pink"}
    puff:move_to(user.x,user.y)
    SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        attacks.summon(user, summon, level*4, self.tile or target.tile or target)
        
        od(self, ...)
    end
    
    a.throwItem(puff, user, target, 0, true, .25)
end

a.shootCompactWebs = function(user, target, webStrength, webSpread, color, fast, maxDis)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "white"
    puff:move_to(user.x,user.y)
    --SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    puff.onDestroyed = function(self, ...)
        a.shootWebs(user, target, webStrength, color, fast, maxDis, true, webSpread)
        od(self, ...)
    end
    
    
    a.throwItem(puff, user, target, 0, true, .25)
end


a.teleportationBlast = function(user, target, tile)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "yellow"
    puff:move_to(user.x,user.y)
    --SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    local tcolor = "yellow"
    
    puff.onDestroyed = function(self, ...)
        local u = target.isCreature and target or target.unit
        if u then
            u.room:addEnchantLight(u.tile, 3, tcolor)
            u.room:teleport(u, tile, true)
        elseif target.item then
            local i = target.item
            i.room:addEnchantLight(i.tile, 3, tcolor)
            i.room:teleport(i, true)
        end
        od(self, ...)
    end
    
    
    a.throwItem(puff, user, target, 0, true, .25)
end


a.blink = function(user, target, tile)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "yellow"
    puff:move_to(user.x,user.y)
    --SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    local tcolor = "gray"
    
    puff.onDestroyed = function(self, ...)
        local u = user or target.isCreature and target or target.unit
        if u then
            u.room:addEnchantLight(u.tile, 3, tcolor)
            u.room:teleport(u, target, true)
        end
        od(self, ...)
    end
    
    
    a.throwItem(puff, user, target, 0, true, .1)
end


a.beckon = function(user, target, tile)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "skyblue"
    puff:move_to(user.x,user.y)
    local dirX = getDir(target.x-user.x)
    local dirY = getDir(target.y-user.y)
    
    local t = user.room:getTile(user.tile._x+dirX, user.tile._y+dirY)
    
    --SmokeTrail(puff)
    
    local od = puff.onDestroyed
    
    local tcolor = "gray"
    
    puff.onDestroyed = function(self, ...)
        local u = target.isCreature and target or target.unit or target.item
        if u then
            u.room:addEnchantLight(u.tile, 7, tcolor)
            u.room:teleport(u, t, true)
            user:addLog(string.format("%s beckoned %s close!", user.title, u.title or u.name))
        end
        od(self, ...)
    end
    
    local function l(tile)
        user.room:addEnchantLight(tile, 3, tcolor)
    end
    
    a.throwItem(puff, user, target, 0, true, .1, l)
end

local polymorphList = {"goblin","skeleton","rat"}
a.polymorphBlast = function(user, target, time)
    local puff = Item:new(items.puff)
    user.room:store_instance(puff)
    puff.color = "green"
    puff:move_to(user.x,user.y)
    --SmokeTrail(puff)
    
    local od = puff.onDestroyed

    
    puff.onDestroyed = function(self, ...)
        local u = target.isCreature and target or target.unit
        if u then
            local g = u.data._id
            while g == u.data._id do
                g = getValue(polymorphList)
            end
            u:polymorph(g, time)
        elseif target.item then
            --local i = target.item
            --i.room:addEnchantLight(i.tile, 3, tcolor)
            --i.room:teleport(i, true)
        end
        
        od(self, ...)
    end
    
    
    a.throwItem(puff, user, target, 0, true, .25)
end

local throwTexts = {"threw","chucked","flung"}

a.throwItem = function(item, user, target, attack, fake, time, func, straight)
    do
        log("throw att")
        local i = item
        local tt = user.tile
        local tile = target.tile or target
        
        local tiles, len = user.world:querySegment(tt.x+tw/2, tt.y+th/2, tile.x+tw/2, tile.y+th/2, sortThrow)
        
        local lastTile = tt
        for ii = 1, len do -- #add max throw range
            local t = tiles[ii]
            t.throwing = false
            if t.solid then
                break
            end
            
            lastTile = t.item and item.isThrowObstacle and item and lastTile or (t.unit and i.unitBlocks and lastTile) or t
            if not item.ignoreItems and (t.item and t.item.isThrowObstacle or (t.unit and t.unit~=user)) then
                break
            end
            
            if func then
                func(tile)
            end
            
        end
        
        if not fake then
            user:removeItem(i)
        end
        
        if i.tile then
            i.tile.item = nil
        end
        
        if not straight then
            user:addLog(string.format("%s %s %s.", user.title, getValue(throwTexts), item.unspecific))
        end
        
        -- to avoid printing throw again
        item.shot = true
        
        item.parent = user
        
        i.throwing = true
        i.tile = lastTile
        --tile.item = nil
        i.throwing = true
        
        if not i.isPuff then
            user:play_sound("throw")
        else
            -- i is a puff that was zapped/shot from another item
        end
        
        local function thrown()
            i.throwing = false
            --i.tile = lastTile
            
            log("Trying to hit throw...")
            i:onThrown(lastTile, user)
            local attack = (attack or 0) + (item.attack or 0)
            if attack > 0 and target.getAttacked and not item.attacked then
                local oa = item.attack
                item.attack = attack
                
                log("ATTACK UTHROW")
                if target:getAttacked(item) then
                    -- remove item?
                end
                
                item.attack = oa
                item.attacked = true
            -- else
                user.done = true
            else
                log("...but attack "..attack..", targ.getAttacked "..tostring(target.getAttacked)..", item.attacked "..tostring(item.attacked))
                user.done = true
            end
            i.va = 0
            if item.attacked or true then
            end
            
            if user.isPlayer then log("UDONE")
                user.room:playNextCreature()
            end
        end
        --i.debug = 1
        local time = (time or .1)*(lume.distance(tt._x, tt._y, lastTile._x, lastTile._y))
        i.va = (not straight and i.data.throwVa) or (straight and 0) or 360*4--local spin = (time/.3)/3
        if straight then
            i.va = 0
        end
        if not straight then
            i.face_direction = i.data.face_direction or straight and 180 or nil
        else
            i.angle = math.deg(math.atan2(lastTile.y-tt.y,lastTile.x-tt.x))
        end
        
        i.name_tag=lume.distance(tt._x, tt._y, lastTile._x, lastTile._y)
        if user.isSeen or target.isSeen then
            user.room:tween(time, i, {x=lastTile.x, y=lastTile.y}, "in-quad", thrown)
        else
            thrown()
        end
    end
end

local tunnelFunc = function(self, tile)
            if tile.solid then
                tile:getAttacked(10, self)
                self.llife = self.llife - 1
            end
            
            if self.llife <= 0 then
                self.room:destroyItem(self)
                self.room:playNextCreature()
                self.room.timer:cancel(self.cl)
            end
        end

a.tunnelThrough = function(item, user, target, attack, fake, time, func, straight)
    do
        local i = item
        local tt = user.tile
        local tile = target.tile or target
        
        --local tiles, len = user.world:querySegment(tt.x+tw/2, tt.y+th/2, tile.x+tw/2, tile.y+th/2, sortThrow)
        local dx = tile.x-tt.x
        local dy = tile.y-tt.y
        local e  = 10
        local ang = item.getAngle(tt.x+tw/2, tt.y+th/2, tile.x+tw/2, tile.y+th/2)
        local tiles, len = user.world:querySegment(tt.x+tw/2, tt.y+th/2, tt.x+tw*e*dx+tw/2, tile.y+th*e*dy+th/2, sortThrow)
        
        local lastTile = tt
        for ii = 1, len do -- #add max throw range
            local t = tiles[ii]
            t.throwing = false
            if t.solid then
              --  break
            end
            
            lastTile = t--t.item and item.isThrowObstacle and item and lastTile or (t.unit and i.unitBlocks and lastTile) or t
            if not item.ignoreItems and (t.item and t.item.isThrowObstacle or (t.unit and t.unit~=user)) then
               -- break
            end
            
            if func then
                func(tile)
            end
            
            if item.done then
            
            end
        end
        
        if not fake then
            user:removeItem(i)
        end
        
        if i.tile then
            i.tile.item = nil
        end
        
        if not straight then
            user:addLog(string.format("%s %s %s.", user.title, getValue(throwText), item.unspecific))
        end
        
        -- to avoid printing throw again
        item.shot = true
        
        item.parent = user
        
        i.throwing = true
        i.tile = lastTile
        --tile.item = nil
        i.throwing = true
        
        
        --i.debug = 1
        local time = (.131)*(lume.distance(tt._x, tt._y, lastTile._x, lastTile._y))
        i.va = (not straight and i.data.throwVa) or (straight and 0) or 360*4--local spin = (time/.3)/3
        
        if straight then
            i.va = 0
        end
        
        if not straight then
            i.face_direction = i.data.face_direction or straight and 180 or nil
        else
            i.angle = math.deg(math.atan2(lastTile.y-tt.y,lastTile.x-tt.x))
        end
        
        
        local cl
        item.tileFunc = tunnelFunc
        local sp = tw*2
       -- local function thrown() error() end
        item.cl = user.room:tween(time, item, {x=lastTile.x, y=lastTile.y}, "in-quad", thrown)
        
    end
end