data.buffs = data.buffs or {}
buffs = data.buffs
local cr = data.buffs

local activateNumber = 10

-- rarity
local C, R, U, m = 20, 10, 5, 2

-- times for echants
-- attacks have verbs

local enc = 3
local mRange = 1
Room.t = tw

local function getEffectValue(lvl)
    return lvl
end

cr.quietus = {
    name = "quietus",
    prefix = {"silencing"},
    continue = "silencing",
    verb = "silenced",
    color = "purple",
    
    rarity = M,
    
    curse = "user",
    buff = "target",
    
    getTime = function() return 1 end,
    getValue = getEffectValue,
    
    activateChance = function(lvl)
        return 10+lvl*5
    end,
    
    once = function(self, user)
        user.blood = false
        user:die()
        local l = user.room:addLight(user.tile, mRange, "maroon", .3)
        
    end
}

local spawn = {3,4,4,5,5,5,6,7,8,8,9,9}
cr.multiplicity = {
    name = {"multiplicity","conjuring"},
    prefix = {"conjuring"},
    continue = "",
    color = "pink",
    
    R = U,
    
    curse = "target",
    buff = "user",
    cursePrefix = "evil",  -- defaults to "self" (e.g. "self-burning")
    
    getTime = function() return 1 end,
    getValue = function(lvl)
        return spawn[lvl] or 10
    end,
    
    activateChance = function(lvl)
        return 10+lvl*5
    end,
    
    once = function(self, user, value)
        local cr = creatures.spectral_blade
        local oa = cr.attack or cr.strength
        cr.attack = self.enchants
        
        attacks.summon(user, cr, value)
        
        cr.attack = oa
    end
}


cr.blasphemy = {
    name = {"blasphemy","blasphemy"},
    prefix = {"blasphemous"},
    continue = "",
    color = "red",
    
    curse = "user",
    buff = "target",
    cursePrefix = "evil",  -- defaults to "self" (e.g. "self-burning")
    
    R = U,
    
    getTime = function() return 2 end,
    getValue = function(lvl)
        return spawn[lvl] or 10
    end,
    
    activateChance = function(lvl)
        return 100+lvl*5
    end,
    
    once = function(self, user, value)
        user.blasphemous = user.blasphemous+1
    end,
    
    action = function(self, user, v)
        if self.ready and not self.done and self.turn ~= user.room.currentTurn then
            if self.light then
                user.room:removeLight(self.light)
            end
            
    
            attacks.divineBlast(user, value, self.ready, self)
            
            if user.blasphemous > 0 then
                user.blasphemous = user.blasphemous - 1
            end
            
            self.done = 1
        else
            user:addLog("A greater @ &colors.red wrath ~ is envoked...")--Evil power has envoked the wrath of &colors.purple @Fishsticks...","crimson")
            user.room.camera:shake(10,4,10)
            user.room:addLight(user.tile, 3, "lime", 2.55)
            self.ready = user.tile or user
            if user.tile then
                self.light = user.room:addLight(user.tile, 3, "red")
            end
            -- don't blast on the same turn
            self.turn = user.room.currentTurn
            
        end
    end
    
}
        
    

cr.shock = {
    name = "shocking",
    prefix = {"elecrocuting"},
    continue = "shocking",
    verb = "electrocuted",
    color = "cyan",
    
    rarity = R,
    
    curse = "user",
    buff = "target",
    
    getTime = function(lvl)
        return 1
    end,
    
    getValue = getEffectValue,
    activateChance = function(lvl)
       return 10+(10*lvl)
    end,
    
    once = function(self, user, value)
        local t = user.tile
        self.l = user.room:addLight(user.tile, mRange, self.color or "yellow", .3)
        
        
        for x = 1, 4 do
            local ox, oy = user.offset_x*0,-th-- math.abs(user.offset_y)
            local xx, yy = math.random(user.x, user.x+user.w)+ox, math.random(user.y, user.y+user.h/nn)+oy
            local gx, gy = math.random(user.x, user.x+user.w)+ox, math.random(user.y, user.y+user.h/nn)+oy

            local l = Lightning:new({
                x = xx, y = yy,
                gx = gx, gy = gy,
                color = self.color,
                life = .3*(x/2)
            })
        end
        
        
        user:getAttacked(self, value)
        if math.random(100)<(500*value) and not user.dying then
            user:applyBuff("paralyse",1,math.floor(value/2)+1)
        end
    end,
    
    
    action = function(self, user, val)
        
    end,
    
    kill = function(self, user)
        if self.l then
            user.room:removeLight(self.l)
        end
    end,
}

cr.knockback = {
    name = "force",
    prefix = {"impactful"},
    continue = "knocked back",
    verb = "knockbacked",
    color = "lightblue",
    curseName = "recoil",
    
    rarity = R,
    
    curse = "user",
    buff = "target",
    
    getTime = function(lvl)
        return 1
    end,
    
    getValue = function(lvl)
        return lvl*lvl
    end,
    
    activateChance = function(lvl)
       return 100+(10*lvl)
    end,
    
    once = function(self, user, value)
        local t = user.tile
        if user.attackerE or user.attacking then
            local a = user.attackerE or user.attacking
            
            local dx = user:getDir(user.x-(a.x or user.x))
            local dy = user:getDir(user.y-(a.y or user.y-1))
            
            assert(dx~=0 or dy~=0) user.name_tag = dx..","..dy.."!!!"
            user:knockback(dx, dy, value)
        else
            error()
        end
    end,
}

cr.burn = {
    name = "burning",
    prefix = {"scorching","flaming"},
    continue = "burning",
    verb = "burnt",
    source = "flame.png",
    color = "orange",
    
    curse = "user",
    buff = "target",
    level = 2,
    
    rarity = C,
    
    getTime = function(lvl)
        return 3*lvl
    end,
    
    getValue = getEffectValue,
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user)
        local t = user.tile
        self. l = user.room:addLight(user.tile, mRange, self.color or "orange")
        user.onFire = true
        user:play_sound("catch_fire")
    end,
    
    
    action = function(self, user, val)
        if self.applied then
        end
        log("burn!")
        
        if not user.tile then
            return
        end
        log("burrrrrn")
        user:play_sound("catch_fire")
        
        local l = user.tile:isFlammable()
        if l and user.tile.fires<1 then
                Fire:new({
                    source = user.tile,
                    intensity = 1,
                })
            
        end
        
        if self.l then
            user.room:removeLight(self.l)
        end
        
        self.l = user.room:addLight(user.tile, mRange, self.color or "orange")
        
        --local obj = Effect({w=tw,h=th,parent=user,source="effects/fire.png",next=true})
        local fl = user.flashColor
        user.flashColor = "orange"
        self.isFire = true
        self.isBurn = true
        user.onFire = 3
        self.deathText = "%s burned to death"
        
        if user.playBurn then
            user:playBurn()
        end
        --takeDamage(attacker, att, fast, noDodge, fake, noDefend, attackVerb)
        user:takeDamage(self, 1, nil, true, nil, true, "burnt")--val)--+3*self.enchants)
        
        user.flashColor = nil---!???!???!
        
    end,
    
    kill = function(self, user)
        if self.l then
            user.onFire = false
            user.room:removeLight(self.l)
        end
        --user.onFire = false
    end,
    
    draw = function(self, user)
        if not user.tile or user.tile.drawID == user.room.drawID then
            user:drawBurn(self.times<=1 and .7 or self.times<=3 and .8 or 1)
        end
    end
}

cr.blind = {
    name = "blinding",
    prefix = {"blinding"},
    continue = "blinded",
    verb = "blinded",
    source = "paralyse.png",
    color = "darkgrey",
    text = "%s was blinded!",
    
    level = 2,
    
    rarity = R,
    
    curse = "user",
    buff = "target",
    
    getTime = function(lvl)
        return math.floor(3.5*lvl)
    end,
    
    getValue =  function(lvl)
        return math.floor(3.5*lvl)
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user.blinded = user.blinded + val
        end
    end,
    
    kill = function(self, user)
    end
}

cr.petrify = {
    name = "petrification",
    prefix = {"petrifying"},
    continue = "petrified",
    verb = "petrified",
    source = "paralyse.png",
    color = "peach",
    
    rarity = U,
    
    level = 2,
    
    curse = "user",
    buff = "target",
    
    getTime = function(lvl)
        return math.floor(3.5*lvl)
    end,
    
    getValue =  function(lvl)
        return math.floor(3.5*lvl)
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user.paralyzed = user.paralyzed + val
            user.petrified = user.petrified + val
            user._opshader = user._opshader or user.shader
            user.shader = petrifiedShader
        end
    end,
    
    kill = function(self, user)
        user.shader = user._opshader
        user._opshader = nil
        --user.paralyzed = user.paralyzed - 1
    end
}

cr.paralyse = {
    name = "paralysis",
    prefix = {"paralyzing"},
    continue = "paralyzed",
    verb = "paralyzed",
    source = "paralyse.png",
    color = "peach",
    
    level = 2,
    
    rarity = R,
    
    curse = "user",
    buff = "target",
    
    getTime = function(lvl)
        return 3*lvl
    end,
    
    getValue =  function(lvl)
        return 3*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user.paralyzed = user.paralyzed + val
        end
    end,
    
    kill = function(self, user)
        --user.paralyzed = user.paralyzed - 1
    end
}

cr.confuse = {
    name = "confusion",
    prefix = {"confusing"},
    continue = "confused",
    verb = "confused",
    source = "paralyse.png",
    color = "white",
    
    rarity = C,
    
    curse = "user",
    buff = "target",
    
    level = 1,
    
    getTime = function(lvl)
        return 3*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user.confused = user.confused + val + 1
        end
    end,
    
    kill = function(self, user)
        --user.confused = user.confused - val
    end
}

cr.discord = {
    name = "discord",
    prefix = {"discordant"},
    continue = "discordant",
    verb = "discordant",
    source = "paralyse.png",
    color = "lightpurple",
    
    rarity = R,
    
    curse = "user",
    buff = "target",
    
    level = 1,
    
    getTime = function(lvl)
        return 3*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user.discordant = user.discordant + val + 1
        end
    end,
    
    kill = function(self, user)
        --user.confused = user.confused - val
    end
}

cr.poison = {
    name = "poison",
    prefix = {"poisoning","venomous"},
    continue = "poisoned",--are
    verb = "poisoned",
    source = "paralyse.png",
    color = "green",
    
    rarity = C,
    
    curse = "user",
    buff = "target",
    
    level = 1,
    
    getTime = function(lvl)
        return 3*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user.poisoned = user.poisoned + val + 1
        end
    end,
    
    kill = function(self, user)
        --user.confused = user.confused - val
    end
}


cr.adrenaline = {
    name = "adrenaline",
    prefix = {"adrenaline"},
    continue = "",--are
    verb = "made mighty",
    source = "mighty.png",
    color = "lime",
    text = "%s starts to sweat!",
    
    rarity = R,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            user.might = user.might + 1
            
            user.stats.strength = user.stats.strength+1
            user.stats.speed = user.stats.speed + val
            
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.stats.strength = user.stats.strength - 1
        user.stats.speed = user.stats.speed - self.val
        --user.fatigued = true
        user.might = user.might - 1
        
        user:addLog(string.format("%s feels tired.", user.title))
        local lvl = self.val/2
        local s = buffs.slow
        user:applyBuff("slow", s.getTime(lvl), s.getValue(lvl))
    end
}

cr.kayoteTime = {
    name = "kayote time",
    prefix = {"kayote time"},
    continue = "delayed",--are
    verb = "has kayote time",
    source = "mighty.png",
    color = "lightgreen",
    text = "%s feels like time waits for you!",
    
    rarity = M,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 100--0+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            user.kayoteTime = user.kayoteTime + 1
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.kayoteTime = user.kayoteTime - 1
        user:addLog(string.format("%s feels less kayote like.", user.title))
        user.might = user.might - 1
    end,
    
    apply = function(self, obj)
        obj.kayoteTime = obj.kayoteTime + 1
    end
}

cr.might = {
    name = "might",
    prefix = {"mighty"},
    continue = "mighty",--are
    verb = "made mighty",
    source = "mighty.png",
    color = "lightgreen",
    text = "%s feels mighty!",
    curse = "target",
    buff = "user",
    
    rarity = U,
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            user.might = user.might + 1
            user.stats.strength = user.stats.strength+val
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.stats.strength = user.stats.strength - self.val
        user:addLog(string.format("%s feels less mighty.", user.title))
        user.might = user.might - 1
    end
}

cr.levitate = {
    name = "levitate",
    prefix = {"levitation"},
    continue = "levitating",--are
    verb = "levitating",
    source = "mighty.png",
    color = "lightgreen",
    text = "%s floats into the air!",
    
    rarity = R,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 7*lvl
    end,
    
    getValue =  function(lvl)
        return lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            user.flying = user.flying + 1
            user.stats.agility = user.stats.agility+val
            local om = user.old_f_y
            user.old_f_y = user.old_f_y or user.offset_y
            
            if not om then
                user.room:tween(.6, user, {offset_y = user.old_f_y - th/3}, "in-quad")
            end
            
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.stats.agility = user.stats.agility - self.val
        user.flying = user.flying - 1
        
        if user.flying <= 0 then
            user:addLog(string.format("%s is no longer levitating.", user.title))
            user.room:tween(.2,user,{offset_y = user.old_f_y},"out-quad")
        else
            user:addLog(string.format("%s feels less floaty.", user.title))
        end
    end,
    
    draw = function(self, user)
        self.ttime = (self.ttime or 0) + user.room.dt
        if self.ttime > .6 then
            self.ttime = 0
            local h = th/2
            user.y = user.y + h
            user:spawnDebris("white",1/10)
            user.y = user.y - h
        end
    end
            
}

cr.protect = {
    name = "protection",
    prefix = {"protecting"},
    continue = "protected",--are
    verb = "protected",
    source = "mighty.png",
    color = "lightgreen",
    text = "%s is protected from harm!",
    
    rarity = R,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 10*lvl
    end,
    
    getValue =  function(lvl)
        return 10*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if true then-- not self.applied then
            user:shake(15,1.2,15,"Y")
            user.protected = user.protected + val
        end
    end,
    
    kill = function(self, user)
        -- user.stats.strength = user.stats.strength - self.val
        -- user:addLog(string.format("%s feels less mighty.", user.title))
        -- user.might = user.might - 1
    end
}

buffs.slow = {
    name = "slow",
    prefix = {"slowing"},
    continue = "slowed",--are
    verb = "slow",
    source = "mighty.png",
    color = "lightblue",
    text = "%s moves slower!",
    
    rarity = C,
    
    curse = "user",
    buff = "target",
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            user.speedy = user.speedy - 1
            
            if user.stats.speed < val then
                val = user.stats.speed/2
            end
            
            user.stats.speed = user.stats.speed-val
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.stats.speed = user.stats.speed + self.val
        user:addLog(string.format("%s speeds up a little.", user.title))
        user.speedy = user.speedy + 1
    end
}

cr.haste = {
    name = "haste",
    prefix = {"hasting"},
    continue = "hasty",--are
    verb = "fast",
    source = "mighty.png",
    color = "lightorange",
    text = "%s moves quicker!",
    
    rarity = R,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            user.speedy = user.speedy + 1
            user.stats.speed= user.stats.speed+val
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.stats.speed = user.stats.speed - self.val
        user:addLog(string.format("%s slows down.", user.title))
        user.speedy = user.speedy - 1
    end
}

cr.sight = {
    name = "extra-sight",
    prefix = {"seeing"},
    continue = "hasty",--are
    verb = "fast",
    source = "mighty.png",
    color = "orange",
    text = "%s sees better!",
    
    rarity = R,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            user:shake(15,1.2,15,"Y")
            --user.speedy = user.speedy + 1
            user.sight= user.sight+val
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.sight = user.sight - self.val
        user:addLog(string.format("%s sees less.", user.title))
        -- user.speedy = user.speedy - 1
    end
}

cr.light = {
    name = "light",
    prefix = {"lighting","illuminating"},
    continue = "illuminated",--are
    verb = "fast",
    source = "mighty.png",
    color = "cyan",
    text = "%s is illuminated!",
    
    rarity = R,
    
    curse = "target",
    buff = "user",
    
    level = 1,
    
    getTime = function(lvl)
        return 5*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            local oc = "white"
            if user.light then
                user._oldLight = user._oldLight or user.light
                oc = user.light[2] or oc
            end
            
            if user.lightData then
                user.room:removeLight(user.lightData)
            end
            
            user.light = {val, multiply(lume.copy(getColor("cyan")), getColor(oc))}
            local l = user.light
            user.lightData = user.room:addLight(user.tile, l[1], l[2])
            
            self.val = val
        end
    end,
    
    kill = function(self, user)
        user.sight = user.sight - self.val
        user:addLog(string.format("%s is less illuminated.", user.title))
        
        user.light = user._oldLight
        user._oldLight = nil
        user.room:removeLight(user.lightData)
        
        if user.light then
            local l = user.light
            user.lightData = user.room:addLight(user.tile, l[1], l[2])
        end
        
        
        -- user.speedy = user.speedy - 1
    end
}

cr.invisible = {
    name = "invisible",
    prefix = {"vanishing"},
    continue = "invisible",--are
    verb = "made invisible",
    source = "paralyse.png",
    color = "white",
    
    rarity = U,
    
    curse = "target",
    buff = "user",
    text = "%s fades away!",
    
    level = 1,
    
    getTime = function(lvl)
        return 7*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        if not self.applied then
            --user.stealth = 0--user.poisoned + val + 1
            user.invisible = user.invisible + 1
        end
    end,
    
    kill = function(self, user)
        user.invisible = user.invisible - 1
    end
}

cr.frightful = {
    name = "frightful",
    continue = "frightful",
    verb = "frightful",
    
    buff = "target",
    
    rarity = R,
    noCurse = true,
    
    level = 2,
    
    getTime = function(lvl)
        return 7*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        self.vv = val
        user.scariness = user.scariness + val + 12
        if user.tile then
            local l = user.room:addLight(user.tile, 2, "maroon",.9)
        end
    end,
    
    kill = function(self, user, val)
        user.scariness = user.scariness - (self.vv or val) - 12
    end
}

cr.fear = {
    name = "fear",
    continue = "fearful",
    verb = "fearful",
    
    rarity = U,
    
    buff = "target",
    noCurse = true,
    
    level = 2,
    
    
    getTime = function(lvl)
        return 7*lvl
    end,
    
    getValue =  function(lvl)
        return 2*lvl
    end,
    
    activateChance = function(lvl)
        return 10+(activateNumber*lvl)
    end,
    
    once = function(self, user, val)
        self.vv = val
        user.cowardice = user.cowardice + val + 12
        if user.tile then
            local l = user.room:addLight(user.tile, 2, "maroon",.9)
        end
    end,
    
    kill = function(self, user, val)
        user.cowardice = user.cowardice + (self.vv or val) + 12
    end
}
    
cr.invincible = {
    name = "invincibility",
    continue = "invincibile",
    verb = "made invincible",
    source = "invincible.png",
    
    once = function(self, user)
        user.invincible = user.invincible + val
    end,
    
    kill = function(self, user)
        user.invincible = user.invincible - val
    end
}

cr.hasIte = {
    name = "haste",
    continue = "hastened",
    verb = "hastened",
    source = "haste.png",
    info = "boosts speed",
    
    level = 2,
    
    once = function(self, user, val)
        user:boostSpeed(val+enc*self.enchants)
    end,
    
    kill = function(self, user, val)
        user:boostSpeed(-(val+enc*self.enchants))
    end
}

cr.toxic = {
    name = "toxicity",
    continue = "toxic",
    verb = "made toxic",
    source = "toxic.png",
    info = "makes attackers weaker",
    
    once = function(self, user, val)
        user.toxicity = user.toxicity + val + enc*self.enchants
    end,
    
    kill = function(self, user, val)
        user.toxicity = user.toxicity - val - enc*self.enchants
    end
}


function cryNoAmmo(user)
    user:cry("No ammo!")
end

guns = {}
guns.shotgun = {
    source = "guns/shotgun.png",
    name = "shotgun",
    
    flip = true,
    bullet = "shell",
    shootAmount = {5,8},
    shootAngle ={15,5,13,10},--10
    range = 5,
    getAngle = function(ang, bul)
        local a = math.deg(ang)
        a = a--+getValue({-25,25,25,-25})
        return math.rad(a)
    end,
    on_shoot = function(self, parent, b)
        b.ac = (b.ac*1.5)/getValue({3,2,1.5,2.4,4,5})
    end,
    
    max_shots = 4,
    cooldown = 1,
    accuracy = .8,
    
    space = 5,
    attack = 4,
    isShooter = true,
    useText = "shoot",
    
    onUse = function(self, user)
        if self:hasAmmo(user) then
            user.room.selectingTarget = true
            user.room.throwing = self
            user.room.onTarget = self.onTarget
        else
            cryNoAmmo(user)
        end
        return true
    end,
    
    onTarget = function(item, user, target)
        attacks.shoot(item, user, target, true)
        
        -- knockback from gun
        user.room:moveObject(user, getDir(user.x-target.x), getDir(user.y-target.y), .2)
    end,
    
    ammo = {
        bullets = 3
    }
}

guns.shotgun = {
    source = "warcrawl/weapons/shotgun.png",
    name = "shotgun",
    
    flip = true,
    bullet = "shell",
    shootAmount = {3,4},
    range = 3,
    getAngle = function(ang, bul)
        local a = math.deg(ang)
        a = a--+getValue({-25,25,25,-25})
        return math.rad(a)
    end,
    on_shoot = function(self, parent, b)
        --b.ac = (b.ac*1.5)/getValue({3,2,1.5,2.4,4,5})
    end,
    
    max_shots = 4,
    cooldown = 1,
    accuracy = .8,
    
    space = 5,
    attack = 4,
    isShooter = true,
    useText = "shoot",
    
    onUse = function(self, user)
        if self:hasAmmo(user) then
            user.room.selectingTarget = true
            user.room.throwing = self
            user.room.onTarget = self.onTarget
        else
            cryNoAmmo(user)
        end
        return true
    end,
    
    onTarget = function(item, user, target)
        attacks.shoot(item, user, target, true)
        
        -- knockback from gun
        user:knockback(getDir(user.x-target.x), getDir(user.y-target.y))
    end,
    
    ammo = {
        shells = 3
    }
}

guns.pistol = {
    source = "warcrawl/weapons/pistol.png",
    name = "pistol",
    
    flip = true,
    bullet = "red_bullet",
    shootAmount = 1,
    range = 5,
    getAngle = function(ang, bul)
        local a = math.deg(ang)
        a = a--+getValue({-25,25,25,-25})
        return math.rad(a)
    end,
    on_shoot = function(self, parent, b)
        --b.ac = (b.ac*1.5)/getValue({3,2,1.5,2.4,4,5})
    end,
    
    max_shots = 4,
    cooldown = 1,
    accuracy = .8,
    
    space = 5,
    attack = 4,
    isShooter = true,
    useText = "shoot",
    
    onUse = function(self, user)
        if self:hasAmmo(user) then
            user.room.selectingTarget = true
            user.room.throwing = self
            user.room.onTarget = self.onTarget
        end
        return true
    end,
    
    onTarget = function(item, user, target)
        attacks.shoot(item, user, target, true)
        
        -- knockback from gun
        -- user.room:moveObject(user, getDir(user.x-target.x), getDir(user.y-target.y), .2)
    end,
    
    ammo = {
        bullets = 3
    }
}

guns.nuke_launcher = {
    source = "warcrawl/weapons/nukelauncher.png",
    name = "nuke launcher",
    
    flip = true,
    bullet = "missile",
    shootAmount = 1,
    range = 5,
    getAngle = function(ang, bul)
        local a = math.deg(ang)
        a = a--+getValue({-25,25,25,-25})
        return math.rad(a)
    end,
    on_shoot = function(self, parent, b)
        --b.ac = (b.ac*1.5)/getValue({3,2,1.5,2.4,4,5})
    end,
    
    max_shots = 4,
    cooldown = 1,
    accuracy = .8,
    
    space = 5,
    attack = 4,
    isShooter = true,
    useText = "shoot",
    
    onUse = function(self, user)
        if self:hasAmmo(user) then
            user.room.selectingTarget = true
            user.room.throwing = self
            user.room.onTarget = self.onTarget
        end
        return true
    end,
    
    onTarget = function(item, user, target)
        attacks.shoot(item, user, target, true)
        user:knockback(getDir(user.x-target.x), getDir(user.y-target.y),2)
        
        -- knockback from gun
        -- user.room:moveObject(user, getDir(user.x-target.x), getDir(user.y-target.y), .2)
    end,
    
    ammo = {
        explosives = 3
    }
}
bullets = {}

bullets.blob = {
    anim = "bullets/blob",
    ac = 40,
    size = 90/200*Room.t,
    delay = 1,
    life = 3,
}

bullets.orb = {
    anim = "bullets/orb",
    ac = 60,
    size = 80/200*Room.t,
    delay = 1,
    life = 3,
}

bullets.red_orb = {
    anim = "bullets/orb",
    ac = 160,
    size = 80/200*Room.t,
    delay = 1,
    life = 3,
    color = "red",
    att = 2
}

bullets.red_bullet = {
    anim = "bullets/red_bullet",
    frameDelay = .05,
    ac = 200,
    delay = .4,
    life = 1,
    size = 90/200*Room.t,
}

bullets.sh = {
    anim = "bullets/orb",
    frameDelay = .05,
    ac = 230,
    delay = .4,
    life = 1,
    size = 90/200*Room.t,
}

bullets.missile = {
    anim = "bullets/missile",
    frameDelay = .05,
    ac = 250,
    startAc = 5,
    buildUp = 0.75,
    delay = .4,
    life = 3,
    size = 90/200*Room.t,
    hits = 1,
    onDestroy = function(self)
        local t = self.room:getTileP(self.x, self.y)
        if t then
            Fire:new({
                source = t,
                explode = true,
                range = 2,
            })
        end
    end
}

bullets.bolt = {
    anim = "bullets/bolt",
    frameDelay = .15,
    ac = 400,
    delay = 1.2,
    hits = 5,
    
    life = 1,
    size = 90/200*Room.t*2
}

--[[
Bounce variables:

    deflection = {0,1},
    attackAllOnBounce = (num)false,
    bounceOffset = 50,
    bounceOn = "isTile",
    maxBounce = (num)-1,
    hitAmount = (num)-1,
    mustBounce = false,
    hitOnBounce = (num)false,
    noCheckBounce = false,
    checkForMaxVelocity = true,
    checkForMinVelocity = false
]]


bullets.tennis_ball = {
    source = "bullets/tennis_ball.png",
    ac = 200,
    hits = 1,
    delay = .4,
    attack = 2,
    size = 90/200*Room.t,
    life = 2,
    va = 450,
    noTrail = true,
    
    deflection = 1.5,
    attackAllOnBounce = 1,
    bounceOffset = 0,
    bounceOn = "isTile",
    maxBounce = 1,
    mustBounce = true,
    noCheckBounce = true,
}

bullets.bouncy_ball = {
    source = "bullets/bouncy_ball.png",
    ac = 200,
    delay = .6,
    hits = 5,
    life = 36,
    attack = 1,
    size = 90/200*Room.t,
    
    deflection = {0,1},
    attackAllOnBounce = 1,
    bounceOffset = 50,
    bounceOn = "isTile",
    hitAmount = 1,
    checkForMinVelocity = true,
    checkForMaxVelocity = false
}

bullets.shell = {
    ac = {250,200,400,300,300},
    source = "bullets/shell.png",
    delay = 1,
    hits = 1,
    life = .9 or .5,
    startAc = 50,
    buildUp = .4,
    attack = 2/10,
    mode = "once",
    --trail = "yellow",
    size = 90/200*Room.t,
    noTrail = true,
    smokeW = tw/3,
    
    deflection = {0,1},
    attackAllOnBounce = false,
    bounceOffset = 50,
    bounceOn = "isEntity",--Tile",
    checkForMinVelocity = true,
    checkForMaxVelocity = true
}

bullets.disc = {
    anim = "bullets/disc",
    ac = 200,
    delay = .6,
    hits = 5,
    life = 36,
    startAc = 50,
    buildUp = .6,
    attack = 1,
    trail = true,
    size = 100/200*Room.t,
    
    deflection = {0,1},
    attackAllOnBounce = 1,
    bounceOffset = 50,
    bounceOn = "isTile",
    hitOnBounce = true,
    checkForMinVelocity = false,
    checkForMaxVelocity = true
}

local v = 2
for x, b in pairs(bullets) do
    if b.ac then
        if type(b.ac) == "table" then
            for xx, bb in ipairs(b.ac) do
                b.ac[xx] = bb*v
            end
        else
            b.ac = b.ac*v
        end
    end
    if b.startAc then
        if type(b.startAc) == "table" then
            for xx, bb in ipairs(b.startAc) do
                b.startAc[xx] = bb*v
            end
        else
            b.startAc = b.startAc*v
        end
    end
end