classes = {}
data.classes = classes
c = classes

c.none = {
    -- skill = table of (str skill or {skill, starting level})
    skills = {},
    evolvesTo = {"scout"},
    isSupportive = false,
    needsSupport = true,
    
    rank = 1,
    apply = function(cr, lvl)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}

c.scout = {
    -- skill = table of (str skill or {skill, starting level})
    skills = {},
    evolvesTo = {"warrior"},
    isSupportive = false,
    needsSupport = true,
    weapon = function(lvl)
        return items.dagger -- weapon data or Item
    end,
    
    rank = 1,
    apply = function(cr, lvl)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}

c.warrior = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {},
    evolvesTo = {"warrior"},
    isSupportive = false,
    needsSupport = false,
    weapon = function(lvl)
        return getWarriorWeapon(lvl)--items.dagger -- weapon data or Item
    end,
    
    rank = 1,
    apply = function(cr, lvl)
        getArmourForCreature(cr, lvl*2)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}

c.bezerker = {
    -- skill = table of (str skill or {skill, starting level, %})
    abilities = {"bezerk"},
    evolvesTo = {"warrior"},
    isSupportive = false,
    needsSupport = false,
    weapon = function(lvl)
        return getWarriorWeapon(lvl)--items.dagger -- weapon data or Item
    end,
    
    rank = 1,
    apply = function(cr, lvl)
        cr.w = cr.w*1.5
        cr.h = cr.h*1.5
        
        cr:set_box()
        cr:center()
 
        if cr.w>tw then
            cr.offset_x = cr.offset_x - (cr.w-tw)/2
        end
    
        cr.offset_y = (0 or cr._og_offset_y or cr.offset_y) - (cr.h*.5-th)
    
        cr.stats.health = cr.stats.health + 2
        cr.maxHealth = cr.maxHealth + 2
        
        -- cr.offset_y = cr._og_offset_y - (cr.h-th)
    end,
    
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}
function nl() self:spawn("goblin",pl.tile):addClass("bezerker") end
c.pyromaniac = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {"bombThrow"},
    evolvesTo = {"warrior"},
    isSupportive = true,
    needsSupport = false,
    
    rank = 1,
    apply = function(cr, lvl)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}

local scrollsToRead = {
    scroll_of_summoning = 5,
    scroll_of_electricity = 1,
    scroll_of_discord = 1,
    scroll_of_vegetation = 2,
    scroll_of_teleportation = 1
}

c.scribe = {
    skills = {"read"},
    helmet = "scribe_hat",
    
    apply = function(cr, lvl)
        if lvl <= 1 then
            cr.cantRead = math.random() > .5
        end
        
        for x = 1, (3*lvl)+3 do
            cr:addItem(lume.weightedchoice(scrollsToRead))
        end
    end
}

c.bomber = {
    rank = 1,
    armour = "bomb_strap",
    
    isSupportive = true,
    needsSupport = false,
    skills = {"blowup"},
    
    apply = function(cr, lv)
        if math.random() > .1 and cr.data.name == "kobold" then
            local sp = cr:add_sprite("creatures/kobold_sad_eyes")
            sp:syncTo(cr.sprite)
        end
    end
}

c.archer = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {"useBow"},
    evolvesTo = {"warrior"},
    isSupportive = true,
    needsSupport = false,
    
    rank = 2,
    apply = function(cr, lvl)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 2,
}

c.archer_hunter = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {"useBow"},
    evolvesTo = {"warrior"},
    isSupportive = true,
    needsSupport = false,
    
    rank = 2,
    apply = function(cr, lvl)
    end,
    
    skinColor = nil,
    clothingColor = nil,
    minLevel = 2,
    helmet = "hunter_hat"
    
}

c.zapper = {
    apply = function(cr, lvl)
        cr.getAttack = function(self, n) return attacks.lightning(self, n) end
        -- cr.closest = 2
        -- cr.furthest = 4
    end,
}

c.gunner = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {"useGun"},
    evolvesTo = {"warrior"},
    isSupportive = true,
    needsSupport = false,
    
    rank = 2,
    apply = function(cr, lvl)
        getArmourForCreature(cr, lvl*2)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 2,
}

c.rockThrower = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {"stoneThrow"},
    evolvesTo = {"pyromaniac"},
    isSupportive = true,
    needsSupport = false,
    
    rank = 1,
    apply = function(cr, lvl)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}

c.conjurer = {
    -- skill = table of (str skill or {skill, starting level, %})
    skills = {"conjure"},
    evolvesTo = {"warrior"},
    isSupportive = true,
    needsSupport = false,
    
    rank = 1,
    apply = function(cr, lvl)
    end,
    skinColor = nil,
    clothingColor = nil,
    minLevel = 1,
}

c.shopkeeper = {
    skills = {"shopkeep"},
    
    apply = function(cr, lvl)
    end
}