local c = {}
creatures = c
data.creatures = c

CLAN_HATRED = -10
GOBLIN_TEXTS = {
    respect = {
        "You well done",
        "@Good",
        "Nice %s",
    },
    respectKill = nil,
    follow = {
        "I follow mighty one",
        "%s strong, %s leader"
    }
}

ORC_TEXTS = {
    respect = {
        "...",
        "Good",
    },
    respectKill = {
        "Very Good",
        "Mighty work!"
    },
    follow = {
        "Mighty %s!!"
    }
}

c.rat = {
    name                   = "rat",
    anim                   = "creatures/rat",
    pitches                = nil,  -- for sound
    
    article               = "the",
    pronoun               = "it",
    pronoun2              = "its",
    
    title                 = nil,   -- default: <article> <name>
    
    team                  = nil,   -- can be function to, like lume.uuid
    
    leaderValue           = 0,     -- or "leaderLevel", howmuch leadership it has, like ranking
    closest               = 0,
    furthest              = 0,
    
    getAttack             = nil,   -- function
    updateTurn            = nil,   -- function
    
    flammability          = 0,
    
    patrolsRoom           = false, -- patrol only one room
    attackRange           = 1,     -- function(self)->number(returns number) or number value
    
    speed                 = 1,
    
    life                  = 2,
    strength              = 1,
    defense               = 0,
    
    maxEnergy             = 10,    --max energy
    energy                = 7,
    nutrition             = 10,
    metabolism            = .2,    -- takes 5 turns to lose 1 nutrition point (1/5)
    eatRate               = .5,    -- how fast to eat, defaults to 1/2
    foodLiking            = 3,     -- how much to like food, defaults to bondingLevel-1 if love food or 3, used to check to disobey leader
    
    cantRead              = nil,   -- if true then ability to read scrolls and other items is removed, can be number (%, e.g. 70 or 90) or {values} for random
    
    lovesFood             = false, -- if true then rush to food always
    
    sleeping              = {true, true, false},
    currentState          = "Sleeping",
    
    nimble                = false, -- can move freely on webs
    
    hearing               = .5,    -- minimum value that can be heard
    maxHearing            = 10,    -- maximum hearing until ... no, No, NOOOO!!
    sight                 = 3,     -- probability to sight other based on stealth
    vision                = 3,     -- how far to really see, set to 1 for blindness kinda
    persistence           = 5,     -- how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility             = 1,     -- 0 - no attack, 1 - only non team when disliked, 2 - player and disliked, 3 - all other except team
    alerter               = 0,     -- alert others of enemy (0- no, 1- when can attack, 2- yes! Yes! YES!)
    
    scariness             = 0,     -- how scary one is, all with cowardice higher than this value flee
    
    liking                = {},    -- table of likes <obj: value>
    fears                 = {},    -- table of fears <obj: value>; runs from all with value lower than cowardice but not <0
    
    bondingLevel          = 10,    -- likeness to reach to assign as leader, 10 default
    furthestFromLeader    = 7,     -- distance to run back to leader
    stealth               = 0,     -- -10 to +10
    dislikeTrigger        = 3,     -- amount of dislike to attack,
    allyLiking            = 2,     -- amount to like to consider as ally,
    
    selfWorth             = 3,     -- liking of own species
    
    playerDislike         = 3,     -- default dislike of player,
    baseDislike           = -2,    -- defaults to -2
    pettiness             = 1,     -- how much hate to carry when wronged
    gratitude             = 1,     -- how much to like someone over a good deed
    
    cowardice             = 1,     -- suggest set to 11 if hostile = 0 (0-10, 10 run from all but friends, %hp to run)
    
    respectKillText       = nil,   -- value of what to say to respect a kill
    respectText           = nil,   -- value of what to say on like/gratitude
    followText            = nil,   -- value of what to say on follow
    texts                 = nil,   -- distribute values to [respectKill, respect, and follow]Text
    
    poweredByMagic        = false, -- whether fully magic powered
    
    group                 = nil,   -- number value or boolean for spawning in a group
    spawn                 = {},    -- weighted table for group
    
    blood                 = nil,   -- debris type to use for blood, set to false for no blood
    bloodColor            = "red", -- color of blood
    noBlood               = nil,   -- whether to not do blood
    
    noBones               = nil,   -- whether to not spawn bones on death
    skullImage            = nil,   -- asset to use for image of skull
    boneImage             = nil,   -- asset to use for image of bones
    isHumanoid            = nil,   -- whether to spawn skull if no skull image set
    
    alpha                 = 1,
    
    food = {
        pig = true,
        meat = true
    },
    
    info                  = "-sewer rat",
    
    loot = {},--???
    light = nil, -- {value/range, color}
    
    canPickItems          = false,
    
    skills = {
        -- name = value level,
        -- bomb = {0,0,1}
    },
    
    abilities = {
        -- name = {level=value, ...}
        -- split = {level={0,0,1}}
    },
    
    inventorySpace = 1,w=tw*.7,h=th*2*.7,
}

c.jackal = {
    name                   = "jackal",
    anim                   = "creatures/jackal",

    updateTurn            = nil,   -- function
    
    speed                 = 2,
    
    life                  = 5,
    strength              = 1,
    defense               = 0,

    lovesFood             = true, -- if true then rush to food always
    
    sleeping              = {true, true, false},
    currentState          = "Sleeping",

    hostility             = 2,     -- 0 - no attack, 1 - only non team when disliked, 2 - player and disliked, 3 - all other except team
    alerter               = 1,     -- alert others of enemy (0- no, 1- when can attack, 2- yes! Yes! YES!)
    allyLiking            = 4,
    
    scariness             = 0.5,     -- how scary one is, all with cowardice higher than this value flee
    
    liking                = {rat=-5},    -- table of likes <obj: value>
    fears                 = {},    -- table of fears <obj: value>; runs from all with value lower than cowardice but not <0
    
    stealth               = 5,     -- -10 to +10
   
    food = {
        pig = true, --boar = true,
        meat = true,
        rat = true
    },
    
    info                  = "A jackal",
    
    -- drop = {},--???
    canPickItems          = false,
    
    abilities = {
        -- name = value level,
        -- bomb = {0,0,1}
    },
    skills = {
        -- name = {level=value, ...}
        -- split = {level={0,0,1}}
        sneakyHunter = {1},
    },
    
    inventorySpace = 1,
}

c.bat = {
    name                   = "bat",
    anim                   = "creatures/bat",

    updateTurn            = nil,   -- function
    
    speed                 = 2,
    
    life                  = 5,
    strength              = 1,
    defense               = 0,

    lovesFood             = false, -- if true then rush to food always
    
    sleeping              = {true, false, false},
    currentState          = "Sleeping",

    hostility             = 2,     -- 0 - no attack, 1 - only non team when disliked, 2 - player and disliked, 3 - all other except team
    alerter               = 1,     -- alert others of enemy (0- no, 1- when can attack, 2- yes! Yes! YES!)
    allyLiking            = 4,
    
    scariness             = 0.5,     -- how scary one is, all with cowardice higher than this value flee
    
    liking                = {},    -- table of likes <obj: value>
    fears                 = {},    -- table of fears <obj: value>; runs from all with value lower than cowardice but not <0
    
    stealth               = 5,     -- -10 to +10
   
    food = {
        pig = true, --boar = true,
        meat = true
    },
    
    info                  = "A jackal",
    
    -- drop = {},--???
    canPickItems          = false,
    
    abilities = {
        -- name = value level,
        float = {steady=false}
    },
    skills = {
        -- name = {level=value, ...}
        -- split = {level={0,0,1}}
        -- sneakyHunter = {1},
    },
    
    inventorySpace = 1,
}

c.worm = {
    name = "meat maggot",
    anim = "creatures/worm",
    life = {1,3},
    food = {
        meat = true,
        rotten_meat = true,
        isFood = true,
    },
    
    team = "worm",
    
    hostility = 3,
    lovesFood = true,
    spawn = {
        worm = 1
    },
    immuneTo = {gas=true},
    
    postMake = function(self)
        self.team = "worm"
    end
}


c.skeleton = {
    name = "skeleton",
    anim = "creatures/skeleton",
    cowardice = 0,
    life = {30,50},
    noBlood = true,
    abilities = {
        revive = {
            object = "skull"
        }
    },
    isLiving = false,
    hostility = 2,
}

c.skull = {
    name = "skull",
    source = "items/skull.png",
    thoughtless = true, w = tw, h=th,
    isLiving = false,
    -- blood:bones
    updateTurn = function(self)
        self.toRevive = (self.toRevive or 3)-1
        
        if self.toRevive <= 0 then
            self:die(nil, nil, true)
            self.parent.stats.health = self.parent.maxHealth
            self.parent:add_to_room(self.room,self.x,self.y)
            self.room:spawn(self.parent, self.tile, self.team)
            self.room:playNextCreature()
        end
        
    end,
}

c.angel = {
    name = "angel",
    anim = {"creatures/angel_yellow","creatures/angel"},
    
    w = tw*1.3,
    h = th*2*1.3,
    
    isLiving = false,
    light = {10, "white"},
    cowardice = 0,
    life = {30,50},
    noBlood = true,
    _abilities = {
        revive = {
            object = "skull"
        }
    },
    hostility = 2,
    skills = {divinity=1},
    -- blood:bones
    updateTurn = function(self)
        
    end,
    
    immuneTo = {
        burn = true
    }
}

c.lich = {
    name = "Lich",
    anim = "creatures/lich",
    
    w = tw*1.5,
    h = th*2*1.5,
    
    isLiving = false,
    light = {10, "lime"},
    cowardice = 0,
    life = {30,50},
    noBlood = true,
    abilities = {
        revive = {
            object = "skull"
        }
    },
    hostility = 2,
    skills = {divinity=1},
    -- blood:bones
    updateTurn = function(self)
        
    end,
    
    immuneTo = {
        burn = true
    }
}


local function E_playTurn(self)
    local en = self:getEnemies()
    if #en > 0 then
        self:getAttack(getValue(en))
    else
        self.done = true
    end
end

c.cursed_flower = {
    name = "cursed flower",
    anim = "creatures/cursed_flower",
    immobile = true,
    hostility = 3,
    team = "curse",
    life = 10,
    sight = 4,
    speed = 1,
    w = tw*2,
    h = th*2,
    
    skills = {divinity=1},
}


c.large_gelatinous_cube = {
    name = "Large Gelatinous Cube",
    anim = "creatures/gelatinous_cube",
    hostility = 3,
    life = 10,
    speed = .5,
    movementType = "slide",
    w = tw*2,
    h = th*2*2,
    
    abilities = {suffocate={}},
    
    postMake = function(self)
        self.offset_y = self.offset_y + 10
    end
}

c.gelatinous_cube = {
    name = "Gelatinous Cube",
    anim = "creatures/gelatinous_cube",
    hostility = 3,
    life = 10,
    speed = .5,
    movementType = "slide",
    w = tw*1.5,
    h = th*2*1.5,
    
    abilities = {suffocate={}},
    
    postMake = function(self)
        self.offset_y = self.offset_y + 10
    end
}

c.g2 = {
    name = "Gelatinous Cube",
    anim = "creatures/gelatinous_cube",
    hostility = 3,
    life = 10,
    speed = .5,
    movementType = "slide",
    
    abilities = {suffocate={}},
    
    postMake = function(self)
        self.offset_y = self.offset_y + 10
    end
}

gcube = function(g)
    toybox.room:spawn(g and "g2" or "gelatinous_cube", pl.tile)
end

c.beholder = {
    name = "beholder",
    anim = "creatures/beholder",
    
    w = tw,
    h = th*2,
    
  
    cowardice = 0,
    life = {30,50},

    _abilities = {
        revive = {
            object = "skull"
        }
    },
    
    hostility = 2,
    skills = {divinity=1},
    -- blood:bones
    updateTurn = function(self)
        
    end,
    
    immuneTo = {
        burn = true
    }
}

stat=function(class) class=class or class ~= false and "warrior" local i = self:spawn("battle_statue",pl.tile) if class then i:addClass(class) end return i end

c.battle_statue = {
    abilities = {float={}},
    name = "battle statue",
    anim = "creatures/battle_statue",
    poweredByMagic = true,

    immobile = true,
    thoughtless = true,
    
    isLiving = false,
    
    life = 20,
    sight = 10,
    speed = .7,
    
    w = tw*1,1*2, h=th*2*1,1*2,
    
    attackRange = 1,--10,
    noBlood = true,
    hostility = 3,
    
    postMake = function(self)
      self.team = self.id
      -- self.playTurn = E_playTurn
      self.ogDelay = self.sprite and self.sprite:getDelay()
      if self.sprite then self.sprite:setDelay(100) end
      self:onDamaged(function(data, self)
          assert(self.isCreature)
          if not self.activated then
              self.immobile = nil
              self.thoughtless = nil
              self.activated = true
              self.room:addEnchantLight(self.tile, 8, "cyan")
              self:addLog(string.format("%s rumbles",self.title))
              self:shake(10,2,10)
              
              if self.sprite then
                  self.sprite:setDelay(self.ogDelay)
              end
          end
      end)
              
        --self:onEvent("StartTurn",function() self:applyBuff("shock",10,2) end)
    end,
    
    updateTurn = function(self, time)
        
    end,
}

c.electric_ball = {
    abilities = {float={}},
    name = "electric ball",
    anim = "creatures/electric_ball",
    thoughtless = false,
    poweredByMagic = true,
    immobile = true,
    isLiving = false,
    life = 10,
    sight = 10,
    speed = 3,
    w = tw*1.6, h=th*2*1.6,
    light = {5, "cyan"},
    attackRange = 10,
    noBlood = true,
    hostility = 3,
    getAttack = function(self, obj)
        return attacks.lightning(
            self,
            obj,
            1, 
            self.onFire and "orange" or self.lightningColors or self.lightningColor or "cyan", 
            self.onFire
        )
    end,
    
    postMake = function(self)
      self.playTurn = E_playTurn
      self.timer:every(.1,function()
        self.tile = self.room:getTileP(self.x, self.y)
        local user = self
        for x = 1, 4 do
            local ox, oy = user.offset_x*0+tw/4,-th+th/2-- math.abs(user.offset_y)
            local xx, yy = math.random(user.x, user.x+user.w)-ox, math.random(user.y, user.y+th)+oy
            local gx, gy = math.random(user.x, user.x+user.w)-ox, math.random(user.y, user.y+th)+oy
            local nn = 5

            local l = Lightning:new({
                x = xx, y = yy-nn,
                gx = gx, gy = gy+nn,
                color = getValue(self.lightningColors or math.random()>.5 and "blue" or "white"),
                life = .3*(x/2),
                alpha = (self.sprite or self).image_alpha
            })
        end
        end)
        --self:onEvent("StartTurn",function() self:applyBuff("shock",10,2) end)
    end,
    
    updateTurn = function(self, time)
        local time = 1/2
        self.maxHealth = lume.max(self.maxHealth, self.stats.health)
        self.stats.health = self.stats.health - 1*time
        
        local s = self.sprite or self
        s.image_alpha = .2+self.stats.health/self.maxHealth
        
        if self.stats.health <= 0 then
            self:die(self,1)
        end
        
    end,
}

c.bloat = {
    name = "bloat",
    anim = "creatures/bloat",
    cowardice = 0,
    life = 2,
    
    onDeath = function(self)
        Gas:new({
                    tile=self.tile or error("no tile for gas on death"),
                    intensity = 7,
                    flammability = 2,
                    color = gasColors.poison,
                    range = 3,
                    lifeBonus = -3
                })
    end,
    
    abilities = {float={}}
                
}


local purplish = {.7,.4,.7}--colors.pink


c.spectral_blade = {
    life = 2,
    name = "spectral blade",
    anim = "creatures/spectral_blade",
    shadow = "creatures/spectral_blade_shadow",
    group = {3,4},
    hostility = 2,
    cowardice = 0,
    poweredByMagic = true,
    isLiving = false,
    light = {2,purplish},
    abilities = {float={steady=true}}
}


c.wisp = {
    life = 2,
    name = "wisp",
    anim = "creatures/wisp",
    shadow = "creatures/spectral_blade_shadow",
    --group = {3,4},
    hostility = 2,
    cowardice = 0,
    poweredByMagic = true,
    isLiving = false,
    
    abilities = {float={steady=false},burn={intensity=1}}
}

c.spectral_scythe = {
    life = 2,
    name = "spectral scythe",
    
    anims = {
               {
                    name = "idle",
                    source = "creatures/scythe",
                    useImages = true,
                    delay = .15,
                    mode = "loop"
                },
                {
                    name = "attack",
                    source = "creatures/scythe_slice",
                    useImages = true,
                    delay = .15,
                    mode = "once",
                    onAnimEnd = function(s)
                        s:switch("idle")
                    end
                }
            },
    
    w = tw*1.6,
    attackAnim = "attack",
    attackDelay = .2,
    
    shadow = "creatures/spectral_blade_shadow",
    group = {3,4},
    hostility = 2,
    cowardice = 0,
    poweredByMagic = true,
    isLiving = false,
    light = {2,purplish},
    
    abilities = {float={steady=true}}
}

c.raty = {
    name = "rat",
    anim = "creatures/rat"
}

c.monkey = {
    name = "monkey",
    anim = "creatures/monkey",--w=th*2,h=th*2,
    
    wieldY = tw/5,
    
    leaderValue = 0,
    closest = 0,
    furthest = 0,
    
    getAttack = nil,
    speed = 1,
    
    life = 4,
    strength = 1,
    defense = 0,
    
    maxEnergy = 10, --max energy
    energy = 7,
    nutrition = 3,
    
    sleeping = {true, true, false},
    
    sight = 5, -- probability to sight other based on stealth
    vision = 5,
    persistence = 5,--how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility = 2, -- 0 - no attack, 1 - only when disliked, 2 - player and disliked, 3 - all other except team
    
    bondingLevel = 10, -- likeness to reach to assign as leader, 100p default
    furthestFromLeader = 7, -- distance to run back to leadee
    stealth = 3, -- -10 to +10
    --dislikeTrigger = 3, -- amount of dislike to attack,
    pettiness = 1,
    gratitude = 2,
    eatRate = 1/2,
    
    -- playerDislike = 0, -- default dislike of player,
    lovesFood = true,
    
    cowardice = 1, -- (0-10, 10 run from all but friends, %hp to run)
    
    spawn = {},
    
    alpha = 1,
    bondingLevel = 1,
    
    food = {
        carrot = true,
        meat = true
    },
    
    info = "-sewer rat",
    
    loot = {},--???
    canPickItems = false,
    furthestFromLeader = 4,
    
    --nimble= true,
    
    inventorySpace = 1,
    drop = {
        --null = {1},
        meat = {30, {1,1,1,1,0,0},"meat"},
        --or
        --drop1 = {weight, {"meat","meat","carrot"}},
        
    },
    
    abilities = {
        thief = {},
        adrenaline = {health = 30}
    }
}

c.pig = {
    name = "pig",
    anim = "creatures/pig",--w=th*2,h=th*2,
    
    leaderValue = 0,
    closest = 0,
    furthest = 0,
    
    getAttack = nil,
    
    attackRaynge = function(self, t)
        if not t.tile.web and t.tile:isWebbable() then
            return 7
        else
            return 1
        end
    end,
    
    getAt4tack = function(self, t)
        if not t.tile.web and t.tile:isWebbable() then
            attacks.shootWebs(self, t)
        else
            return false
        end
    end,
    
    speed = 1,
    
    life = 4,
    strength = 1,
    defense = 0,
    
    maxEnergy = 10, --max energy
    energy = 7,
    nutrition = 3,
    
    sleeping = {true, true, false},
    
    sight = 5, -- probability to sight other based on stealth
    vision = 5,
    persistence = 5,--how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility = 0, -- 0 - no attack, 1 - only when disliked, 2 - player and disliked, 3 - all other except team
    
    bondingLevel = 10, -- likeness to reach to assign as leader, 100p default
    furthestFromLeader = 7, -- distance to run back to leadee
    stealth = 0, -- -10 to +10
    dislikeTrigger = 3, -- amount of dislike to attack,
    pettiness = 0,
    gratitude = 2,
    eatRate = 1/2,
    
    playerDislike = 0, -- default dislike of player,
    lovesFood = true,
    
    cowardice = 1, -- (0-10, 10 run from all but friends, %hp to run)
    
    spawn = {},
    
    alpha = 1,
    bondingLevel = 1,
    
    food = {
        carrot = true,
        meat = true
    },
    
    info = "-sewer rat",
    
    loot = {},--???
    canPickItems = false,
    furthestFromLeader = 4,
    
    --nimble= true,
    
    inventorySpace = 2,
    drop = {
        --null = {1},
        meat = {30, {1,1,1,1,0,0},"meat"},
        --or
        --drop1 = {weight, {"meat","meat","carrot"}},
        
    }
}

c.boar = {
    name = "boar",
    anim = "creatures/boar",--w=th*2,h=th*2,
    w = tw*1.6,
    
    leaderValue = 2,
    closest = 0,
    furthest = 0,
    
    --getAttack = nil,
    
    attackRange = 1,
    
    speed = 1,
    
    life = 7,
    strength = 3,
    defense = 0,
    
    maxEnergy = 10, --max energy
    energy = 7,
    nutrition = 3,
    
    sleeping = {true, true, false},
    
    sight = 5, -- probability to sight other based on stealth
    vision = 5,
    persistence = 5,--how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility = 2, -- 0 - no attack, 1 - only when disliked, 2 - player and disliked, 3 - all other except team
    
    bondingLevel = 10, -- likeness to reach to assign as leader, 100p default
    furthestFromLeader = 7, -- distance to run back to leadee
    stealth = 0, -- -10 to +10
    dislikeTrigger = 3, -- amount of dislike to attack,
    pettiness = 2,
    gratitude = 2,
    eatRate = 1/2,
    
    playerDislike = 0, -- default dislike of player,
    lovesFood = true,
    
    cowardice = -1, -- (0-10, 10 run from all but friends, %hp to run)
    
    spawn = {},
    
    alpha = 1,
    bondingLevel = 1,
    
    food = {
        carrot = true,
        meat = true
    },
    
    info = "-sewer rat",
    
    loot = {},--???
    canPickItems = false,
    furthestFromLeader = 3,
    
    inventorySpace = 1,
    drop = {
        --null = {1},
        meat = {30, {1},"meat"},
        --or
        --drop1 = {weight, {"meat","meat","carrot"}},
        
    },
    
    abilities = {
        -- name = {level=value, ...}
        bezerk = {level={1}}
    }
}

local function rhino_playTurn(self)
    self.dir = self.dir or getValue(dirs4)
    
    local moved = self.room:moveObject(self, self.dir[1], self.dir[2])
    if not moved then
        local dir = self.dir
        while dir == self.dir do
            self.dir = getValue(dirs4)
        end
    end
end

c.rhino_beetle = {
    name = "rhino beetle",
    anim = "creatures/rhino_beetle",--w=th*2,h=th*2,

    closest = 0,
    furthest = 0,
    
    --getAttack = nil,
    
    attackRange = 1,
    
    
    speed = 1,
    
    life = 7,
    strength = 3,
    defense = 0,
    
    maxEnergy = 10, --max energy
    energy = 7,
    nutrition = 3,
    
    sleeping = false,--{true, true, false},
    
    sight = 5, -- probability to sight other based on stealth
    vision = 5,
    persistence = 5,--how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility = 2, -- 0 - no attack, 1 - only when disliked, 2 - player and disliked, 3 - all other except team
    
    bondingLevel = 10, -- likeness to reach to assign as leader, 100p default
    furthestFromLeader = 7, -- distance to run back to leadee
    stealth = 0, -- -10 to +10
    dislikeTrigger = 3, -- amount of dislike to attack,
    pettiness = 2,
    gratitude = 2,
    eatRate = 1/2,
    
    playerDislike = 0, -- default dislike of player,
    lovesFood = true,
    
    cowardice = -1, -- (0-10, 10 run from all but friends, %hp to run)
    
    spawn = {},
    
    alpha = 1,
    bondingLevel = 1,
    
    food = {
        carrot = true,
        meat = true
    },
    
    info = "-sewer rat",
    
    loot = {},--???
    canPickItems = false,
    furthestFromLeader = 3,
    
    inventorySpace = 1,
    drop = {
        --null = {1},
        meat = {30, {1},"meat"},
        --or
        --drop1 = {weight, {"meat","meat","carrot"}},
        
    },
    
    abilities = {
        -- name = {level=value, ...}
        bezerk = {level={1}}
    },
    
    
    postMake = function(self)
        self.playTurn = rhino_playTurn
    end,
}

c.snail = {
    name = "rhino beetle",
    anim = "creatures/rhino_beetle",--w=th*2,h=th*2,

    closest = 0,
    furthest = 0,
    
    --getAttack = nil,
    
    attackRange = 1,
    
    
    speed = 1,
    
    life = 7,
    strength = 3,
    defense = 0,
    
    maxEnergy = 10, --max energy
    energy = 7,
    nutrition = 3,
    
    sleeping = false,--{true, true, false},
    
    sight = 5, -- probability to sight other based on stealth
    vision = 5,
    persistence = 5,--how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility = 2, -- 0 - no attack, 1 - only when disliked, 2 - player and disliked, 3 - all other except team
    
    bondingLevel = 10, -- likeness to reach to assign as leader, 100p default
    furthestFromLeader = 7, -- distance to run back to leadee
    stealth = 0, -- -10 to +10
    dislikeTrigger = 3, -- amount of dislike to attack,
    pettiness = 2,
    gratitude = 2,
    eatRate = 1/2,
    
    playerDislike = 0, -- default dislike of player,
    lovesFood = true,
    
    cowardice = -1, -- (0-10, 10 run from all but friends, %hp to run)
    
    spawn = {},
    
    alpha = 1,
    bondingLevel = 1,
    
    food = {
        carrot = true,
        meat = true
    },
    
    info = "-sewer rat",
    
    loot = {},--???
    canPickItems = false,
    furthestFromLeader = 3,
    
    inventorySpace = 1,
    drop = {
        --null = {1},
        meat = {30, {1},"meat"},
        --or
        --drop1 = {weight, {"meat","meat","carrot"}},
        
    },
    
    abilities = {
        -- name = {level=value, ...}
        bezerk = {level={1}}
    },
    
    
    postMake = function(self)
        self.playTurn = rhino_playTurn
    end,
}

c.giant_snail = {
    name = "giant snail",
    anim = "creatures/giant_snail",

    closest = 0,
    furthest = 0,
    
    --getAttack = nil,
    
    attackRange = 1,
    
    
    speed = .5,
    
    life = 16,
    strength = 3,
    defense = 3,
    
    maxEnergy = 10, --max energy
    energy = 7,
    nutrition = 3,
    
    sleeping = false,--{true, true, false},
    
    sight = 5, -- probability to sight other based on stealth
    vision = 5,
    persistence = 5,--how many turns to keep chasing if not seen, reduced by target's stealth,
    
    hostility = 1, -- 0 - no attack, 1 - only when disliked, 2 - player and disliked, 3 - all other except team
    
    bondingLevel = 10, -- likeness to reach to assign as leader, 100p default
    furthestFromLeader = 7, -- distance to run back to leadee
    stealth = 0, -- -10 to +10
    dislikeTrigger = 3, -- amount of dislike to attack,
    pettiness = 2,
    gratitude = 2,
    eatRate = 1/2,
    
    playerDislike = 0, -- default dislike of player,
    lovesFood = true,
    
    cowardice = 2, -- (0-10, 10 run from all but friends, %hp to run)
    
    bondingLevel = 1,
    
    food = {
        Tree = true,
        grass = true
    },
    
    info = "-sewer rat",
    
    loot = {},--???
    canPickItems = false,
    furthestFromLeader = 3,
    
    inventorySpace = 1,
    d£rop = {
        --null = {1},
        meat = {30, {1},"meat"},
        --or
        --drop1 = {weight, {"meat","meat","carrot"}},
        
    },
    
    abilities = {
        -- name = {level=value, ...}
        muncher = {level={2}}
    },
    
    
    postMake = function(self)
        self.shell = self:add_sprite("creatures/giant_snail_shell_color")
        self.shell_outline = self:add_sprite("creatures/giant_snail_shell_outline")
        
        self.shell:syncTo(self.sprite)
        self.shell_outline:syncTo(self.sprite)
        
        self.shell.color = "black"
    end,
    
    updateTurn = function(self)
        -- self.shell.color
    end,
        
    
    w = tw*1.6,
    h = th*1.6*2,
}

--c.spectral_blade=c.rat c.pig=c.rat
