
dungeon[1] = {
    minRooms = 12,
    nextLevel = 2,
    
    -- change intensity of spawns
    intensity = {
        ["1"] = 1,
        ["3"] = 3
    },
    
    groupSize = {2,3},
    
    creatures = {
        -- [1]weight, [2]amount, [3]intensity, [4]team, [5]group
        goblin = {20,{1,3},2,"gob",4},
        pig = {5,{1,3},.5},
        rat = {50,nil,nil,nil,nil,"r",3},
        bloat = {10,1,1},
        goblin_conjurer = {5,1,3}
    },
    
    creatureData = {
        kobold = {
            30,
            name = {"kobold"},
            class = {
                scout = {4, 1},
                rockThrower = {2,{1,1,2,3}},
                archer = {1, 1},
                none = {13, 1},
                bomber = {3, 1} 
            },
            
            level = 3,
            group = {1,1,1,2,2,2,3},
        },
        
        pig = {
            10,
            level = 1,
            group = {1,1,2},
            leader = true
        },
        
        
        rat = {
            20,
            name = {"rat"},
            intensity = 1
        },
        
        
        bloat = {
            2,
            name = {"bloat"},
            insensity = 1
        },
        
        bat = {
            5,
            intensity = 1.5,
            group = {1,1,2}
        },
        
        goblin = {
            3,
            intensity = 1,
            group = {1,1,1,2},
            leader = true
        }
    
    },
    
    ot = {
        goblin = {
            25,
            name = {"goblin"},
            class = {
                -- class = {weight, level}
                scout = {80, 1},
                --warrior = {15, 1},
                conjurer = {20, 1, "goblin_conjurer"},
                --bezerker = {5, 1},
              --  bomber = {10,1}
            },
            
            skills = {},
            numberOfSkills = 0,
            
            level = 1,
            group = {1,1,1,1,2,2,3,3,3},-- increases intensity
            intensity = {2,3,1,2}, -- gotten intensity is added to level
            amount = 1, -- does not increase intensity
            leader = true, -- is there a leader in the group?
        },
        
        orc = {
            25,
            name = {"orc"},
            class = {
                -- class = {weight, level[, actual_creature]}
                scout = {80, 1},
                warrior = {15, 1},
                --conjurer = {20, 1},
                bezerker = {5, 1},
                --bomber = {10,1}
            },
            
            skills = {},
            numberOfSkills = 0,
            
            level = 1,
            group = {1,1,1,1,2,2,3,3,3},-- increases intensity
            intensity = {2,3,1,2}, -- gotten intensity is added to level
            amount = 1, -- does not increase intensity
            leader = true, -- is there a leader in the group?
        },
        
        bloat = {
            10,
            name = {"bloat"},
            insensity = 1
        },
        
        pig = {
            8,
            name = {"pig"},
            insensity = 1,
            group = {1,1,1,2}
        },
        
        boar = {
            20,
            name = {"boar"},
            groupCreatures = "pig",
            group = {2,2,2,3,3,3,4,3,3},
            level = 2,
            leader = true
        },
        
        
        
            
    },
    
    -- chnge wieldAngle on use item
    itemPool = {
        pool1 = {
            sword = {
                weight = 40,
                durability = {40,60},
                enchants = {2,2,3},
                buffs = {"random"},
            },
            axe = {
                weight = 20,
                durability = {40,60},
                enchants = {0,1},
                buffs = {nil,nil,"random"},
            },
            wand = {
                weight = 60,
                item = {"wand_of_poisoning", "wand_of_teleportation","wand_of_lightning"},
                enchants = {0,0,1,2},
            }
        },
        
        rewardPool = {
            wand = {
                weight = 30,
                item = getRandomWand,
                enchants = {0,0,0,1,1,1,1,2},
            },
            
            weapon = {
                weight = 40,
                durability = {40,60},
                enchants = {0,0,2,1,1},
                buffs = {false, false, false, "random"},
                item = {"axe", "dagger", "sword"}
            },
            
            misc = {
                weight = 30,
                item = {"bomb"}
            }
        },
        
        randomDrops = {
            wand = {
                weight = 2,
                item = getRandomWand,
                enchants = {0,0,0,1,1,1,1,2},
            },
            
            weapon = {
                weight = 10,
                durability = {30,60},
                enchants = {-1,-1,0,0,0,2,1,1},
                buffs = {false, false, false, "random"},
                item = {"axe", "dagger", "sword"}
            },
            
            potions = {
                weight = 40,
                items = getRandomPotion--"bomb"
            },
            
            
            scrolls = {
                weight = 20,
                items = getRandomScroll--"bomb"
            },
                
            misc = {
                weight = 30,
                item = {"bomb","stick","stone"}
            },
            
            seed = {
                weight = 5,
                items = getRandomSeed,
            }
        }
    },
    
    traps = {
        trap = {
            poisonGasTrap = 10,
            --fireTrap = 5,
        },
        
        min = 0,
        max = 0
    },
    
    roomTypes = {


        {
            name = "cave",
            chanceToSpawn = 13,
            min = 1,
            mutate = "cave",
            noCount = true
        },
        

        {
            name = "cave2",
            chanceToSpawn = 23,
            min = 2,
            mutate = "depressRoof",
            noCount = true
        },
        
        
        {
            name = "battleRoom_medium",
            chanceToSpawn = 50,
            maxPercent = 50,
            minPercent = 30,
            tags = {
                battleRoom = true
            },
            
            level = 2,
            --maxDoors = 1,
        },
        
        
        {
            name = "battleRoom_hard",
            chanceToSpawn = 25,
            maxPercent = 25,
            min = 2,
            max = 3,
            tags = {
                battleRoom = true
            },
            
            level = 3
        },
        
        {
            name = "battleRoom_easy",
            chanceToSpawn = 25,
            maxPercent = 25,
            min = 1,
            max = 3,
            tags = {
                battleRoom = true
            },
            
            level = 1
        },
        
        {
            name = "enchanted_scroll",
            max = 3,
            min = 1,
            tags = {
                rewardRoom = true
            },
            spawnItem = "scroll_of_enchanting"
        },
        
        
        --[[{
            name = "shop",
            max = 0,
            specialRooms = "shop_room",
            
            postMake = function(l,map) er()
                map:after(.1,function() map:teleport(pl,l:getRandomSpaceTile()) end)
            end
        }]]
        
        {
            name="t",
            min = 0,max=0,
            maxDoors = 1,
            --spawnItem = {angel_statue={1,items={"angel_statue"}}},
            
            postMake = function(l, map) warn()
                for x = l.minTileX, l.maxTileX do
                    for y = l.minTileY, l.maxTileY do
                        local t = map:getTile(x, y)
                        local isEdge = t and
                          (x==l.minTileX or x==l.maxTileX) or 
                          (y==l.minTileY or y==l.maxTileY)
                          
                        if t and not t.isCorridor and isEdge then
                            t.solid = true
                            t.keepSolid = true
                        end
                    end
                end
                
                for x, d in pairs(l.doors) do
                    --d:makeDoor(true)
                end
                
                local fire = map:spawnItem("campfire",l:getRandomSpaceTile())
                
                local crs = map:spawnFromData("goblin",l)
                -- map:spawn("pig",l:getRandomSpaceTile())
                rooom = fire.tile
                if not crs then return end
                for x = 1,#crs do
                    crs[x].campfire = fire
                    crs[x].currentState = "Dancing"
                    local c = crs[x]
                    c.waiting = true
                end
                
                do
                
                    local c = getValue(crs)
                    
                    local ocl = c.leader
                    c.leader = nil
                    
                    c.title = "Hunger gobbo"
                    c.currentState = "Hungry"
                    c.grabFood = true
                    c.isHunting = true
                    
                    c.onGrabFood = function(self)
                        c:onStartTurn(function()
                            if c.tile.roomData == l and not c.thrown then
                                pl:addLog("Done!","cyan")
                                c.toThrow = c:getFoodItem()
                                c.throwDistance = 3
                                if c.toThrow then
                                c.toThrow.onCooked = function(food)
                                    for x = 1, #crs do
                                        crs[x].isHunting = true
                                    end
                                end
                                
                                c.throwTarget = fire.tile
                                c.thrown = true end
                            else
                                c.targetTile = l:getRandomSpaceTile()
                            end
                        end)
                        
                        c.targetTile = l:getRandomSpaceTile()
                        c.currentState = "Curious"
                        c.isHunting = false
                        c.leader = ocl cwarn("Grabbed ","pink")
                        c.grabFood = false
                    end
                    
                end
                --map:after(.1,function() fire.room:spawn("bloat",rooom) fire.room:teleport(pl,rooom) end)
            end,
        },
        {
            name = "keyRoom",
            min = 1,
            max = 3,
            maxDoors = 1,
            minDoors = 1,
            
            specialRooms = {
                statue_challenge_room = 10000
            },
            
            tags = {
                rewardRoom = true,
                lockedRoom = true,
            },
    
            items = {
                amount = 4,
                pool = "rewardPool",
                pedestalLocked = true,
                onPedestal = true,
            },
            
            checkRoom = {
                lockedRoom = false,
                lastRoom = false,
                keyRoom = false,
                rewardRoom = false
            },
    
            
            preMake = function(l, map)
                for x = l.minTileX, l.maxTileX do
                    for y = l.minTileY, l.maxTileY do
                        local t = map:getTile(x, y)
                        local isEdge = t and
                          (x==l.minTileX or x==l.maxTileX) or 
                          (y==l.minTileY or y==l.maxTileY)
                          
                        if t and not t.isCorridor and isEdge and not t.door then
                            t.solid = true
                            t.keepSolid = true
                        end
                    end
                end
                l.roomTypes.noMutation = true
                ll = l
            
                l.toyi = true
                local done
               -- error(inspect(l.doors,1))
                for x, d in pairs(l.doors) do
                    d:makeDoor(true)
                    l.door = d l.toy=1
                    l.door.key = l.key or l.door.key
                    if done then error("more than 1 door!") end
                    done = true
                end
            end,
            
            spawnRooms = {
                 {
                    chance = 100,
                    data = keyPlacement.pressurePlateKey
                }
            }
                    
        },
        
        {
            name = "pedestal_reward_room",
            chanceToSpawn = 70,
            min = 1,
            maxPercent = 14 ,
            min = 1, max = 2,
            specialRooms = "pedestal_reward_room",
        
            checkRoom = {
                battleRoom = false,
                pedestal_reward_room = false
            }
        },
        
        {
            name = "specialRoom",
            specialRoom = true,
            min = 1,
            max = 0,
            roomLevel = 1
        },
        
        {
            name = "randomDrop",
            items = {
                amount = {1,1,1,1,2,3},
                pool = "randomDrops"
            },
            max = 6,
            min = 4
        },

        
        goblinRoom = {
            spawn = {
                goblin = {1, nil, nil, "gob", 3}
            },
            chanceToSpawn = 30,
            min = 1
        },
        
        bloatRoom = {
            spawn = {
                bloat = {1},
            },
            chanceToSpawn = 30,
            min = 1,
        },
        
        craftingRoom = {
            spawnItem = {
                anvil = {10,
                    items = {
                        "anvil",
                        {"arrow",{4,10}}
                    }
                }
            },
            chanceToSpawn = 20,
            min = 1
        }
    }
}

dungeon[2] = {
    minRooms = 12,
    
    -- change intensity of spawns
    intensity = {
        ["1"] = 1,
        ["3"] = 3
    },
    
    groupSize = {2,3},
    
    creatures = {
        -- [1]weight, [2]amount, [3]intensity, [4]team, [5]group
        goblin = {20,{1,3},2,"gob",4},
        pig = {5,{1,3},.5},
        rat = {50,nil,nil,nil,nil,"r",3},
        bloat = {10,1,1},
        goblin_conjurer = {5,1,3}
    },
    
    creatureData = {
        kobold = {
            10,
            name = {"kobold"},
            class = {
                scout = {4, 1},
                rockThrower = {3,{1,1,2,3}},
                archer = {2, 1},
                none = {10, 1},
                bomber = {3, 1} 
            },
            
            level = 1.5,
            group = {1,1,1,2,2,2,3},
        },
        
        pig = {
            5, 
            level = 1,
            group = {1,1,2},
            leader = true
        },
        
        
        rat = {
            5,
            name = {"rat"},
            intensity = 1
        },
        
        
        bloat = {
            2,
            name = {"bloat"},
            insensity = 1
        },
        
        bat = {
            5,
            intensity = 1.5,
            group = {1,1,2}
        },
        
        goblin = {
            3,
            intensity = 1,
            group = {1,1,1,1,2,2,3},
            leader = true
        },
        
        orc = {
            3,
            intensity = 1,
            group = {1,1,1,2},
            leader = true
        },
        
        jackal = {
            3,
            intensity = 1.5,
            group = {1,1,1,2,2},
            leader = true
        },
        
        monkey = {
            2,
            intensity = 1
        }
    
    },
    
    ot = {
        goblin = {
            25,
            name = {"goblin"},
            class = {
                -- class = {weight, level}
                scout = {80, 1},
                --warrior = {15, 1},
                conjurer = {20, 1, "goblin_conjurer"},
                --bezerker = {5, 1},
              --  bomber = {10,1}
            },
            
            skills = {},
            numberOfSkills = 0,
            
            level = 1,
            group = {1,1,1,1,2,2,3,3,3},-- increases intensity
            intensity = {2,3,1,2}, -- gotten intensity is added to level
            amount = 1, -- does not increase intensity
            leader = true, -- is there a leader in the group?
        },
        
        orc = {
            25,
            name = {"orc"},
            class = {
                -- class = {weight, level[, actual_creature]}
                scout = {80, 1},
                warrior = {15, 1},
                --conjurer = {20, 1},
                bezerker = {5, 1},
                --bomber = {10,1}
            },
            
            skills = {},
            numberOfSkills = 0,
            
            level = 1,
            group = {1,1,1,1,2,2,3,3,3},-- increases intensity
            intensity = {2,3,1,2}, -- gotten intensity is added to level
            amount = 1, -- does not increase intensity
            leader = true, -- is there a leader in the group?
        },
        
        bloat = {
            10,
            name = {"bloat"},
            insensity = 1
        },
        
        pig = {
            8,
            name = {"pig"},
            insensity = 1,
            group = {1,1,1,2}
        },
        
        boar = {
            20,
            name = {"boar"},
            groupCreatures = "pig",
            group = {2,2,2,3,3,3,4,3,3},
            level = 2,
            leader = true
        },
        
        
        
            
    },
    
    -- chnge wieldAngle on use item
    itemPool = {
        pool1 = {
            sword = {
                weight = 40,
                durability = {40,60},
                enchants = {2,2,3},
                buffs = {"random"},
            },
            axe = {
                weight = 20,
                durability = {40,60},
                enchants = {0,1},
                buffs = {nil,nil,"random"},
            },
            wand = {
                weight = 60,
                item = {"wand_of_poisoning", "wand_of_teleportation","wand_of_lightning"},
                enchants = {0,0,1,2},
            }
        },
        
        rewardPool = {
            wand = {
                weight = 30,
                item = getRandomWand,
                enchants = {0,0,0,1,1,1,1,2},
            },
            
            weapon = {
                weight = 40,
                durability = {40,60},
                enchants = {0,0,2,1,1},
                buffs = {false, false, false, "random"},
                item = {"axe", "dagger", "sword"}
            },
            
            misc = {
                weight = 30,
                item = {"bomb"}
            }
        },
        
        randomDrops = {
            wand = {
                weight = 2,
                item = getRandomWand,
                enchants = {0,0,0,1,1,1,1,2},
            },
            
            weapon = {
                weight = 10,
                durability = {30,60},
                enchants = {-1,-1,0,0,0,2,1,1},
                buffs = {false, false, false, "random"},
                item = {"axe", "dagger", "sword"}
            },
            
            potions = {
                weight = 40,
                items = getRandomPotion--"bomb"
            },
            
            
            scrolls = {
                weight = 20,
                items = getRandomScroll--"bomb"
            },
                
            misc = {
                weight = 30,
                item = {"bomb","stick","stone"}
            },
            
            seed = {
                weight = 5,
                items = getRandomSeed,
            }
        }
    },
    
    traps = {
        trap = {
            poisonGasTrap = 10,
            fireTrap = 2,
        },
        
        min = 0,
        max = 1
    },
    
    roomTypes = {


        {
            name = "cave",
            chanceToSpawn = 13,
            min = 1,
            mutate = "cave",
            noCount = true
        },
        

        {
            name = "cave2",
            chanceToSpawn = 23,
            min = 2,
            mutate = "depressRoof",
            noCount = true
        },
        
        
        {
            name = "battleRoom_medium",
            chanceToSpawn = 50,
            maxPercent = 50,
            minPercent = 30,
            tags = {
                battleRoom = true
            },
            
            level = 2,
            --maxDoors = 1,
        },
        
        
        {
            name = "battleRoom_hard",
            chanceToSpawn = 25,
            maxPercent = 25,
            min = 2,
            max = 3,
            tags = {
                battleRoom = true
            },
            
            level = 3
        },
        
        {
            name = "battleRoom_easy",
            chanceToSpawn = 25,
            maxPercent = 25,
            min = 1,
            max = 3,
            tags = {
                battleRoom = true
            },
            
            level = 1
        },
        
        {
            name = "shop",
            specialRooms = "shop_room",
            max = 1,min = 1
        },
        
        {
            name="t",
            min = 0,max=0,
            maxDoors = 1,
            --spawnItem = {angel_statue={1,items={"angel_statue"}}},
            
            postMake = function(l, map) warn()
                for x = l.minTileX, l.maxTileX do
                    for y = l.minTileY, l.maxTileY do
                        local t = map:getTile(x, y)
                        local isEdge = t and
                          (x==l.minTileX or x==l.maxTileX) or 
                          (y==l.minTileY or y==l.maxTileY)
                          
                        if t and not t.isCorridor and isEdge then
                            t.solid = true
                            t.keepSolid = true
                        end
                    end
                end
                
                for x, d in pairs(l.doors) do
                    --d:makeDoor(true)
                end
                
                local fire = map:spawnItem("campfire",l:getRandomSpaceTile())
                
                local crs = map:spawnFromData("goblin",l)
                -- map:spawn("pig",l:getRandomSpaceTile())
                rooom = fire.tile
                if not crs then return end
                for x = 1,#crs do
                    crs[x].campfire = fire
                    crs[x].currentState = "Dancing"
                    local c = crs[x]
                    c.waiting = true
                end
                
                do
                
                    local c = getValue(crs)
                    
                    local ocl = c.leader
                    c.leader = nil
                    
                    c.title = "Hunger gobbo"
                    c.currentState = "Hungry"
                    c.grabFood = true
                    c.isHunting = true
                    
                    c.onGrabFood = function(self)
                        c:onStartTurn(function()
                            if c.tile.roomData == l and not c.thrown then
                                pl:addLog("Done!","cyan")
                                c.toThrow = c:getFoodItem()
                                c.throwDistance = 3
                                if c.toThrow then
                                c.toThrow.onCooked = function(food)
                                    for x = 1, #crs do
                                        crs[x].isHunting = true
                                    end
                                end
                                
                                c.throwTarget = fire.tile
                                c.thrown = true end
                            else
                                c.targetTile = l:getRandomSpaceTile()
                            end
                        end)
                        
                        c.targetTile = l:getRandomSpaceTile()
                        c.currentState = "Curious"
                        c.isHunting = false
                        c.leader = ocl cwarn("Grabbed ","pink")
                        c.grabFood = false
                    end
                    
                end
                --map:after(.1,function() fire.room:spawn("bloat",rooom) fire.room:teleport(pl,rooom) end)
            end,
            
            spawnRooms = {
                 {
                    chance = 100,
                    data = keyPlacement.pressurePlateKey
                }
            }
                    
        },
        
        --[[{
            name = "pedestal_reward_room",
            chanceToSpawn = 70,
            min = 1,
            maxPercent = 14 ,
            min = 1, max = 2,
             specialRooms = "pedestal_reward_room",
        
            checkRoom = {
                battleRoom = false
            }
        },]]
        
        {
            name = "specialRoom",
            specialRoom = true,
            min = 1,
            max = 0,
            roomLevel = 1
        },
        
        {
            name = "randomDrop",
            items = {
                amount = {1,1,1,1,2,3},
                pool = "randomDrops"
            },
            max = 6,
            min = 4
        },

        
        goblinRoom = {
            spawn = {
                goblin = {1, 2, 2, "gob", 3}
            },
            chanceToSpawn = 30,
            min = 1
        },
        

    }
}