
keyPlacement = {
    pressurekPlateKey = {
        name = "pressurePlateKeyRoom",
        traps = {
            traps = {keyTrap=1},
            keyTrap = {
                onSteppedOn = function(tile)
                    local k = tile.roomData.key
                    if not k then
                        log("[Key] failed "..tostring(tile.roomData))
                        error(inspect(tile.roomData.parentRoom,1))
                    end
                    
                    k:unlock()
                end,
                
                onReleased = function(tile)
                    local k = tile.roomData.key
                    k:lock()
                end
            }
        },
        
        tags = {
            keyRoom = true,
        },
        
        checkRoom = {
            --lockedRoom = false
        },
        
        noSpawnInParentRoom = true,
        postMake = function(roomData)
          log("[KEy plate] making room "..tostring(roomData))
          
          roomData.key = roomData.room:spawnItem("cagedKey", roomData:getRandomSpaceTile())
          --assert(roomData.parentRoom.toy) 
          log("k")
          
          roomData.parentRoom.key = roomData.key or error()
          
          rr = roomData.parentRoom
          kk = roomData
        end
    },
    
    prkessurePlateKey = {
        name = "chasmPressurePlateRoom",
        noSpawnInParentRoom = true,
        maxDoors = 1,
        minDoors = 1,
        
        checkRoom = {
            --so some key rooms may be in locked rooms but
            -- only those spawned by other locked rooms which are guaranteed
            -- to not spawn in an already placed key room
            
            --lockedRoom = false
        },
        
        tags = {
            keyRoom = true
        },
        
        postMake = function(roomData)
            local d = roomData.doors[1]
            local furthest, dis
            for x = 1, 10 do
                local t = roomData:getRandomSpaceTile()
                --spawnrooms
                if t then
                    local ddis = lume.distance(t._x,t._y,d._x,d._y)
                    if not dis or ddis>dis then
                        furthest = t
                        dis = ddis
                    end
                end
            end
            
            if furthest and dis > 2 then
            
                Trap.loadTrap({
                onSteppedOn = function(tile)
                    local k = tile.roomData.key
                    if not k then
                        log("[Key] failed "..tostring(tile.roomData))
                        error(inspect(tile.roomData.parentRoom,1))
                    end
                    
                    k:unlock()
                end,
                
                onReleased = function(tile)
                    local k = tile.roomData.key
                    k:lock()
                end
                }, furthest)
                
                local f = furthest
                for x = 1, lume.max(math.floor(dis-1),1) do
                    for d = 1, 8 do
                         local ds = dirs8[d]
                         local t = f.room:getTile(f._x+ds[1], f._y+ds[2])
                         if t then
                            t.chasm = true
                        end
                    end
                end
            elseif furthest then error(dis) end
            
            
          log("[KEy plate] making room "..tostring(roomData))
          
          roomData.key = roomData.room:spawnItem("cagedKey", roomData:getRandomSpaceTile())
          --assert(roomData.parentRoom.toy) 
          log("k")
          
          roomData.parentRoom.key = roomData.key or error()
          
          rr = roomData.parentRoom
          kk = roomData
        end
    },
    
    prjessurePlateKey = {
        name = "skeletonKeyRoom",
        noSpawnInParentRoom = true,
        maxDoors = 1,
        minDoors = 1,
        
        checkRoom = {
            --so some key rooms may be in locked rooms but
            -- only those spawned by other locked rooms which are guaranteed
            -- to not spawn in an already placed key room
            
            --lockedRoom = false
        },
        
        tags = {
            keyRoom = true
        },
        
        postMake = function(roomData)
            local skulls = {}
            local t = lume.randomchoice(roomData:getSolidTiles())
            t.onDestroyed = function()
                t.room:spawn("orc", t)
            end
          
            for x = 1, math.random(3,5) do
                local s = roomData.room:spawnItem("skull", roomData:getRandomSpaceTile())
                
                if x == 1 or math.random() < .5 then
                    skulls[#skulls+1] = s
                end
            end
            
          
            roomData.key = roomData.room:spawnItem("key", roomData:getRandomSpaceTile())
            --assert(roomData.parentRoom.toy)
            roomData.key.tile.pedestal = true
            roomData.key.___updateTurn =  function(self)
                if self.isCarried and t.solid then
                    t:getAttacked(3, self)
                elseif not t.solid then
                    t.onDestroyed = nil
                end
                
                if self.startSkulls then
                    
                    for x = 1, self.startSkulls == 1 and 0 or #skulls do
                        local t = skulls[x]
                        local ti = t.tile
                        t:destroy()
                        roomData.room:spawn("skeleton", ti)
                    end
                    
                    self.startSkulls = self.startSkulls == 1 and 2 or nil
                end
            end
            
            roomData.key.onCarry = function()
                for x = 1, #skulls do
                    local t = skulls[x]
                    local ti = t.tile
                    t:shake(15,100,20)
                end
                
                roomData.key.startSkulls = 1
            end
            
            log("k")
        
            roomData.parentRoom.key = roomData.key or error()
           
            addCarpetsToRoom(roomData)
            
            rr = roomData.parentRoom
            kk = roomData
        end
    },
    
    pressure7PlateKey = {
        name = "monkeyKeyRoom",
        noSpawnInParentRoom = true,
        maxDoors = 1,
        minDoors = 1,
        
        checkRoom = {
            --so some key rooms may be in locked rooms but
            -- only those spawned by other locked rooms which are guaranteed
            -- to not spawn in an already placed key room
            
            --lockedRoom = false
        },
        
        tags = {
            keyRoom = true
        },
        
        postMake = function(roomData)
          
            roomData.key = roomData.room:spawnItem("key", roomData:getRandomSpaceTile())
            roomData.key.tile.pedestal = true
            
            local monkey = roomData.room:spawn("monkey", roomData:getRandomSpaceTile())
            
            if monkey then
                monkey:forceAddItem(roomData.key)
                monkey:playSteal(monkey, nil, roomData.key)
                if not monkey:hasItem(roomData.key) then
                    error(inspect(monkey,inventory,3)..","..inspect(roomData.key,1))
                end
            end
        
            roomData.parentRoom.key = roomData.key or error()
           
            addCarpetsToRoom(roomData)
            
            rr = roomData.parentRoom
            kk = roomData
        end
    },
    
    pressurePlateKey = {
        name = "ratKeyRoom",
        noSpawnInParentRoom = true,
        maxDoors = 1,
        minDoors = 1,
        
        checkRoom = {
            --so some key rooms may be in locked rooms but
            -- only those spawned by other locked rooms which are guaranteed
            -- to not spawn in an already placed key room
            
            --lockedRoom = false
        },
        
        tags = {
            keyRoom = true
        },
        
        postMake = function(roomData)
            local skulls = {}
            local done = {}
            if roomData==roomData.parentRoom then error() end
            local t
            for x = 1, math.random(8,15) do
                t = lume.randomchoice(roomData:getSolidTiles())
                if not done[t] then
                    done[t] = true
                    t.onDestroyed = function()
                       t.room:spawn("rat", t)
                    end
                end
            end

          
            roomData.key = roomData.room:spawnItem("key", roomData:getRandomSpaceTile())
            --assert(roomData.parentRoom.toy)
            roomData.key.tile.pedestal = true
            roomData.key.___updateTurn =  function(self)
                if self.isCarried and t.solid and done then
                    for tt, i in pairs(done) do
                        tt:getAttacked(math.random()<.5 and 1 or 1.5, self)
                    end
                    
                    if not self.rumbled then
                        self.user:addLog("You hear a rumbling sound")
                        self.room.camera:shake(15,5,15)
                        self.rumbled = true
                    end
                    
                elseif not t.solid and done then
                    for tt, i in pairs(done) do
                        tt.onDestroyed = nil
                    end
                    done = nil
                end
            end

        
            roomData.parentRoom.key = roomData.key or error()
           
            --addCarpetsToRoom(roomData)
            
            rr = roomData.parentRoom
            kk = roomData
        end
    },
    
}