data.rooms = {}
rooms = data.rooms
local r = rooms
local i = rooms

dungeon = {}

--[[
summonTrapPedestal
graveyardRoom
headstoneRoom
statueChallengeRoom
trapRoom
warRoom
]]

--[[
Tags for rooms
    - startingRoom
    - endingRoom
    
    - rewardRoom
    - plantRoom
    - holyRoom
    - statueRoom
    - cursedRoom
    - noSpawn
    - enemyRoom
    - battleRoom
    - shop

]]

r.shop_room = {
    roomLevel = 2,
    
    tags = {
        shop = true,
        noSpawn = true
    },
    
    checkRoom = {
        startingRoom = false
    },
    
    shop = {
        shopkeeper = "burlyman",
        shopType = {
            library = {
                weight = 10,
                itemPool = "library",
                priceIncrement = 1,
                addon = 0,
                greeting = {"Welcome to my library, %s!"}
            },
            
            chemist = {
                weight = 10,
                itemPool = "chemist",
                priceIncrement = 1,
                greeting = {"Welcome to my pharmacy, %s!"}
            },
            
            general = {
                weight = 10,
                itemPool = "general",
                priceIncrement = 1,
                greeting = {"Welcome to my shop, %s!"}
            },
            
        }
    },
    
    preMake = function(l, map)
        do local c=0
                for x = l.minTileX, l.maxTileX do
                    for y = l.minTileY, l.maxTileY do
                        local t = map:getTile(x, y)
                        local isEdge = t and
                          (x==l.minTileX or x==l.maxTileX) or 
                          (y==l.minTileY or y==l.maxTileY)
                          
                        if t and not t.isCorridor and not t.isEntrance and isEdge and not t.stairs then
                            t.solid = false c=c+1
                            map:spawnItem("woodenWall",t,true)
                            -- t.keepSolid = true
                            t.isCorridor = true
                            t.isEntrance = true
                        elseif t and not isEdge and not t.stairs then
                            map:spawnItem("woodenFloor",t)
                            t.isCorridor = true
                        end
                    end
                end assert(c>4)
        end
    end,
    
    postMake = function(l, map)
        l.shopkeeper.currentState = "Dancing"
        
    end
    
}

r.flamesprout_room = {

    roomLevel = 1,
    minRoomLevel = 1,
    maxRoomLevel = 5,
    
    tags = {
        plantRoom = true
    },

    name = "flamesprout_room",
    spawnItem = {
        flamesprout = {1, {2,4}}
    },
    chanceToSpawn = 10
}

r.pooleaf_room = {
    name = "pooleaf_room",
    spawnItem = {
        pooleaf = {1, {1,1,1,1,2}}
    },
    
    tags = {
        plantRoom = true
    },
    
    chanceToSpawn = 10
}

r.angel_statue_room = {
    roomLevel = 3,
    spawnItem = {
        angel_statue = {1, 1}
    },
    
    tags = {
        statueRoom = true
    },
    
    chanceToSpawn = 3,
}

r.cursed_statue_room = {
    roomLevel = 4,
    
    spawnItem = {
        cursed_statue = {1,1}
    },
    
    tags = {
        statueRoom = true
    },
    
    chanceToSpawn = 2,
}

r.pedestal_reward_room = {
    items = {
        amount = 4,
        pool = "rewardPool",
        pedestalLocked = true,
        onPedestal = true,
    },
    
    tags = {
        rewardRoom = true
    }
}

r.weapon_reward_room = {
    items = {
        amount = 1,
        pool = "weaponPool",
        pedestalLocked = true,
        onPedestal = true,
    },
    
    tags = {
        rewardRoom = true
    }
}

i.scroll_reward_room = {
   itemData = {
        items = getRandomScroll,
        enchants = {0,0,0,1,1,2},
        amount = {2,3,3,3,3,4}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.potion_reward_room = {
    itemData = {
        items = getRandomPotion,
        enchants = {0,0,0,1,1,2},
        amount = {2,3,3,3,3,4}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.wand_reward_room = {
    itemData = {
        items = getRandomWand,
        enchants = {0,1,1,2,2,1,1,1,2,2,3,0,5},
        amount = {2,3,3,3,3,4}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.scroll_of_enchanting_reward_room = {
    itemData = {
        items = {"scroll_of_enchanting"},
        enchants = {0,0,0,1,1,2},
        amount = {1,1,1,2,2,2,2,1,1,1,3}
    },
    
    tags = {
        rewardRoom = true
    }
}

i.angel_statue_potion_reward_room = {
    itemData = {
        itemsByWeight = {
            potion_of_healing = 5,
            potion_of_life = 1,
            potion_of_haste = 2,
            potion_of_protection = 2
        },
        enchants = {0,0,0,1,1,2},
        amount = {2,3,3,3,3,4}
    },
    
    spawnItem = "angel_statue",
    
    tags = {
        rewardRoom = true,
        statueRoom = true,
        holyRoom = true
    }
}
    
i.statue_challenge_room = {
    tags = {
        battleRoom = true,
        rewardRoom = true,
        statueRoom = true
    },
    
    postMake = function(room, map)
        local sta = map:spawn("battle_statue", room:getRandomSpaceTile())
        
        sta:addClass(getValue({"warrior"}))
    end
}
    
r.single_pedestal_reward_room = {

    tags = {
        rewardRoom = true
    },
    
    items = {
        amount = 1,
        pool = "rewardPool",
        --pedestalLocked = true,
        onPedestal = true,
    },
    
    checkRoom = {
        battleRoom = false,
        rewardRoom = false,
        lockedRoom = false
    },
    
    chanceToSpawn = 10,
    max = 2
    
}

for x, i in pairs(r) do
    i._id = i._id or x
    i.name = i.name or x
end