local i = items
armour = {}
helmets = {}
glasses = {}

armour.leather_armour = {
    name = "leather armour",
    anim = "items/armour/leather_armour",
    space = 5,
    
    useText = "equip",
    
    onUse = function(self, user)
    end,

}

armour.scale_armour = {
    name = "scale armour",
    anim = "items/armour/scale_armour",
    space = 3,
    stats = {
        agility = 2,
        defense = 1,
    }
}

armour.plate_mail = {
    name = "plate armour",
    anim = "items/armour/plate_mail",
    space = 3,
    stats = {
        agility = 2,
        defense = 1,
    }
}

armour.cloth_mail = {
    name = "cloth armour",
    anim = "items/armour/cloth_armour",
    space = 3,
    stats = {
        agility = 2,
        defense = 1,
    }
}

armour.big_armour = {
    name = "big armour",
    anim = "items/armour/big_armour",
    space = 3,
    stats = {
        agility = 2,
        defense = 1,
    }
}

armour.splint_armour = {
    name = "splint armour",
    anim = "items/armour/splint_armour",
    space = 3,
    stats = {
        agility = 2,
        defense = 1,
    }
}
armour.bomb_strap = {
    name = "bomb strap",
    small = true,
    space = 3,
    anims = {
        idle = {
            source = "items/bomb_strap",frameDelay=.15
        },
        active = {
            source = "items/bomb_strap_on",
        }
    },
    
    life = 4,
    noDrop = true,
    
    activate = function(armour, cr)
        if armour.activated then
            return
        end
        
        armour.sprite:switch("active")
        cr.sprite:setDelay(.05)
        --not work if cr was set on fire assert(not cr.lightData)
        cr.light = {5,"red"}
        local user = cr
        user.lightData = user.room:addLight(user.tile, user.light[1], user.light[2])
        
        cr.bombActive = true
        cr:onDamaged(armour.data.blowup)
        armour.activated = true
        
        armour.dead = true
        
        return true
    end,
    
    onDamaged = function(self, th)
        if th.isFire or th.isBurn then
            self.data.activate(self, self.user)
        end
    end,
    
    blowup = function(data, user, att)
        att = user.attacker
        if not user.blown and (att.isFire or att.isBurn) then
                user.blown = true
                Fire:new({
                    source = user and user.tile or error(user.name),
                    explode = true,
                    range = 3,
                })
                user:addLog("A bomb &colors.orange @exploded ~!")
                user.armour.activated = false
                 if user.lightData then user.room:removeLight(user.lightData) end
                if user.armour.exploded then error() end

        end
    end,
        
    updateTurn = function(self, user)
        if not self.activated then
            return
        end
        
        self.color = "red"
        
        self.llife = (self.llife or self.life) - 1
        self.info = string.format("This bomb will go off in %s turn%s", self.life, self.life>1 and "s" or "")
        
        if self.llife <= 0 then
            user.blown = true
            self.room:addLog("The bomb...")-- burnt out")
            if user then
                user:removeItem(self, true)
            else
                self.room:removeItem(self)
            end
            
            self.room:removeLight(self.light)
            if not self.exploded then  
                Fire:new({
                    source = self.tile or user and user.tile,
                    explode = true,
                    range = bombRange,
                })
                self:addLog("A bomb &colors.orange @exploded ~!")
                self.exploded = true
            end
            return
        end
        
        if not user then
            if self.light then
                self.room:removeLight(self.light)
            end
            --self.light = self.room:addLight(user and user.tile or self.tile, mRange,self.color)
        
            return
        end
    end,
}

helmets.basic_helm = {
    name = "Basic Helm",
    anim = "items/helmets/bucket_helmet",
    space = 3,
    
    useText = "equip",
    isHelmet = true
}

helmets.advanced_helmet = {
    name = "Advanced Helmet",
    anim = "warcrawl/helmets/spacehelmet",
    space = 3,
    stats = {
        agility = 2,
        defense = 1,
    }
}

helmets.space_helmet = {
    name = "Full Helmet",
    anim = "warcrawl/helmets/spacehelmet2",
    space = 3,
    stats = {
        sight = 2,
        defense = 3,
    }
}

helmets.orb_helmet = {
    name = "Orb Helmet",
    anim = "warcrawl/helmets/orbhelmet",
    space = 3,
    stats = {
        sight = 4,
        defense = 1,
    }
}

helmets.triangle_helmet = {
    name = "Advanced Helmet",
    anim = "warcrawl/helmets/spacehelmet",
    space = 3,
    stats = {
        speed = .25,
        strength = 2,
    }
}

helmets.furnace_helmet = {
    name = "Furnace Helm",
    anim = "warcrawl/helmets/furnacehelmet",
    space = 3,
    stats = {
        strength = 2,
        defense = 2,
    }
}

helmets.beetle_helmet = {
    name = "Beetle Helmet",
    anim = "warcrawl/helmets/hornhelmet",
    space = 3,
    stats = {
        strength = 1,
        speed = -.2,
    }
}

helmets.onion_helmet = {
    name = "Onion Helmet",
    anim = "items/helmets/onion_helmet",
    space = 3,
    stats = {
        speed = -.5,
        defense = 3,
        strength = 1
    }
}

helmets.great_helm = {
    name = "Great Helm",
    anim = "items/helmets/greathelm",
    space = 3,
    stats = {
        agility = 2,
        defense = 2,
        sight = -1,
    }
}

helmets.standard_helm = {
    name = "Standard Helmet",
    anim = "items/helmets/standard_helm",
    space = 3,
    stats = {
        defense = 1,
    }
}


helmets.wizard_cap = {
    name ="wizard Cap",
    anim = "items/helmets/wizard_cap",
    useText = "equip"
}


helmets.hunter_hat = {
    name = "Hunter Hat",
    anim = "items/helmets/hunter_hat",
    stats = {
        sight = 1,
        speed = .5
    }
}

helmets.scribe_hat = {
    name = "scribe hat",
    anim = "items/helmets/scribe_hat",
}

glasses.eye_glasses = {
    name = "Seeing glasses",
    anim = "items/glasses/eye_glasses",
    space = 3,
    stats = {
        sight= 3
    },
    
    useText = "equip",

}

local function getHelmetGrade(helm)
    local grade = 1
    for x, i in pairs(helm.stats or {}) do
        grade = grade + (i*(x=="strength" and 1.5 or x=="speed" and 2 or 1))
    end
    
    return helm.grade or grade
end
    

for x, ii in pairs(helmets) do
    ii.isHelmet = true
    ii.useText = ii.useText or "equip"
    ii.grade = getHelmetGrade(ii)
    ii.h = th*2
    i[x] = ii
end

for x, ii in pairs(armour) do
    ii.isArmour = true
    ii.grade = getHelmetGrade(ii)
    ii.useText = ii.useText or "equip" -- if x=="bomb_strap" then error(ii.useText) end
    ii.h = th*2
    i[x] = ii
end


for x, ii in pairs(glasses) do
    ii.isGlasses = true
    ii.grade = getHelmetGrade(ii)
    ii.useText = ii.useText or "equip" -- if x=="bomb_strap" then error(ii.useText) end
    ii.h = th*2
    i[x] = ii
end

function getArmourForCreature(cr, level)
    local lvl = level
    local helmet
    local count = 50
    while not helmet do
        helmet = getValue(helmets)
        if helmet.grade > lvl then
            count = count - 1
            helmet = nil
        end
        if count <= 0 then
            break
        end
    end
    
    if helmet then
        lvl = lvl-helmet.grade
        cr:setHelmet(helmet._id)
        if lvl >= 1 then
            local a
            local count = 50
            while not helmet do
                a = getValue(armour)
                if a.grade > lvl then
                    count = count - 1
                    a = nil
                end
                if count <= 0 then
                    break
                end
            end
            
            if a then
                lvl = lvl-a.grade
                cr:setArmour(a._id)
            end
            
            if lvl >= 1 then
                local v = math.random(lvl)
                if math.random()>.7 and a then
                    if v > 0 then
                        cr.armour:enhance(v)
                    end
                    lvl = lvl - v
                    if lvl > 0 then
                        cr.helmet:enhance(lvl)
                    end
                else
                    if v > 0 then
                        cr.helmet:enhance(a and v or lvl)
                    end
                    lvl = lvl - v
                    if lvl > 0 and a then
                        cr.armour:enhance(lvl)
                    end
                end
            end
        end
    end
end

gac = function(pl,l)
    toybox.room:after(.1,function() getArmourForCreature(pl,l) end)
end