
local weights = {
    common = 60,
    rare = 25,
    ultrarare = 12,
    mythical = 3
}

potions = {}
local potionWeights = {}

function revealPotion(u, p, fake)
    
    if u.isPlayer and not data.knownPotions[p._id] then
        if not fake then
            u:addLog(string.format("The %s must be a %s!", p.name, p.data.oldName))
        end
        data.knownPotions[p._id] = true
        if u.room.inventoryIsOpen then
            u.room:reloadInventoryUI()
        end
    end
end

 function pr() pl:addItem("potion_of_protection") end

local function boilFunction(self)
    if true then
        self.sprite_2 = toybox.new_sprite(self, {
            animations = {
                idle = {
                    source = "items/potion/boil",
                    delay = .15,
                    useImages = true,
                    mode = "loop"
                }
            }
        })
        
        local t = 5000
        self:addLog(string.format("%s is boiling!", self:getName()))
        
        self:shake(5, t, 15)
    end
end

i.potion = {
    source = "items/potion/liquid.png",
    name = "Potion",
    space = 1,
    --color = "red",
    pcolor = "lime",
    life = 1,
    w = tw*.8, h = th*.8,
    
    
    getName = function(self)
        if data.knownPotions[self._id] then
            self.ogName = self.data.oldName
            
            self.name = string.format("%s%s%s %s",
            self.enchants>0 and "&colors.cyan " or "",
            self.enchants>0 and "+" or self.enchants==0 and "" or "-",
            self.enchants ~=0 and self.enchants or "",
            self.ogName) -- self.ogName
            
            self.title = string.format("the %s", self.name)
        end
        
        return string.format("%s%s%s %s",
            self.enchants>0 and "&colors.cyan " or "",
            self.enchants>0 and "+" or self.enchants==0 and "" or "-",
            self.enchants ~=0 and self.enchants or "",
            self.ogName)
    end,
    
    postMake = function(self)
        self.image1 = self:add_image("items/potion/liquid.png")
        self.image1.color = lume.copy(getColor(self.data.pcolor))
        self.ogColor = getColor(self.data.pcolor)
        
        self.image2 = self:add_image("items/potion/shading.png")
        
        self.image3 = self:add_image("items/potion/bottle.png")
        
        self.doBoil = boilFunction
        
        self.isPotion = true
    end,
    
    useText = "drink",
    onUse = function(self, user)
        local tile = user.tile
        if self.data.doGas then
            local b = buffs[self.buff] or self.buff
            Gas:new({
                source = tile,
                buff = self.buff,
                buffIntensity = (self.intensity or 10)+self.grade-1,
                buffTime = self.buffTime or b.getTime(self.grade),
                lifeBonus = -(self.data.gasAttack or 0),
                corrosive = self.data.corrosive or nil,
                color = self.pcolor or self.data.pcolor
            })
            user:addLog(string.format("%s gas gushes out of the bottle!", b.name))
            
        elseif self.buff then
            local b = buffs[self.buff] or self.buff
            user:applyBuff(self.buff, self.buffTime or b.getTime(self.grade), self.intensity or b.getValue(self.grade))
            if b.text then
                -- user:addLog(string.format(b.text, user.title))
            end
        end
        
        
        self.used = true
        self:getAttacked(user, 1)--.life = self.life - 1
        
        if user.isPlayer then --self.isSeen then
            revealPotion(user, self)
        end
    end,
    
    onDestroyed = function(self)
        
        for x = 1, 0 do--1, 4 do
            local d = dirs4[x]
            local t = self.room:getTile(self.tile._x+d[1], self.tile._y+d[2])
            if t then
            end
        end
        
        if self.tile and self.data.doGas and not self.used then
            self.tile:addPuddle(getPuddle(self))
        end
    end,
    
    onThrow = function(self, tile)
        if self.data.doGas then
            local b = buffs[self.buff] or self.buff
            Gas:new({
                source = tile,
                buff = self.buff,
                buffIntensity = (self.intensity or 10)+self.grade-1,
                buffTime = self.buffTime or b.getTime(self.grade),
                lifeBonus = -(self.data.gasAttack or 0),
                corrosive = self.data.corrosive or nil,
                color = self.pcolor or self.data.pcolor
            })
        else
            if self.buff and tile.unit then
                local user = tile.unit
                local b = buffs[self.buff] or self.buff
                user:applyBuff(self.buff, self.buffTime or b.getTime(self.grade), self.intensity or b.getValue(self.grade))
                if b.text then
                    -- user:addLog(string.format(b.text, user.title))
                end
            elseif tile.unit then
                self:onUse(tile.unit)
            end
        
        end
        
        if self.isSeen then
            revealPotion(self.room.player, self)
        end
        
        self.intensity = (self.intensity or 1)/4
        self:onDestroyed()
        
        self.room:removeItem(self)
    
    end,
    
    onFire = function(self, user)
        
        tile = user.tile or user
        Fire:new({
            source = tile,
            intensity = self.intensity+self.grade-1,
            range = 3*self.grade,
            forceSpread = true,
            explode = self.explode,
        })
        
        
        if user.isSeen or (tile.canBeSeen and tile:canBeSeen()) then
            revealPotion(self.room.player, self)
        end
        
        
        if not tile.isTile then
            self:getAttacked(1)--.life = self.life - 1
        else
            self.room:removeItem(self)
        end
    end,
    
    onHeal = function(self, user)
        user:heal(5*self.grade)
        
        if user.poisoned > 0 or user.confused > 0 or user.paralyzed > 0 then
            user.poisoned = 0
            user.confused = 0
            user.paralyzed = 0
            user.blinded = 0
            user:addLog(string.format("%s afflictions go away.", user.title))
        end
        
        user:addLog(string.format("%s feels much better.", user.title))
        
        if user.tile and user.isSeen then
            revealPotion(self.room.player, self)
        end
            
        self:getAttacked(1)
    end,
    
    
    onLife = function(self, user)
    
        user.totalHealth = user.totalHealth + math.floor(user.totalHealth * .3)
        user.maxHealth = user.totalHealth
        
        user:heal(user.maxHealth-user.stats.health)
        
        if user.poisoned > 0 or user.confused > 0 or user.paralyzed > 0 then
            user.poisoned = 0
            user.confused = 0
            user.paralyzed = 0
            user.blinded = 0
            user:addLog(string.format("%s afflictions go away.", user.title))
        end
        
        user:addLog(string.format("%s feels much healthier!", user.title))
        
        if user.tile and user.isSeen then
            revealPotion(self.room.player, self)
        end
        
        
            
        self:getAttacked(1)
    end,
   
    
    onLight = function(self, user)
        user = user.isTile and (user.unit or user.item) or user
        if user and user.isCreature then
            local b = buffs.light
            user:applyBuff("light",b.getTime(self.grade),b.getValue(self.grade))
            if user.isPlayer then
                user.room:reloadFov()
            end
        elseif user and (user.tile or user.isTile) then
            local tile = user.tile or user
            tile:addLog("the area brightens up!")
            tile.room:addLight(tile, self.grade+2, "cyan")
        end
        
        
        if user and ((user.tile and user.isSeen) or (user.canBeSeen and user:canBeSeen())) then
            revealPotion(self.room.player, self)
        end
        
        self:getAttacked(1)
    end,
    
    onHaste = function(self, user)
        user = user.isTile and (user.unit or user.item) or user
        if user and user.isCreature then
            user:addLog(string.format("%s feels faster.", user.title))
            local b = buffs.haste
            user:applyBuff("haste",b.getTime(self.grade),b.getValue(self.grade))
            
        elseif user and user.isTree then
            if not user.fullyGrown then
                user:addLog(string.format("%s grows faster!", user.title))
                user:grow(self.grade)
            else
                user:addLog(string.format("%s seems to grow a little.", user.title))
            end
            
        end
        
        
        if user and user.tile and user.isSeen then
            revealPotion(self.room.player, self)
        end
        
        self:getAttacked(1)
    end,
    
    onPetrify = function(self, user)
        if user then
            user:addLog(string.format("%s turned to stone!", user.title))
            local b = buffs.petrify
            user:applyBuff("petrify",b.getTime(self.grade),b.getValue(self.grade))
        end
        
        
        if user.tile and user.isSeen then
            revealPotion(self.room.player, self)
        end
        
        self:getAttacked(1)
    end,
    
    update = function(self, dt)
        if self.color then
            local r = getColor(self.color)
            local og = getColor(self.ogColor)
            local c = self.image1.color
            
            -- c[1], c[2], c[3] = 1,1,1--og[1]+r[1], og[2]+r[2])/2
            -- c = multiply(c, og or colors.white)--, r)
        else
            
            self.name_tag = ","
            local og = self.ogColor
            local c = self.image1.color
            c[1], c[2], c[3] = og[1], og[2], og[3]
        end
        
        self.image1.light_alpha = self.light_alpha
    end
}




local function iceFunc(self, user)
    local t = self.tile or user.tile or user.isTile and user
    for g  = 1, 2*self.grade do
      for x = 1, 8+1 do
        local d = dirs8[x] or {0,0}
        local t = self.room:getTile(d[1]+t._x*g, d[2]+t._y*g)
        
        if t and not t:isSolid() then
            local te = t:getTemperature()
            local gg = (g == 2 and 5 or 10)
            t:increaseTemperature(-self.grade*3)
            if te <= 10 then
                t:spawnIce(gg+(self.grade*2))
            else
                t:addLog("You hear the sizzle of steam.")
            end
        end
      end
    end
    
    
    if self.isSeen then
        revealPotion(self.room.player, self)
    end
    
    self:getAttacked(1)
end

local polyTable = {
    goblin = 4,
    rat = 10,
    skeleton = 3
}

local function polymorph(self, user)
    local polyTab = polyTable
    if self.grade > 1 then
        polyTab = lume.copy(polyTable)
        for x = 1, self.grade - 1 do
            for xx, i in pairs(polyTab) do
                if i < 5 then
                    polyTab[xx] = i + 3
                else
                    polyTab[xx] = i + (i>15 and 0) or 1
                end
            end
        end
    end
    
    local cr = lume.weightedchoice(polyTab)
    user:polymorph(cr, self.grade*5)
    
    if user.tile and user.isSeen then
        revealPotion(self.room.player, self)
    end
            
    self:getAttacked(1)
end

local function strengthen(self, user)
    user.stats.strength = user.stats.strength + 1*self.grade
    if user.isPlayer then
        user:addLog("You feel stronger!")
    else
        user:addLog(string.format("%s looks stronger!",user.title))
    end
    
    
    if user.isPlayer or (user.isSeen) then
        revealPotion(self.room.player, self)
    end
    
    self:getAttacked(1)
end

local function teleport(self, user)

    self.room:addEnchantLight(user.tile, 8, "yellow")
    
    self.room:teleport(user, nil, true)
    
    if user.isPlayer or user.isSeen then
        revealPotion(self.room.player, self)
    end
    
    self:getAttacked(1)
end

local function descend(self, user)
    local t = self.tile or user.tile or user.isTile and user
    
    for g  = 1, 2*self.grade do
      for x = 1, 8+1 do
        local d = dirs8[x] or {0,0}
        local t = self.room:getTile(d[1]+t._x*g, d[2]+t._y*g)
        
        if t and not t:isSolid() then
            t.toSolidify = self.grade+(self.grade*2-g)
            t.chasm = true
        end
      end
    end
end

function getPotion(utility, rarity, name, color, buff, intensity, gas, light, postMake, boilingPoint, boilTo)
    local p = lume.copy(i.potion)
    p.name = name
    --p.color = color
    p.pcolor = color
    p.intensity = intensity or nil
    
    p.boilingPoint = boilingPoint
    p.boilTo = boilTo
    
    if p.boilTo then assert(p.boilingPoint, name) end
    
    p.nutrition = lume.max(1, utility+1)
    
    p.buff = buff
    p.doGas = gas-- == true and nil or gas
    p.light = light or (light == nil and {2, color})
    p.utility = utility
    p.isPotion = true
    
    potionWeights[p.name] = getValue(weights[rarity or "common"])
    potions[p.name] = p
    
    if postMake then
        postMake(p)
    end
    
    p._oldP_OnThrow = p.onThrow
    
    p.onThrow = function(self, ...)
        self:play_sound("glass")
        return self.data._oldP_OnThrow(self, ...)
    end
    
    return p
end

local potionColors = {
    "tan", "turquoise", "white", "red", "yellow",
    "orange", "blue", "cyan", "purple", "green",
    "gray", "brown", "pink", "lime", "violet",
    "bronze","gold","fuchsia","magenta", "emerald",
    "crimson"
}

local relatedPotions
data.knownPotions = {}
math.randomseed(love.timer.getTime())

local T = TEMPERATURES

function shufflePotions()
    data.knownPotions = {}
    
    local pcolors = lume.copy(potionColors)
    local relatedPotions = {}
    local allPotions = lume.keys(potions)
    local p2 = lume.keys(potions)
    lume.shuffle(p2)
    
    for xp = 1, #p2 do
        local name = p2[xp]
        local potion = potions[name]
        
        if #pcolors == 0 then
            error(string.format("%s is not enough colors for the %s potions!", #potionColors, #p2))
        end
        
        color = lume.eliminate(pcolors)
        potion.oldName = potion.oldName or potion.name
        potion.name = string.format("&colors.%s %s potion~", UNKNOWN_COLOR, color)
        potion.oldPcolor = potion.oldPcolor or potion.pcolor
        potion.pcolor = color
        potion.light[2] = color
        
        
        lume.remove(allPotions, name)
        
        relatedPotions[name] = relatedPotions[name] or {}
        local rp = relatedPotions[name]
        
        local allPotions2 = lume.copy(allPotions)
        
        if not rp[1] and #allPotions>0 then
            local p = lume.eliminate(allPotions2)
            rp[1] = p
            relatedPotions[p] = relatedPotions[p] or {name}
            
            if relatedPotions[p][1] ~= name then
                assert(not relatedPotions[p][2])
                relatedPotions[p][2] = name
                lume.remove(allPotions, p)
            end
        end
        
        
        if not rp[2] and #allPotions2>0 then
            local p = getValue(allPotions2)
            rp[2] = p
            relatedPotions[p] = relatedPotions[p] or {name}
            
            if relatedPotions[p][1] ~= name then
                assert(not relatedPotions[p][2])
                relatedPotions[p][2] = name
                lume.remove(allPotions, p)
            else
                assert(not relatedPotions[p][2])
                relatedPotions[p][2] = rp[1]
                lume.remove(allPotions, p)
            end
            
            relatedPotions[rp[1]][2] = p
            lume.remove(allPotions, rp[1])
        end
        
        local rp1, rp2
        if rp[1] then
            rp1 = string.format("&colors.%s %s ~", potions[rp[1]].oldPcolor or potions[rp[1]].pcolor, rp[1])
        end
        
        if rp[2] then
            rp2 = string.format("&colors.%s %s ~", potions[rp[2]].oldPcolor or potions[rp[2]].pcolor, rp[2])
        end
        
        potion.oldInfo = potion.oldInfo or potion.info
        potion.info = string.format("Swirling %s liquid fills this flask.\n \n%s",
            color,
            #rp>0 and string.format("From your @knowledge ~ it's either a %s%s or &colors.%s %s ~",
                rp1, rp[2] and string.format(", %s",rp2) or "", potion.oldPcolor, name) or
            "What could it be?"
        )
        
    
    
    end
    
    -- error(inspect(relatedPotions,3))
end




function getRandomPotion()
    return potions[lume.weightedchoice(potionWeights)]
end

--[[
Utility ([int] or function(user))
    3   - instant saving grace
    2   - pretty good advantage
    1   - better than nothing
    0   - meh
    -1  - hmph, devious
    -2  - wow, that's bad
    -3  - pure evil. Very faily
    
    
]]

-- heheh, crum
local C, R, U, M = "common", "rare", "ultrarare", "mythical"

local TI, TH, TW, TC, TF = T.INFERNO, T.HOT, T.WARM, T.COLD, T.FREEZING


--[[
rage - might

fr stone
lign - vege
magical str
stone water
nulling water
blinding water
sight bkinding
agility speed
protec - stone
]]

i.potion_of_might = getPotion(3, R, "Potion of might", "skyblue", "might", nil, false, nil, nil, TH, "potion_of_protection")
i.potion_of_protection = getPotion(3, R, "Potion of protection", "violet", "protect", nil, false,nil,nil,TH,"potion_of_petrification")
i.potion_of_levitation = getPotion(2, C, "Potion of levitation", "teal", "levitate", nil, false, nil, nil, TC, "potion_of_descent")
i.potion_of_blinding = getPotion(-2, U, "Potion of blinding", "darkgrey", "blind", nil, false)
i.potion_of_invisibility = getPotion(2, C, "Potion of invisibility", "lightgrey", "invisible", nil, false, nil, nil, TH, "potion_of_water")
i.potion_of_confusion = getPotion(-2, C, "Potion of confusion", "lightpink", "confuse", 12, true,nil,nil,TH,"potion_of_polymorphing")
i.potion_of_paralysing = getPotion(-3, R, "Potion of paralysing", "lightpink", "paralyse", 12, true,nil,nil,TH,"potion_of_confusion")
i.potion_of_incineration = getPotion(-1, C, "Potion of incineration", "orange", nil, 5, nil, nil, function(p)
    p.onUse = p.onFire
    p.onThrow = p.onFire
end, TI, "potion_of_explosion")

i.potion_of_explosion = getPotion(-1, C, "Potion of explosion", "orange", nil, 5, nil, nil, function(p)
    p.explode = true
    p.onUse = p.onFire
    p.onThrow = p.onFire
end)

i.potion_of_water = getPotion(3, R, "Potion of water", "cyan", nil, 5, nil, nil, function(p)
end)

i.potion_of_methane = getPotion(3, R, "Potion of methane", "lightorange", nil, 5, nil, nil, function(p)
    p.flamibility = 12
end, TH, "potion_of_explosion")

i.potion_of_strength = getPotion(3, U, "Potion of strength", "lightred", nil, 5, nil, nil, function(p)
    p.onUse = p.strengthen
end)

i.potion_of_haste = getPotion(3, C, "Potion of haste", "lightorange", nil, 5, nil, nil, function(p)
    p.onUse = p.onHaste
    p.onThrow = p.onHaste
end, TI, "potion_of_teleportation")

i.potion_of_light = getPotion(3, C, "Potion of light", "orange", nil, 5, nil, nil, function(p)
    p.onUse = p.onLight
    p.onThrow = p.onLight
end)

i.potion_of_descent = getPotion(3, C, "Potion of descent", "orange", nil, 5, nil, nil, function(p)
    p.onUse = descend
    p.onThrow = descend
end, TI, "potion_of_water")

i.potion_of_polymorphing = getPotion(0, R, "Potion of polymorphing", "lightpurple", nil, 5, nil, nil, function(p)
    p.onUse = polymorph
end)


i.potion_of_teleportation = getPotion(1, R, "Potion of teleportation", "yellow", nil, 5, nil, nil, function(p)
    p.onUse = teleport
end, TH, "potion_of_invisibility")

i.potion_of_healing = getPotion(3, C, "Potion of healing", "lime", nil, 5, nil, nil, function(p)
    p.onUse = p.onHeal
    --p.onThrow = p.onFire
end, TH, "potion_of_might")

i.potion_of_life = getPotion(3, U, "Potion of life", "cyan", nil, 5, nil, nil, function(p)
    p.onUse = p.onLife
    --p.onThrow = p.onFire
end, TI, "potion_of_strength")

i.potion_of_frost = getPotion(-1, U, "Potion of frost", "lime", nil, 5, nil, nil, function(p)
    p.onUse = iceFunc
    
    p.onThrow = iceFunc
end)

--i.potion_of_ice = getPotion(-1, U, "Potion of ice", "lime", nil, 5, nil, nil, function(p)
--    p.onUse = p.onHeal
    --p.onThrow = p.onFire
--end)


i.potion_of_petrification = getPotion(-3, U, "Potion of petrification", "lightblue", nil, 5, nil, nil, function(p)
    p.onUse = p.onPetrify
    --p.onThrow = p.onFire
end)


for x, val in pairs(i) do
    if val.boilTo then
        assert(i[val.boilTo], val.boilTo)
    end
end