
local weights = {
    common = 60,
    rare = 25,
    ultrarare = 12,
    mythical = 3
}

rings = {}
local ringWeights = {}

function revealRing(u, p, fake)
    
    if u.isPlayer and not data.knownRings[p._id] then
        if not fake then
            u:addLog(string.format("The %s must be a %s!", p.name, p.data.oldName))
        end
        data.knownRings[p._id] = true
        if u.room.inventoryIsOpen then
            u.room:reloadInventoryUI()
        end
    end
end

 function pr() pl:addItem("ring_of_protection") end

i.ring = {
    source = "items/ring/ring_color.png",
    name = "Ring",
    space = 1,
    isRing = true,
    
    --color = "red",
    pcolor = "lime",
    life = 1,
    w = tw*.8, h = th*.8,
    
    
    getName = function(self)
        if data.knownRings[self._id] then
            self.ogName = self.data.oldName
            
            self.name = string.format("%s%s%s %s",
            self.enchants>0 and "&colors.cyan " or "",
            self.enchants>0 and "+" or self.enchants==0 and "" or "-",
            self.enchants ~=0 and self.enchants or "",
            self.ogName) -- self.ogName
            
            self.title = string.format("the %s", self.name)
        end
        
        return string.format("%s%s%s %s",
            self.enchants>0 and "&colors.cyan " or "",
            self.enchants>0 and "+" or self.enchants==0 and "" or "-",
            self.enchants ~=0 and self.enchants or "",
            self.ogName)
    end,
    
    postMake = function(self)
        self.image1 = self:add_image("items/rings/ing_color.png")
        self.image1.color = lume.copy(getColor(self.data.pcolor))
        self.ogColor = getColor(self.data.pcolor)
        
        self.image2 = self:add_image("items/rings/ring.png")
        
        self.isRing = true
    end,
    
    useText = "equip",
    
    onUse = function(self, user)
        local tile = user.tile
        elseif self.buff then
            local b = buffs[self.buff] or self.buff
            user:applyBuff(self.buff, self.buffTime or b.getTime(self.grade), self.intensity or b.getValue(self.grade))
            if b.text then
                -- user:addLog(string.format(b.text, user.title))
            end
        end
        
        
        self.used = true
        self:getAttacked(user, 1)--.life = self.life - 1
        
        if user.isPlayer then --self.isSeen then
            revealRing(user, self)
        end
    end,

}



function getRing(utility, rarity, name, color, buff, intensity, gas, light, postMake)
    local p = lume.copy(i.ring)
    p.name = name
    --p.color = color
    p.pcolor = color
    p.intensity = intensity or nil
    
    p.nutrition = lume.max(1, utility+1)
    
    p.buff = buff
    p.doGas = gas-- == true and nil or gas
    p.light = light or (light == nil and {2, color})
    p.utility = utility
    p.isRing = true
    
    ringWeights[p.name] = getValue(weights[rarity or "common"])
    rings[p.name] = p
    
    if postMake then
        postMake(p)
    end
    
    return p
end

local ringColors = {
    "tan", "black", "white", "red", "yellow",
    "orange", "blue", "cyan", "purple", "green",
    "gray", "brown", "pink", "lime", "violet",
    "bronze","gold","fuchsia","magenta"
}

local relatedRings
data.knownRings = {}
math.randomseed(love.timer.getTime())

function shuffleRings()
    data.knownRings = {}
    
    local pcolors = lume.copy(ringColors)
    local relatedRings = {}
    local allRings = lume.keys(rings)
    local p2 = lume.keys(rings)
    lume.shuffle(p2)
    
    for xp = 1, #p2 do
        local name = p2[xp]
        local ring = rings[name]
        
        if #pcolors == 0 then
            error(string.format("%s is not enough colors for the rings!", #ringColors))
        end
        
        color = lume.eliminate(pcolors)
        ring.oldName = ring.oldName or ring.name
        ring.name = string.format("&colors.%s %s ring~", UNKNOWN_COLOR, color)
        ring.oldPcolor = ring.oldPcolor or ring.pcolor
        ring.pcolor = color
        
        
        lume.remove(allRings, name)
        
        relatedRings[name] = relatedRings[name] or {}
        local rp = relatedRings[name]
        
        local allRings2 = lume.copy(allRings)
        
        if not rp[1] and #allRings>0 then
            local p = lume.eliminate(allRings2)
            rp[1] = p
            relatedRings[p] = relatedRings[p] or {name}
            
            if relatedRings[p][1] ~= name then
                assert(not relatedRings[p][2])
                relatedRings[p][2] = name
                lume.remove(allRings, p)
            end
        end
        
        
        if not rp[2] and #allRings2>0 then
            local p = getValue(allRings2)
            rp[2] = p
            relatedRings[p] = relatedRings[p] or {name}
            
            if relatedRings[p][1] ~= name then
                assert(not relatedRings[p][2])
                relatedRings[p][2] = name
                lume.remove(allRings, p)
            else
                assert(not relatedRings[p][2])
                relatedRings[p][2] = rp[1]
                lume.remove(allRings, p)
            end
            
            relatedRings[rp[1]][2] = p
            lume.remove(allRings, rp[1])
        end
        
        local rp1, rp2
        if rp[1] then
            rp1 = string.format("&colors.%s %s ~", rings[rp[1]].oldPcolor or rings[rp[1]].pcolor, rp[1])
        end
        
        if rp[2] then
            rp2 = string.format("&colors.%s %s ~", rings[rp[2]].oldPcolor or rings[rp[2]].pcolor, rp[2])
        end
        
        ring.oldInfo = ring.oldInfo or ring.info
        ring.info = string.format("Swirling %s liquid fills this flask.\n \n%s",
            color,
            #rp>0 and string.format("From your @knowledge ~ it's either a %s%s or &colors.%s %s ~",
                rp1, rp[2] and string.format(", %s",rp2) or "", ring.oldPcolor, name) or
            "What could it be?"
        )
        
    
    
    end
    
    -- error(inspect(relatedRings,3))
end




function getRandomRing()
    return rings[lume.weightedchoice(ringWeights)]
end

--[[
Utility ([int] or function(user))
    3   - instant saving grace
    2   - pretty good advantage
    1   - better than nothing
    0   - meh
    -1  - hmph, devious
    -2  - wow, that's bad
    -3  - pure evil. Very faily
    
    
]]

-- heheh, crum
local C, R, U, M = "common", "rare", "ultrarare", "mythical"

i.ring_of_might = getRing(3, R, "Ring of might", "skyblue", "might", nil, false)
i.ring_of_protection = getRing(3, R, "Ring of protection", "violet", "protect", nil, false)
i.ring_of_levitation = getRing(2, C, "Ring of levitation", "teal", "levitate", nil, false)
i.ring_of_blinding = getRing(-2, U, "Ring of blinding", "darkgrey", "blind", nil, false)
i.ring_of_invisibility = getRing(2, C, "Ring of invisibility", "lightgrey", "invisible", nil, false)
i.ring_of_confusion = getRing(-2, C, "Ring of confusion", "lightpink", "confuse", 12, true)
i.ring_of_paralysing = getRing(-3, R, "Ring of paralysing", "lightpink", "paralyse", 12, true)
i.ring_of_incineration = getRing(-1, C, "Ring of incineration", "orange", nil, 5, nil, nil, function(p)
    p.onUse = p.onFire
    p.onThrow = p.onFire
end)


i.ring_of_strength = getRing(3, U, "Ring of strength", "lightred", nil, 5, nil, nil, function(p)
    p.onUse = p.strengthen
end)

i.ring_of_haste = getRing(3, C, "Ring of haste", "lightorange", nil, 5, nil, nil, function(p)
    p.onUse = p.onHaste
    p.onThrow = p.onHaste
end)

i.ring_of_polymorphing = getRing(0, R, "Ring of polymorphing", "lightpurple", nil, 5, nil, nil, function(p)
    p.onUse = polymorph
end)


i.ring_of_teleportation = getRing(1, R, "Ring of teleportation", "yellow", nil, 5, nil, nil, function(p)
    p.onUse = teleport
end)

i.ring_of_healing = getRing(3, C, "Ring of healing", "lime", nil, 5, nil, nil, function(p)
    p.onUse = p.onHeal
    --p.onThrow = p.onFire
end)

i.ring_of_life = getRing(3, U, "Ring of life", "cyan", nil, 5, nil, nil, function(p)
    p.onUse = p.onLife
    --p.onThrow = p.onFire
end)

i.ring_of_frost = getRing(-1, U, "Ring of frost", "lime", nil, 5, nil, nil, function(p)
    p.onUse = iceFunc
    
    p.onThrow = iceFunc
end)

--i.ring_of_ice = getRing(-1, U, "Ring of ice", "lime", nil, 5, nil, nil, function(p)
--    p.onUse = p.onHeal
    --p.onThrow = p.onFire
--end)


i.ring_of_petrification = getRing(-3, U, "Ring of petrification", "lightblue", nil, 5, nil, nil, function(p)
    p.onUse = p.onPetrify
    --p.onThrow = p.onFire
end)