local i = data.items


i.angel_statue = {
    source = "items/statues/angel_statue.png",
    name = "Angel Statue",
    isObstacle = true,
    life = 80,
    w = tw*1.6,
    h = th*1.6*2,
    light = {2,"white"},
    
    postMake = function(self)
        self.offset_y = self.offset_y
    end,
    
    onDamaged = function(self, attacker, n)
        if self.life<=70 then -- going to 3
            if attacker.applyBuff then
                attacker:applyBuff("blasphemy",2,1)
            end
            self.life = self.done1000 and self.life or 1000
        elseif self.life > 100 and self.attackedDone == 1 then
            self.life = 4
            self.done1000 = true
        elseif self.life > 100 then
            self.attackedDone = (self.attackedDone and 1) or true
        end
        
    end,
    
    onDestroyed = function(self, attacker, n)
        self.isObstacle = false
        self.room.timer:after(1,function()
            local c = self.room:spawn("angel", self.tile)
            local s = (c.sprite or c)
            s.image_alpha = 0
            self.room:tween(.5, c.sprite or c, {image_alpha=1}, "in-quad")
            self.room:addLight(self.tile,15,"yellow",1)
        end)
    end
}

i.portal ={
    anim = "items/portal",
    name = "Angel Statue",
    isObstacle = true,
    framjeDelay =.3,
    life = 80,
    w = 200,
    h = 234,--th*1.6*2,
    light = {3,"lightblue"},
    
    postMake = function(self)
        self.offset_y = self.offset_y self.va = 360
    end,
    
    onDamaged = function(self, attacker, n)
        if self.life<=70 then -- going to 3
            if attacker.applyBuff then
                pl:applyBuff("blasphemy",2,1)
            end
            self.life = self.done1000 and self.life or 1000
        elseif self.life > 100 and self.attackedDone == 1 then
            self.life = 4
            self.done1000 = true
        elseif self.life > 100 then
            self.attackedDone = (self.attackedDone and 1) or true
        end
        
    end,
    
    onDestroyed = function(self, attacker, n)
        self.isObstacle = false
        self.room.timer:after(1,function()
            local c = self.room:spawn("angel", self.tile)
            local s = (c.sprite or c)
            s.image_alpha = 0
            self.room:tween(.5, c.sprite or c, {image_alpha=1}, "in-quad")
            self.room:addLight(self.tile,15,"yellow",1)
        end)
    end
}

i.cursed_statue = {
    source = "items/statues/cursed_statue.png",
    name = "Cursed Statue",
    isObstacle = true,
    life = 80,
    w = tw*1.6,
    h = th*1.6*2,
    light = {2,"lightgrey"},
    
    postMake = function(self)
        self.offset_y = self.offset_y
        self.glow_image = self:add_image("items/statues/cursed_statue_eyes.png")
    end,
    
    onDamaged = function(self, attacker, n)
        if self.life<=76 then -- going to 3
            if self.saidFool == nil then
                self:addLog('&colors.crimson # "Fool"...')
                Creature.speak(self, "#fool", "red", 3)
                
                self.saidFool = true
                self.room.camera:shake(10,4,10)
                self.room:addLight(self.tile, 3, "red", 2.55)
                Creature.zoomIn(self,2,1.3)
            elseif self.saidFool == 1 then
                self:addLog('&colors.crimson # "Fool"...')
                Creature.speak(self, "#fool", "red", 3)
                local lColors = {"crimson", "red", "lightred"}
                
                for x = 1, 2 do
                    local t
                    for i = 1, 4 do
                        t = self.tile.roomData:getRandomSpaceTile()
                        if t:isFree() then
                            break
                        else
                            t = nil
                        end
                    end
                    
                    if t then
                        self.team = "curse"
                        local e = attacks.summon(self, "electric_ball", t)
                        e.lightningColors = lColors
                        e.light = {5,"crimson"}
                        local val = 3
                        e.stats.health = val
                        e.stats.maxHealth = val
                    end
                end
                
                self.saidFool = false -- off
                
            elseif self.saidFool == true then
                self.saidFool = 1
            elseif self.saidFool == false then
                self.saidFool = nil   -- repeat
            end
                    
        elseif self.life > 100 and self.attackedDone == 1 then
            self.life = 4
            self.done1000 = true
        elseif self.life > 100 then
            self.attackedDone = (self.attackedDone and 1) or true
        end
        
    end,
    
    onDekstroyed = function(self, attacker, n)
        self.isObstacle = false
        self.room.timer:after(1,function()
            local c = self.room:spawn("angel", self.tile)
            c.sprite.image_alpha = 0
            self.room:tween(.5, c.sprite, {image_alpha=1}, "in-quad")
            self.room:addLight(self.tile,15,"yellow",1)
        end)
    end
}