
i.pooleaf = {
    name = "pooleaf",
    source = "plants/pooleaf",
    growthTime = 9,
    life = 45,
    
    class = "Tree",
    
    isObstacle = true,
    flammability = 4,
    noPickup = true,
    
    updateTurn = function(self) log("p")
        if lume.distance(self.x, self.y, self.room.player.x, self.room.player.y)/tw>50 then
            return
        end log("pppp")
        
        if self.fullyGrown then
            self.pooTime = (self.pooTime or 2)-1
            if self.pooTime <= 0 then
                self.pooTime = 7
                Gas:new({
                    tile=self.tile,
                    flammability = 1,
                    color = gasColors.stinky,
                    range = 1.5,
                })
                
            end
        end
    end
}

i.pooleaf_seed = {
    name = "seed of pooleaf",
    source = "plants/seeds/pooleaf.png",
    isSeed = true,
    
    onThrow = function(self, tile)
        tile.room:removeItem(self)
        tile.room:spawnItem("pooleaf", tile)
    end,
    
    onUse = function(self)
        self:onThrow(self.user.tile)
    end
}

i.flamesprout = {
    name = "flamesprout",
    source = "plants/flamesprout",
    growthTime = 12,
    life = 5,
    
    class = "Tree",
    
    isObstacle = true,
    flammability = 4,
    noPickup = true,
    light = {5,"lightred"},
    
    onDeath = function(self)
        if self.growth < .4 then
            Fire:new({source=self.tile, range=1})
        elseif self.growth >= .4 then
            Fire:new({
                source = self.tile,
                explode = true,
                range = lume.min(self.growth*10, 3),
            })
        end
    end,
    
    updateTurn = function(self)
        if lume.distance(self.x, self.y, self.room.player.x, self.room.player.y)/tw>50 then
            return
        end
        
        if self.fullyGrownnil then
            self.pooTime = (self.pooTime or 2)-1
            if self.pooTime <= 0 then
                self.pooTime = 7
                Gas:new({
                    tile=self.tile,
                    flammability = 1,
                    color = gasColors.stinky,
                    range = 1.5,
                })
                
            end
        end
    end
}

i.flamesprout_seed = {
    name = "seed of flamesprout",
    source = "plants/seeds/flamesprout.png",
    isSeed = true,
    
    
    onThrow = function(self, tile)
        tile.room:removeItem(self)
        local t = tile.room:spawnItem("flamesprout", tile)
    end,
    
    onUse = function(self)
        self:onThrow(self.user.tile)
        
        if self.explodingVariant then
            if self.growth < .4 then
                Fire:new({source=self.tile, range=1})
            elseif self.growth >= .4 then
                Fire:new({
                    source = self.tile,
                    explode = true,
                    range = lume.min(self.growth*10, 3),
                })
            end
        end
    end
}


local explodingTitle = "&colors.lightred exploding ~"

i.fadeleaf = {
    name = "fadeleaf",
    source = "plants/fadeleaf",
    growthTime = 8,
    life = 5,
    
    class = "Tree",
    
    isObstacle = false,
    flammability = 4,
    noPickup = true,
    light = {5,"lightgreen"},
    
    
    postMake = function(self)
        self.explodingVariant = 1
        if self.explodingVariant then
            self.light = {5,"lightred"}
            self._ogEName = self.name
            self.name = string.format("%s fadeleaf", explodingTitle)
            self.title = string.format("the %s", self.name)
        end
    end,
    
    onDeath = function(self)
        if self.explodingVariant then
            if self.growth < .4 then
                Fire:new({source=self.tile, range=1})
            elseif self.growth >= .4 then
                Fire:new({
                    source = self.tile,
                    explode = true,
                    range = lume.min(self.growth*10, 3),
                })
            end
        end
    end,
    
    onSteppedOn = function(self, dmger)
        if dmger then
            dmger.room:teleport(dmger)
            self:getAttacked(5)
        end
    end,
    
    updateTurn = function(self)
        if lume.distance(self.x, self.y, self.room.player.x, self.room.player.y)/tw>50 then
            return
        end
        
        if self.fullyGrownnil then
            self.pooTime = (self.pooTime or 2)-1
            if self.pooTime <= 0 then
                self.pooTime = 7
                Gas:new({
                    tile=self.tile,
                    flammability = 1,
                    color = gasColors.stinky,
                    range = 1.5,
                })
                
            end
        end
    end
}

i.fadeleaf_seed = {
    name = "seed of fadeleaf",
    source = "plants/seeds/fadeleaf.png",
    isSeed = true,
    
    postMake = function(self)
        self.explodingVariant = nil
        if self.explodingVariant then
            self.itemColor = "hotpink"
            self.name = string.format("%s seed of fadeleaf", explodingTitle)
            self.title = string.format("the %s", self.name)
        end
    end,
    
    onThrow = function(self, tile)
        
        if tile.unit then
            tile.room:teleport(tile.unit)
            tile.room:removeItem(self)
            return
        end
        
        if tile.iterm then --?? not working
            tile.room:teleport(tile.item, tile)
            tile.room:removeItem(self)
            return
        end
        
        tile.room:removeItem(self)
        
        local t = tile.room:spawnItem("flamesprout", tile)
        
        if self.explodingVariant then
            t.light = {t.light[1], "hotpink"}
            t.name = string.format("%s fadeleaf", explodingTitle)
            t.title = string.format("the %s", t.name)
        else
            t.light = {t.light[1], "lightgreen"}
            t.name = t._ogEName
            t.title = string.format("the %s", t.name)
        end
        
        t.explodingVariant = self.explodingVariant
    end,
    
    onUse = function(self)
        self:onThrow(self.user.tile)
    end
}


i.watersprout = {
    name = "watersprout",
    source = "plants/watersprout",
    growthTime = 12,
    life = 5,
    
    class = "Tree",
    color = "lightblue",
    
    isObstacle = true,
    flammability = 4,
    noPickup = true,
    light = {3,"skyblue"},
    
    onDeath = function(self)
        if self.growth < .4 then
            self.tile:addWater({
                value = 1,
            }, true)
        elseif self.growth >= .4 then
            self.tile:addWater({
                value = 5,
            }, true)
        end
    end,
    
    updateTurn = function(self)
        if lume.distance(self.x, self.y, self.room.player.x, self.room.player.y)/tw>50 then
            return
        end
        
    end
}

i.watersprout_seed = {
    name = "seed of watersprout",
    source = "plants/seeds/watersprout.png",
    isSeed = true,
    
    
    onThrow = function(self, tile)
        tile.room:removeItem(self)
        local t = tile.room:spawnItem("watersprout", tile)
    end,
    
    onUse = function(self)
        self:onThrow(self.user.tile)
    end
}


i.poisonleaf = {
    name = "poison leaf",
    source = "plants/poisonleaf",
    color = "purple",
    growthTime = 3,
    life = 5,
    
    class = "Tree",
    
    isObstacle = false,
    flammability = 4,
    noPickup = true,
    light = {3,"pink"},
    
    onDeath = function(self)
    end,
    
    
    onSteppedOn = function(self, dmger)
        if dmger then
            self:getAttacked(2)
            dmger:applyBuff("poison", 4, 4)
            dmger:addLog(string.format("The poison leaf ... @ &colors.purple poisoned ~ %s!", dmger.title))
        end
    end,
  
}

i.poisonleaf_seed = {
    name = "seed of poison leaf",
    source = "plants/seeds/poisonleaf.png",
    isSeed = true,
    
    
    onThrow = function(self, tile)
        tile.room:removeItem(self)
        local t = tile.room:spawnItem("poisonleaf", tile)
    end,
    
    onUse = function(self)
        self:onThrow(self.user.tile)
    end
}

i.frostflower = {
    name = "watersprout",
    source = "plants/frostflower",
    growthTime = 6,
    life = 5,
    
    class = "Tree",
    
    isObstacle = true,
    flammability = 4,
    noPickup = true,
    light = {3,"skyblue"},
    
    onDeath = function(self)
        for x = 1, 3 do
            for i = 1, 8 do
                local dx = dirs8[i][1]
                local dy = dirs8[i][2]
                local ti = self.room:getTile(self.tile._x+dx, self.tile._y+dy)
                if ti then
                    ti:increaseTemperature(-(4-x))
                end
            end
        end
        
        self.room:addEnchantLight(self.tile, 8, "skyblue")
    end,
    
    color = "skyblue",
        
    updateTurn = function(self)
        if lume.distance(self.x, self.y, self.room.player.x, self.room.player.y)/tw>50 then
            return
        end
        
        if self.fullyGrown and not self.iced then
          for x = 1, 3 do
            for i = 1, 8 do
                local dx = dirs8[i][1]
                local dy = dirs8[i][2]
                local ti = self.room:getTile(self.tile._x+dx, self.tile._y+dy)
                if ti then
                    ti:increaseTemperature(-(4-x))
                end
            end
          end
        
        self.iced = true
        
        end
    end
}

i.frostflower_seed = {
    name = "seed of frost flower",
    source = "plants/seeds/frostflower.png",
    isSeed = true,
    
    
    onThrow = function(self, tile)
        tile.room:removeItem(self)
        local t = tile.room:spawnItem("frostflower", tile)
        tile:increaseTemperature(-2)
    end,
    
    onUse = function(self)
        self:onThrow(self.user.tile)
    end
}