skills = {}
data.skills = skills
local skills = skills

local function nullAttack(cr)
    -- return false so a creature's default attack is called
    cwarn("null attack", "orange")
    return false
end

local function bomberGetAttack(self, other)
    self.cry = nil
    self:cry("Bomb "..(self.hasBomb and "yessss" or "no"))
    
    if self.hasBomb and not self.lighted then
        self.hasBomb:onUse(self)
        self.lighted = self.hasBomb
        self.done = true
        self.bombTarget = other
    elseif self.hasBomb then
        self.lighted = nil
        self.bombTarget = nil
        local i = self:getItem("burning_bomb")
        if i then
            attacks.throwItem(i, self, other.tile)
        end
    else
        return self.oldAttack(self, other)
    end
end

local function bomberCanAttack(self, other)
    self.bombHit = false
    self:cry("att????????")
    
    if self.hasBomb then self:cry("boom")
        
        if attacks.throwWillReach(self.hasBomb, self, other, 7) and not self:tooCloseTo(other) then --throw will hit
            self.bombHit = true cwarn("ye","blue")
            self.thrownBomb = getValue(self.bombWaitAmount) or 3
            return true
        end
        
        if self.lighted then
            return true
        end
    else
        self:cry("no bomb?")
    end
    
    do
        return self.lighted or self.oldCanAttack(self, other)
    end
end

local function updateStart(buff, self)
    self.hasBomb = (self.thrownBomb or 0)<0 and self:getItem("bomb") or self.lighted
    --if self.hasBomb then cwarn("hmm","yellow") end
    self.cry = nil
    self:cry("Bomb?? "..(self.hasBomb and "yes" or "no"))
    self.thrownBomb = (self.thrownBomb or 0)-1
    
end

local function bomberPlayTurn(self, ...)
    if self.lighted then
        return bomberGetAttack(self, self.target or self.bombTarget)
    end
    
    return self._oupdate(self, ...)
end

function makeBomber(cr, lvl)
    local lvl = lvl or 1
    
    if not cr.updatedBombInit then
        cr:onStartTurn(updateStart, 1)
    end
    
    cr.canPickItems = true
    cr.bombLvl = lvl
    cr.closest = 2
    cr.furthest = 7
    cr.sight = 15+lvl
    cr.bombWaitAmount = WARCRAWL and {4,6} or nil
    cr.vision = 15+lvl
    for x = 1, 2*lvl do
        cr:addItem("bomb")
    end
    
    cr.stats.health = cr.maxHealth + 1*lvl
    
    if not cr.updayedBombInit then
        cr.oldCanAttack = cr.canAttack or Creature.canAttack
        cr.oldAttack = cr.getAttack or Creature.getAttack or nullAttack
    
        cr.getAttack = bomberGetAttack
        cr.canAttack = bomberCanAttack
        cr._oupdate = cr.playTurn
        cr.playTurn = bomberPlayTurn
    
        cr.updatedBombInit = true
    end
end

local function throwerGetAttack(self, other)
    
    if self.hasAmmo then
        attacks.throwItem(self.hasAmmo, self, other.tile)
        self.usedGun = 3
    else
        return self.oldAttack(self, other)
    end
end

local function throwerCanAttack(self, other)
    
    if self.hasAmmo then
        if attacks.throwWillReach(self.hasAmmo, self, other, self.throwRange) and not self:tooCloseTo(other) then --throw will hit
            return true
        end
    else
    end
    
    do
        return self.oldCanAttack(self, other)
    end
end

local function throwerUpdateStart(buff, self)
    self.hasAmmo = (self.usedGun or 0)<0 and math.random()>.6 and self:getItem("rock") or self:getItem("stone")
    if self.hasAmmo then
        self:wieldItem(self.hasAmmo)
    end

    self.usedGun = (self.usedGun or 0)-1
    
end

function makeThrower(cr, lvl)
    local lvl = lvl or 1
    
    if true then
        cr:onStartTurn(throwerUpdateStart)
    end
    
    cr.accuracy = 5+lvl
    cr.canPickUp.rock = true
    cr.canPickUp.stone = true
    cr.bombLvl = lvl
    cr.throwRange = 3+lvl
    cr.closest = 2
    cr.furthest = cr.throwRange
    cr.sight = 15+lvl
    cr.vision = 15+lvl
    for x = 1, 6*lvl do
        cr:addItem(x>4 and "stone" or "rock")
    end
    
    cr.stats.health = cr.maxHealth + 1*lvl
    
    if true then
        cr.oldCanAttack = cr.canAttack or Creature.canAttack
        cr.oldAttack = cr.getAttack or nullAttack--Creature.doAttack
    
        cr.getAttack = throwerGetAttack
        cr.canAttack = throwerCanAttack
        cr._oupdate = cr.playTurn
        cr.playTurn = bomberPlayTurn
    end
    
    
end


local function shooterGetAttack(self, other)
    
    if self.hasAmmo then
        self.usedGun = 3
        self.gun:onTarget(self, other)
    else log("oldshooter attack"..inspect(self.oldsAttack==Creature.getAttack))
        return self.oldsAttack(self, other)
    end
end

local function shooterCanAttack(self, other)
    
    if self.hasAmmo then
        if attacks.throwWillReach(self, self, other, self.gun.range or 9) and not self:tooCloseTo(other) then --throw will hit
         
            return true
        end warn("false cant hit")
        return
    else
    end
    
    do warn("default no ammo")
        return self.oldsCanAttack(self, other)
    end
end

local function shooterUpdateStart(buff, self)
    self.hasAmmo = (self.usedGun or 0)<0 and self.gun:hasAmmo(self)
    if not self.hasAmmo and (self.usedGun or 0)<0 then
        self.closest = self.hasBomb and 5 or 0
        self.furthest = self.hasBomb and 7 or 0
    else
        self.closest = 2
        self.furthest = 5
    end

    self.usedGun = (self.usedGun or 0)-1
    
end

local function shooterPlayTurn(self, ...)
    if self.lighted then
        -- return bomberGetAttack(self, self.target or self.bombTarget)
    end
    
    return self._osupdate(self, ...)
end

function makeShooter(cr)
    cr:onStartTurn(shooterUpdateStart, 1)
    cr.canPickItems = true
    cr.closest = 2
    cr.furthest = 5
    cr.sight = 15
    cr.vision = 15
    cr.gun = cr:addItem("pistol")
    for x = 1, 55 do
        cr:addItem("stone")
    end
    
    cr.oldsCanAttack = cr.canAttack or Creature.canAttack
    cr.oldsAttack = cr.getAttack or Creature.getAttack or nullAttack
    
    cr.getAttack = shooterGetAttack
    cr.canAttack = shooterCanAttack
    cr._osupdate = cr.playTurn
    cr.playTurn = shooterPlayTurn
    
    log("adding skill")
   -- cr:addSkill("bombThrow") log("done skill")
end

function bkob() self:spawn("kobold",pl.tile):addClass("archer") end

function makeBowShooter(cr, lvl)
    cr:onStartTurn(shooterUpdateStart)--, 1)
    cr.canPickUp["arrow"] = true
    cr.closest = 2
    cr.furthest = 3
    cr.sight = 15
    cr.vision = 15
    cr.accuracy = 5+lvl
    cr.gun = cr:forceAddItem("bow")
    assert(cr.gun)
    
    for x = 1, 55 do
        assert(cr:addItem("arrow",nil,nil,nil,nil,true))
    end
    
    
    cr.oldsCanAttack = cr.canAttack or Creature.canAttack
    cr.oldAttack = cr.getAttack or nullAttack-- Creature.doAttack
    cr.oldsAttack = cr.oldAttack

    
    cr.getAttack = shooterGetAttack
    cr.canAttack = shooterCanAttack
    cr._osupdate = cr.playTurn
    cr.playTurn = shooterPlayTurn
    
    assert(cr.gun:hasAmmo(cr))
end

local conj_getAttack = function(self, other)
        self.lastSummoned = (self.lastSummoned or self.maxSummoned or 2)-1
        
        
        if self.lastSummoned <= 0 then
            self.maxSummoned = (self.maxSummoned or 3) + 1
            attacks.summon(self, self.summon_creature or "spectral_blade", self.summon_number, self.team)
            self.lastSummoned = 3
        else
            self:runAwayFrom(other)
            --self.done = true
        end
end

local ang_getAttack = function(self, other)
    self.lastSummoned = (self.lastSummoned or 2)-1
    
    if self.lastSummoned <= 0 then
        local e = attacks.summon(self, "electric_ball",  1, self.team)
        self:addLog(string.format("%s summoned an electric ball", self.title))
        self.lastSummoned = 3
    else
        return Creature.applyDamage(self, other)
    end
end

local ang_attackRange = function(self)
    if (self.lastSummoned or 2) > 0 then
        return 1
    else
        return 6
    end
end

local conj_attackRange = function(self)
    return 4
end

local sneaky_isEnemy = function(self, other)
    if not Creature.isEnemy(self, other) then
        local otherLowHp = other:healthPercentage() <= 30 or other.health <= 2
        if otherLowHp and not other.data == self.data then
            if other.isPlayer then
                other:addLog(string.format("%s finds %s vulnerable...", self.title, other.title))
            end
            
            return true
        end
        
    else
        return false
    end
end

function sneaky_startTurn(n, self)
    local target = self.target or self.foodTarget
    if target then
    
        self.huntPatienceTable[target] = self.huntPatienceTable[target] or self.huntPatience
        
        local impatient = self.huntPatienceTable[target] <= 0
        log("patience "..self.huntPatienceTable[target].."," ..tostring(impatient))
        
        local attack = true
        if target.isCreature and target:inGroup() then
            if self:inGroup() then
                attack = true
            else
                attack = false
            end
        elseif target.isCreature and (target:healthPercentage() <= 30 or target.health <= 2) then
            attack = true
        end
        
        
        if not attack and not impatient then
            self.closest = 2
            self.furthest = 3
            self.huntPatienceTable[target] = self.huntPatienceTable[target] - math.random(1,3)
        else
            self.closest = 0
            self.furthest = 1
            
            if impatient and not attack then
                local t = self:addLog(string.format("%s got impatient waiting to hunt %s!", self.title, target.title))
                warn(string.format("[HUNTING] %s got impatient waiting to hunt %s!", self.title, target.title))
            end
            
            self.huntPatienceTable[target] = self.huntPatienceTable[target] + 1
        end
    end
end
    



local function readerGetAttack(self, other)
    
    if self.hasScroll then
        if self.prompted then
            self.prompted = nil
            self.scrollToRead = nil
            
            if self.cantRead then
                self:addLog(string.format("Oh no! %s can't read!", self.title))
                self.done = true
                self.lastRead = 2
                
                if not self.shinyEyes and self.data.name == "kobold" then
                    local sp = self:add_sprite("creatures/kobold_sad_eyes")
                    sp:syncTo(self.sprite)
                    self.shinyEyes = sp
                end
                
                return
            else
                self:addLog(string.format("%s read &colors.yellow %s!",self.name, self.hasScroll.title))
                self.hasScroll:onUse(self)
                self.done = true
                self.lastRead = 3
                return
            end
            
        else
            self:wield(self.hasScroll)
            self.prompted = true
            self:addLog(string.format("%s gets &colors.yellow %s ~ ready!",self.name, self.hasScroll.unspecific))
            self.scrollToRead = self.hasScroll
            self.done = true
            return
        end
        
    else
        return self.oldAttack(self, other)
    end
end

local function readerCanAttack(self, other)
    
    if self.hasScroll then
        return true
    end
    
    do
        return self.oldCanAttack(self, other)
    end
end

local function readerUpdateStart(buff, self)
    self.lastRead = (self.lastRead or 1)-1
    self.hasScroll = nil
    
    if self.lastRead <=0 then
        local scrolls = not self.scrollToRead and self:getAllItemsOfType("scroll")
        self.hasScroll = self.scrollToRead or lume.randomchoice(scrolls)
    end
end
    


local blowup_getAttack = function(self, enemy)
    if self.armour.data.activate(self.armour, self) then
        self:addLog(string.format("%s &colors.red @activated ~ a bomb!", self.title))
    end
    self.done = 1
    
end

local blowup_attackRange = function(self)
    local r = math.random()
    return r>.9 and 3 or r>.3 and 1 or 2
end

local blowup_onDeath = function(data, self)
    if (math.random() < .7 or self.bombActive) and not self.blown then
        local item = math.random()>.7 and not self.bombActive and "bomb" or "burning_bomb"
        item = self.room:spawnItem(item, self.tile)
        
        self:addLog(string.format("%s dropped %s!", self.title, item.unspecific))
    end
end

local shopkeeper_aggro = function(self, enemy)
    if enemy then
        self:like(enemy, -10)
    end
    
    self.room:addEnchantLight(self.tile, 3, "red")
    
    if self.aggroActive then
        return
    end
    
    self:shake(15,.4,15)
    
    self:addLog(string.format("%s is aggrivated!", self.title))
    self:setWeapon("sword")
    self.stayInRoom = false
    self.patrolsRoom = false
    self.aggroActive = true
    
end

local shopkeeper_merchPickedUp = function(data, self, val, merch)
    self.pickedItems[#self.pickedItems+1] = merch
end

local shopkeeper_merchDestroyed = function(data, self, val, merch)
    shopkeeper_aggro(self, merch.user or merch.oldUser)
end

local shopkeeper_onDamaged = function(data, self, val, att, ent, en)
    if en.isCreature then
        shopkeeper_aggro(self, en)
    end
end

local shopkeeper_updateTurn = function(self, ...)
    self:_o_update(self, ...)
    
    local t = self.tile
    local r = self.shop -- t and t.roomData
    
    if not r then
        return
    end
    
    
    if not self.aggroActive then
    
        for x, ti in ipairs(r.allTiles) do
            local i = ti.item
        
            if i and i.burning then
                local u = i.user
                if u then
                    shopkeeper_aggro(self, u)
                    break
                end
            end
            
            if ti.fires > 1 then
                shopkeeper_aggro(self)
            end
            
        
        end
    
        for x = 1, #self.pickedItems do
            local i = self.pickedItems[x]
            if i then
                if i.isCarried then
                    if i.user.tile.roomData ~= r then
                        shopkeeper_aggro(self, i.user)
                        break
                    end
                    self.tileTarget = i.user.tile
                elseif i.tile and i.tile.roomData ~= r then
                    shopkeeper_aggro(self, i.user or i.oldUser)
                    break
                else
                    table.remove(self.pickedItems, x)
                end
            end
        end
    end
        
end


function io()
    self:after(.1,function()
    local self = toybox.room
    --self:spawn("jackal", pl.tile)
    --self:spawnFromData("boar",pl.tile.roomData)
    
    self:spawn("kobold", pl.tile):addClass("bomber")
    end)
end


skills.sneakyHunter = {
    activate = function(cr, lvl)
        cr.getEnemy = sneaky_isEnemy
        cr:onStartTurn(sneaky_startTurn)
        cr.huntPatience = 6+2*lvl
        cr.huntPatienceTable = {}
    end,
}

skills.read = {
    activate = function(cr, lvl)
    
        local lvl = lvl or 1
    
        if true then
            cr:onStartTurn(readerUpdateStart)
        end

        cr.canPickUp.scroll = true

        cr.closest = 2
        cr.furthest = 5

        for x = 1, 1*lvl do
            cr:addItem("scroll_of_summoning")
        end
    
        cr.stats.health = cr.maxHealth + 1*lvl
    
        if true then
            cr.oldCanAttack = cr.canAttack or Creature.canAttack
            cr.oldAttack = cr.getAttack or nullAttack--Creature.doAttack
    
            cr.getAttack = readerGetAttack
            cr.canAttack = readerCanAttack
            cr._oupdate = cr.playTurn
            cr.playTurn = bomberPlayTurn
        end
    end
}

skills.bombThrow = {
    activate = makeBomber,
    titles = {
        [1] = {"bomber"},
        [3] = {"destroyer"}
    }
}

skills.useBow = {
    activate = makeBowShooter,
    titles = {
        [1] = {"archer"}
    }
}


skills.useGun = {
    activate = makeShooter,
    titles = {
        [1] = {"gunner"}
    }
}

skills.stoneThrow = {
     activate = makeThrower,
     titles = {
        [1] = {"stoner","stone thrower"},
        [2] = {"rock thrower"}
    }
}

skills.shopkeep = {
    activate = function(cr, lvl)
        cr.pickedItems = {}
        
        cr._o_update = cr._updateTurn or null
        cr._updateTurn = shopkeeper_updateTurn
        cr:onDamaged(shopkeeper_onDamaged)
        cr:onMerchandiseDestroyed(shopkeeper_merchDestroyed)
        cr:onMerchandisePickedUp(shopkeeper_merchPickedUp)
        cr.stayInRoom = true
    end
}

skills.blowup = {
    activate = function(cr, lvl)
        cr.closest = 0
        cr.furthest = 0
        cr.attackRange = blowup_attackRange
        cr.getAttack = blowup_getAttack
        cr:onDeath(blowup_onDeath)
    end
}

skills.conjure = {
    activate = function(cr, lvl)
        cr.getAttack = conj_getAttack
        cr.closest = 3
        cr.furthest = 8
        cr.attackRange = conj_attackRange
        cr.summon_number = 1+lvl*2
        cr.summon_creature = "spectral_blade"
    end,
    
    titles = {
        "conjurer",
        [3] = "advanced conjurer",
        [7] = "master conjurer"
    }
}

skills.divinity = {
    activate = function(cr, lvl)
        cr.getAttack = ang_getAttack
        cr.attackRange = ang_attackRange
    end
}

skills.steal = {
    activate = function(cr, lvl)
    
    end
}