creatures.jon = {
    name                   = "&colors.woodbrown Jon ~",
    anim                   = "creatures/buff_dude",
    pitches                = nil,  -- for sound
    
    article               = "the",
    pronoun               = "it",
    pronoun2              = "its",
    
    title                 = nil,   -- default: <article> <name>
    
    team                  = nil,   -- can be function to, like lume.uuid   flipX = -1,
    group = {3,4},
    
    
    food = {
        pig = true,
        meat = true
    },
    
    isHumanoid = true,
    
    leaderValue = 1,
    cowardice = 0,
    life = 140,
    strength = 2,
    defense = 3,
    playerDislike = -5,
    hostlity = 2,
    
    
    --alerter = {0,0,1,0,0,1,2},
    postMake = function(self)
        self:makeNamed("male")
        self.equipped.durability = 1000
    end,
    
    armour = "plate_mail",
    helmet = "great_helm",
    weapon = "sword",
    
    inventory = {"baby_photo", "ice"},

    
    info                  = "-sewer rat",
    
    loot = {},--???
    light = nil, -- {value/range, color}
    
    canPickItems          = false,
    
    skills = {
        -- name = value level,
        -- bomb = {0,0,1}
    },
    
    abilities = {
        -- name = {level=value, ...}
        -- split = {level={0,0,1}}
    },
    
    inventorySpace = 1
}

creatures.sakura = {
    name                   = "&colors.pink Sakura ~",
    anim                   = "creatures/sakura",
    pitches                = nil,  -- for sound
    
    article               = "the",
    pronoun               = "it",
    pronoun2              = "its",
    
    title                 = nil,   -- default: <article> <name>
    
    team                  = nil,   -- can be function to, like lume.uuid   flipX = -1,
    group = {3,4},
    
    
    food = {
        pig = true,
        meat = true
    },
    
    isHumanoid = true,
    
    leaderValue = 1,
    cowardice = 0,
    life = 140,
    strength = 5,
    defense = 3,
    playerDislike = -5,
    hostlity = 2,
    
    --alerter = {0,0,1,0,0,1,2},
    postMake = function(self)
        self:makeNamed("female")
        self:addClass("archer_hunter")
    end,
    
    inventory = {"sakura_journal", {"potion_of_might",2}, "potion_of_healing", nil and "scroll_of_teleportation"},

    
    info                  = "-sewer rat",
    
    loot = {},--???
    light = nil, -- {value/range, color}
    
    canPickItems          = false,
    
    skills = {
        -- name = value level,
        -- bomb = {0,0,1}
    },
    
    abilities = {
        -- name = {level=value, ...}
        -- split = {level={0,0,1}}
    },
    
    inventorySpace = 1,
}

creatures.harry = {
    name                   = "Harry",
    anim                   = "creatures/harry",
    pitches                = nil,  -- for sound
    
    article               = "the",
    pronoun               = "it",
    pronoun2              = "its",
    
    title                 = nil,   -- default: <article> <name>
    
    team                  = nil,   -- can be function to, like lume.uuid   flipX = -1,
    group = {3,4},
    
    
    food = {
        pig = true,
        meat = true
    },
    
    helmet = "wizard_cap",
    glasses = "eye_glasses",
    
    isHumanoid = true,
    
    leaderValue = 1,
    cowardice = 0,
    life = 140,
    strength = 3,
    defense = 3,
    playerDislike = -5,
    hostlity = 2,
    
    --alerter = {0,0,1,0,0,1,2},
    postMake = function(self)
        self:makeNamed("male")
        self:addClass("zapper")
    end,
    
    
    inventory = {"wand_of_lightning", "potion_of_levitation", "wand_of_blinking"},
    
    info                  = "-sewer rat",
    
    loot = {},--???
    light = nil, -- {value/range, color}
    
    canPickItems          = false,
    
    skills = {
        -- name = value level,
        -- bomb = {0,0,1}
    },
    
    abilities = {
        -- name = {level=value, ...}
        -- split = {level={0,0,1}}
    },
    
    inventorySpace = 1,
}

items.baby_photo = {
    name = "Old photo",
    useText = "look",
    source = "items/baby_photo.png",
    onUse = function(self, user)
        user:addLog(string.format("%s looks at %s...",user.title,user.isPlayer and self.title or self.unspecific or self.name))
        if user.isPlayer then
            user:addLog("It's a picture of a baby...")
        end
    end
}

local texts = {
    "Harry is looking so cool today...but he didn't notice my new haircut...",
    "Jon really is a jerk face",
    "I miss the lead, but immortality here I come!",
    "Today was a pretty bad day, I feel like ... no. Not yet. Not now.",
    "I always pick on Kobo but secretly I feel sorry for him",
    "I miss my Mom. I kind of regret coming here.",
    "This dungeon is spooky. I'll trust Jon for now.",
    "Jon acts like a fart-brain but he really is strong",
    "Harry and Jon both give me 'the chosen one' vibe. I feel left out. I'm out of place.",
    "Kobo keeps staring at me. I think he thinks I'm his mom, poor thing. Gross ... but sad.",
    "#Harry @Haaaaarrrrrrry ~ &colors.pink Leave that red haired girl. I mean, my hair is pink, what's better than that!?",
    "I'm kinda depressed lately. I miss my friends. This dungeon is creepy ... and I can't even use this bow well",
    "I'm hungry. I want some cup-ramen, but the only thing in this dungeon is stinky meat..."
}

local nx = lume.copy(texts)

items.sakura_journal = {
    name = "Pink Journal",
    useText = "read",
    w = tw*.5,
    h = th*.5,
    source = "items/sakura_journal.png",
    onUse = function(self, user)
        if user.name == "kobold" then
            user:addLog("The handwriting is too wierd to read")
            return
        end
        
        user.room:closeInventory()
        if #nx<=0 then nx = lume.copy(texts) end
        
        local txt = string.format("%s peeks into sakura's 'diary'. It reads: &colors.pink %s", user.title, lume.eliminate(texts))
        user:addLog(txt)
    end
}

items.tutorial_note = {
    name = "Note",
    useText = "read",
    source = "items/note.png",
    onUse = function(self, user)
        user:addLog("The note reads: &colors.yellow 'The ... has the madness. It made the orb. Destroy at all costs. Run or ... will kill you. The ... isn't a Lich. There's also a ...' ~ \nThe rest is illegible.")
    end
}

creatures.kobold_monster = {
    name = "Kobold?",
    anim = "creatures/kobold_monster",
    w = tw*1.5, h = th*2*1.5,
    strength = 5,
    speed = 5,
    health = 40,
    abilities = {
        uncontrolled_teleportation={},
        vorpal_movement = {range=1, color="cyan"}
    }
    
}

creatures.chained_kobold_monster = {
    name = "Kobold?",
    anim = "creatures/chained_kobold_monster",
    w = tw*1.5, h = th*2*1.5,
    strength = 5,
    speed = 5,
    health = 400,
    
    immobile = true,
    thoughtless = true
    
}


local mColors = {"cyan","lime","lightpurple","orange"}

items.madorb = {
    name = "Orb ????",
    anim  = "items/madorb",
    frameDelay = .3,
    noPickup = true,
    h = th*2, w = tw,
    update = function(self, dt)
        self.timerL = (self.timerL or 0)-dt
        if self.timerL > 0 then
            return
        end
        
        self.timerL = 1
        if self.lightData then
           -- self.room:removeLight(self.lightData)
        end
        
        self.lightDfata = self.room:addEnchantLight(self.tile, 5, getValue(mColors), 4)
    end
}

items.kobold_elixir = {
    name = "mysterious elixir",
    useText = "quaff",
    source = "items/elixir.png",
    onUse = function(self, user)
        if user.data.name == "kobold" then
            user.room:addEnchantLight(user.tile, 3, "cyan", 3)
            user:addLog(string.format("Dangerous energy courses through %s", user.title))
            user:shake(15,2,20)
            
            local function pl()
                local p = user:polymorph("kobold_monster", 1000, true)
                p.playing = true
                
                local bfunc = function(self, user, v, tile)
                    user:spawnBones(true)
                end
                
                p:onMove(bfunc)
            end
            
            user.timer:after(2, pl)
        end
    end
}

ang = function() pl.room:spawn("angel",pl.tile).stats.speed=5 end
