local Mutation = class:extend("Mutation")
local rot = require "toybox.libs.src.rot"


local dirs = {{1,0},{0,1},{0,-1},{-1,0}}

function floodFill(tile, addedMap)
    local Q = {}
    
    Q[#Q+1] = tile
    local tiles = {tile}
    local IDS = {}
    local roomID = 1
    local room = tile.room
    local good
    local ii = 0
    --local all = #room.allTiles
    
    repeat
        local tile = Q[1]
        IDS[tile] = roomID
        
        for xx = 1, 4 do
            local d = dirs[xx]
            local x, y = tile._x+d[1], tile._y+d[2]
            local t = addedMap and addedMap[x] and addedMap[x][y] or room:getTile(x,y)
            
            if t and (not (t.isSolid and t:isSolid() or t.solid) and not t.water) and not IDS[t] then 
                IDS[t] = roomID
                Q[#Q+1] = t
                tiles[#tiles+1] = t
                t._x = t._x or x
                t._y = t._y or y
                
                if t.roomData and tile.roomData and t.roomData ~= tile.roomData and not t.con then
            --        good= true t.con=1
               --     break
                end
            end
        end
        ii = ii + 1
        table.remove(Q, 1)
    until #Q<1 --or ii>all
    log("done fill" ..#tiles)
    return tiles, IDS, good
    
end


function checkRoomFloodFill(tile, addedMap, IDS)
    local Q = {}
    
    Q[#Q+1] = tile
    local tiles = {tile}
    local IDS = IDS or {}
    local roomID = 1
    local room = tile.room
    local good
    local ii = 0
    --local all = #room.allTiles
    local doors = {}
    
    repeat
        local tile = Q[1]
        IDS[tile] = roomID
        
        for xx = 1, 4 do
            local d = dirs[xx]
            local x, y = tile._x+d[1], tile._y+d[2]
            local t = addedMap and addedMap[x] and addedMap[x][y] or room:getTile(x,y)
            
            if t and (not (t.isSolid and t:isSolid() or t.solid or t.door) and not t.water) and not IDS[t] then 
                IDS[t] = roomID
                Q[#Q+1] = t
                tiles[#tiles+1] = t
                
                if t.door then
                    doors[#doors+1] = t
                end
                
                t._x = t._x or x
                t._y = t._y or y
                
                if t.roomData and tile.roomData and t.roomData ~= tile.roomData and not t.con then
            --        good= true t.con=1
               --     break
                end
            end
        end
        ii = ii + 1
        table.remove(Q, 1)
    until #Q<1 --or ii>all
    log("done fill" ..#tiles)
    return tiles, doors, IDS, good
    
end

function Mutation:__init__(kwargs)
    self.digger = kwargs.digger
    self.map = kwargs.map or toybox.room
    
    self.mutations = {
        dome = self.ďome,
        cone = self.cone,
        depressRoof = self.depressRoof,
        elevateRoof = self.elecateRoof,
        depressFloor = self.depressFloor,
        elevateFloor = self.elevateFloor,
        --blocks = self.blocks,
        cave = self.cave,
        sides = changeSides,
        --corridors = self.corridors,
       -- none = self.none
    }
end

function Mutation:random(room, by, step)
    return lume.randomchoice({self.cave} or self.mutations)(self, room, by, step)
end

function Mutation:none()
end

function Mutation:solidify(tile)
    tile:setType("stone")
end

function Mutation:clear(tile)
    tile:setType("grass")
end
            
local solid, free = {solid=true},{}
function Mutation:dig(ttype,room,x,y,w,h,options)
    if type(ttype)=="table" then
    
        x = ttype.x
        y = ttype.y
        w = ttype.w
        h = ttype.h
        options = ttype
        room = ttype.room
        ttype = options.type or options.name
    end
    
    local c
    
    for tx = 1, 10 do
    c = rot.Map[ttype]:new(w or room.w, h or room.h, options or {caveChance=1,cavePasses=17})
    if c.randomize then c:randomize(flp or .6) end
    
    local xx, yy = x,y
    log("doing a t "..xx..","..yy)
    local map = {}
    local allTiles = {}
    
    c:create(function(x,y,v)
        local tile = room.getTile and room:getTile(x+xx,y+yy) or self.map:getTile(x+xx,y+yy)
        if tile and true then--(math.random(1,100) > 65 or not tile.room) then
           -- tile.debug=1
            local t = tile
            map[t._x] = map[t._x] or {}
            if v == 1 and not tile._isEntrance and not tile.isEntrance then
                map[t._x][t._y] = {solid=true, roomData=t.roomData}
                --if math.random()>.7 then  self:solidify(tile) end
                allTiles[#allTiles+1] = {t, v}
            elseif v == 0 and not tile:isLastWall() then
                --map[t._x][t._y] = {roomData=t.roomData}--
                self:clear(tile)
                allTiles[#allTiles+1] = {t, v}
            end --tile.cjolor="pink" log("tilee")
        else
            log("not tilee")
            
        end
    end)
    
    --[[local tiles,q,con = floodFill(room:getRandomSpaceTile(), map)
    if #tiles > 50 or con then
        for x = 1, #allTiles do
            local t = allTiles[x]
            local tile = t[1]
            if t[2] == 1 then
               tile.debgug=1-- self:solidify(tile)
            else
                self:clear(tile)
            end
        end
        break
    end]]
    --error()
    break
    end
    
    return c
end

function Mutation:cave(room)
    local spaces = room--self.digger:getRoomTiles(room,true)
    local sw= math.floor(spaces.w/4)

    self:dig({
        x = spaces.minTileX-sw*2,
        y = spaces.minTileY-sw*2,
        w = spaces.w+sw*2,
        h = spaces.h+sw*2,
        type = "Brogue",
        caveChance = 1,
        room = room,
        
    })
end

function Mutation:blocks(room, amount)
    local amount = getValue(amount or {3,5})
    
    while amount > 0 do
        local t = room:getRandomSpaceTile()
        if not t._isEntrance then
            self:solidify(t)
            amount = amount - 1
        end
    end
end

function Mutation:corridors(room)
    for x = 1, #room.allTiles do
        local tile = room.allTiles[x]
        if not tile._isEntrance and not tile.solid then
            --self:solidify(tile)
            tile.isWall = false
        end
    end
end

function Mutation:dome(room, by, step)
    local spaces = room--:getRoomTiles(room)
    self.map = room
    step = step or 2
    local by = by or 2
    local maxX, maxY = room.maxTileX, room.maxTileY
    local minX, minY = room.minTileX, room.minTileY
    
    for x = minX, maxX do
        for y = minY, maxY do
            local tile = self.map:getTile(x,y)
            if tile and not tile._isEntrance then
                self:solidify(tile)
                --tile.pale=1
            end
        end
    end
    
    local w = math.floor(room.w*(by or 2))
    local ww = w
    for yy = maxY, minY, -1 do
        local y = yy
        local mw = math.floor(w/2)
        for x = -mw,mw do
            xx = minX+math.floor(ww/2)+x
            local tile = self.map:getTile(xx, y)
            if tile and not tile:isLastWall() then
                --tile.crazy = true
                self:clear(tile)
            end
        end
        w = w - step
        if w <= 0 then
            break
        end
        --if y == spaces.y then
    end
    
end

function Mutation:cone(room, by, step)
    local spaces --= self.digger:getRoomTiles(room,5)
    step = step or 4
    
    local maxX, maxY = room.maxTileX, room.maxTileY
    local minX, minY = room.minTileX, room.minTileY
    
    for x = minX, maxX do
        for y = minY, maxY do
            local tile = room:getTile(x,y+room.h)
            if tile and not tile.isEntrance then
                tile:solidify()
            end
        end
    end
    
    local w = math.floor(room.w*(by or 2))
    local ww = w
    for yy = minY, maxY do
        local y = yy+room.h--+(spaces.y-yy)-- (spaces.y+spaces.h)-(spaces.y-yy
        local mw = math.floor(w/2)
        for x = -mw,mw do
            xx = minX+math.floor(ww/2)+x
            local tile = self.map:getTile(xx, y)
            if tile and not tile:isLastWall() then
                self:clear(tile)
            end
        end
        w = w - step
        if w <= 0 then
            break
        end
        --if y == spaces.y then
    end
end

local lev = {1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,3,3,3,3,4}
function Mutation:depressRoof(room, by)
    by = getValue(by or lev)
    local spaces = room-- self.digger:getRoomTiles(room,5)
    
    for x = spaces._x+math.random(2,4), spaces._x+spaces.w-math.random(2,4) do
        for y = 1,by do
            local noDo
            local tile = self.map:getTile(x,y+spaces._y)
            for x, i in ipairs(room.doors) do
                if tile._x == i._x or tile._y == i._y then
                    noDo = true
                end
            end
            
            if tile and not tile._isEntrance and not tile.isCorridor and not noDo then
                self:solidify(tile)
            end
        end
    end
end

function Mutation:elevateRoof(room, by)
    by = getValue(by or lev)
    local spaces = room--self.digger:getRoomTiles(room,5)
    
    for x = spaces._x+math.random(2,3), spaces._x+spaces.w-math.random(2,3) do
        for y = 1,by do
            local tile = self.map:getTile(x,spaces._y-y+1)
            if tile and not tile:isLastWall() then
                self:clear(tile)
            end
        end
    end
end

function Mutation:elevateFloor(room, by)
    by = getValue(by or lev)
    local spaces = room--self.digger:getRoomTiles(room,5)
    
    for x = spaces._x+math.random(2,4), spaces._x+spaces.w-math.random(2,4) do
        for y = 1,by do
            local noDo
            local tile = self.map:getTile(x,spaces._y+spaces.h-y)
            for x, i in ipairs(room.doors) do
                if tile._x == i._x or tile._y == i._y then
                    noDo = true
                end
            end
            
            if tile and not tile._isEntrance and not tile.isCorridor and not noDo then
                self:solidify(tile)
            end
        end
    end
end

function Mutation:depressFloor(room, by)
    by = getValue(by or lev)
    local spaces = room--self.digger:getRoomTiles(room,5)
    
    for x = spaces._x+math.random(2,3), spaces._x+spaces.w-math.random(2,3) do
        for y = 1,by do
            local tile = self.map:getTile(x,spaces._y+spaces.h+y-1)
            if tile and not tile:isLastWall() then
                self:clear(tile)
            end
        end
    end
end

function Mutation:changeSides(room, sides, _type, all)
    
    local spaces = room--self.digger:getRoomTiles(room,5)
    sides = sides or 4
    if type(sides) ~= "table" then
        local data = {}
        local s = {"Left","Right"}
        local s2 = {"Top","Bottom"}
        while sides>0 do
            local add
            if sides <= 2 then
                add = lume.randomchoice(s)
                lume.remove(s,add)
            else
                add = lume.randomchoice(s2)
                lume.remove(s2,add)
            end
            data[#data+1] = add
            sides = sides-1
        end
        sides = data
    end
    
    for x, i in ipairs(sides) do
        local name = string.capitalize(i)
        if name == "Top" then
            name = "Roof"
        elseif name == "Bottom" then
            name = "Floor"
        end
        
        self[string.format("change%s",name)](self, room, _type, all)
    end
end
function nb(s,t,a) return mm:changeSides(ppl.tile.room,s,t,a) end
function Mutation:changeLeft(room, type, all)
    local spaces = room--self.digger:getRoomTiles(room,5)
    
    if true then
        for y = spaces._y+(all and 0 or math.random(2,3)), spaces._y+spaces.h-(all and 0 or math.random(2,3)) do
            local noDo
            local tile = self.map:getTile(spaces._x,y)
            for x, i in ipairs(room.doors) do
                if tile._x == i._x or tile._y == i._y then
                    noDo = true
                end
            end
            
            if tile and not tile._isEntrance and not tile.isCorridor and not noDo then
                self:solidify(tile, (type and type ~= true and type) or "Iron")
            end
        end
    end
end


function Mutation:changeRight(room, type, all)
    local spaces = self.digger:getRoomTiles(room,5)
    
    if true then
        for y = spaces._y+(all and 0 or math.random(2,3)), spaces._y+spaces.h-(all and 0 or math.random(2,3)) do
            local noDo
            local tile = self.map:getTile(spaces._x+spaces.w,y)
            for x, i in ipairs(room.doors) do
                if tile._x == i._x or tile._y == i._y then
                    noDo = true
                end
            end
            
            if tile and not tile._isEntrance and not tile.isCorridor and not noDo then
                self:solidify(tile, (type and type ~= true and type) or "Iron")
            end
        end
    end
end

function Mutation:changeFloor(room, type, all)

    local spaces = room--self.digger:getRoomTiles(room,5)
    
    if true then
        for x = spaces._x+(all and 0 or math.random(2,3)), spaces._x+spaces.w-(all and 0 or math.random(2,3)) do
            local noDo
            local tile = self.map:getTile(x,spaces._y+spaces.h)
            for x, i in ipairs(room.doors) do
                if tile._x == i._x or tile._y == i._y then
                    noDo = true
                end
            end
            
            if tile and not tile._isEntrance and not tile.isCorridor and not noDo then
                self:solidify(tile, (type and type ~= true and type) or "Iron")
            end
        end
    end
end

function Mutation:changeRoof(room, type, all)

    local spaces = room--self.digger:getRoomTiles(room,5)
    
    if true then
        for x = spaces._x+(all and 0 or math.random(2,3)), spaces._x+spaces.w-(all and 0 or math.random(2,3)) do
            local noDo
            local tile = self.map:getTile(x,spaces._y)
            for x, i in ipairs(room.doors) do
                if tile._x == i._x or tile._y == i._y then
                    noDo = true
                end
            end
            
            if tile and not tile._isEntrance and not tile.isCorridor and not noDo then
                self:solidify(tile, (type and type ~= true and type) or "Iron")
            end
        end
    end
end

return Mutation