FIND_DOORS = false -- debugging for finding doors
ROT = toybox.rot()
WARCRAWL = true
WAR_CRAWL = true

prefabs = req "data.war_prefabs"
traits = req "data.war_traits"
req "data.abilities"

for x, i in pairs(traits) do
    i._id = x
    abilities[x] = i
    i.isTrait = true
end

love.audio.newSource("nest/m.ogg", "stream"):play()
function loadPrefab(p, map)
    items.bomb = items.grenade
    items.burning_bomb = items.burning_grenade
    
    p = p:sub(1,#p-1)
    local n = {}
    local m = {}
    local c = 0
    
    while true do
        c = c+1
        local str = p:sub(c,c)
        if str == "\n" then
            n[#n+1] = m
            m = {}
        elseif str and str ~= "" then
            m[#m+1] = str
        else
            n[#n+1] = m
            m = {}
            break
        end
        
        if c>#p then 
            n[#n+1] = m
            m = {}
            break
        end
    end
    
    return n
           
end

function loadPrefabs(map)
    local w = (#map.tiles-2)/8
    
    local s = 0
    ww = 0
    local c, cy = -1,0
    local breakIt
    local chunks, allChunks = {}, {}
    
    while true do
    
    while ww < w do
        c = c + 1
        for yy = 1, 8 do
            for x = 1, 8 do
                local t = map:getTile(1+x+c*8, 1+yy+cy*8) 
                if t then
                    chunks[#chunks+1] = {t, x, yy}
                    
                    if t._y == map.maxTileY then
                        breakIt = true chunks = {}
                        break
                    end else error((1+x+c*8)..","..(1+yy+cy*8))
                end
            end
            if breakIt then break end
        end
        ww = ww + 1
        if breakIt then break end
        
    allChunks[#allChunks+1] = chunks
    chunks = {}
    end
    cy = cy+1
    ww = 0
    c = -1
    --allChunks[#allChunks+1] = #chunks
    chunks = {}
    
    if breakIt then
        break
    end
    
    end --error(inspect(getValue(allChunks)))

    
    for x = 1, #allChunks do
        local c = allChunks[x]
        if c and #c<64 then
            lume.remove(allChunks, c)
        end
        
    end
    for x = 1, #allChunks do
        local c = allChunks[x]
        if c then
            local data = {} local cc=0
            for xx, ii in ipairs(c) do
                data[ii[2]] = data[ii[2]] or {}
                data[ii[2]][ii[3]] = ii[1]  assert(type(ii[1])=="table") cc=cc+1
            end --if #c<64 then error() end
            allChunks[x] = data assert(cc==64, cc)
        end
    end
    
    -- error(inspect(allChunks))
    

    
    local tiles = {} sstr="?"
    for x, ii in ipairs(allChunks) do
      if #ii~=0 then local og = ii[1][1]
        local t = loadPrefab(getValue(prefabs))
        local cy = 0 sstr=sstr=="?" and "#"or "?"
        local ddone
        for _, n in ipairs(t) do
            cy = cy + 1
            local c = 0
            for _, str in ipairs(n) do
                c = c + 1 if c>8 or not ii[c] then error(#n..inspect(n)..c) end
                local tile = ii[c][cy]--map:getTile(8*s+c, cy+sy*8)
                if cy==8 then ddone = 1 end
                sstr = str
                if tile
                then assert(tile._y==(og._y+cy-1),tile._y..","..og._y..","..cy)
                    if sstr == "#" then
                        tile.solid = true
                    elseif sstr == "?" then
                        tile.solid = nil tile.grass=nil--math.random()>.5
                    elseif sstr=="." then
                    else error(sstr)
                    end
                end
            end --assert(c==8,c..","..inspect(n))
        end
        if not (cy==8) then error(cy..","..inspect(t)) end
        assert(ddone)
      end
    end
    
    local ammos = {
        bullets = 60,
        shells = 40,
        explosives = 20
    }
    
    local ammoAmounts = {
        bullets = {10,10,20},
        shells = {5,5,10},
        explosives = {3,3,5}
    }
    
    local lst = {"orc","orc","orc","orc"}--,"goblin","goblin"}--{"jackal","bloat","boar","jackal","goblin","goblin","kobold","spectral_blade","spectral_scythe","orc","goblin_conjurer"}
    map:after(2,function()
        for x = 1, math.random(7,9) do
            local a = lume.weightedchoice(ammos)
            local am = getValue(ammoAmounts[a])
            map:spawnItem(a,map:getRandomSpaceTile()).amount = am
        end
        
    local pl = pl
    local oldAddAbility = pl.addAbility
    pl.addAbility = function(self, name, ...)
        if traits[name] then
            if not self.room.traits[name] then
                self.room.allTraits[#self.room.allTraits+1] = name
                local y = 20+5+(H()/25)+(H()/25)*3/4
                local x = (H()/24)*2-10
                local w = 65
                local b = gooi.newButton({
                    y = y, x = x + (#self.room.allTraits-1)*(w+7),
                    w = w, h = w, text="",
                    group = gooi.currentGroup
                })
                b.borderWidth = 3
                b:addImage(string.format("warcrawl/traits/%s.png", name))
                
                self.room.allTraitButtons[#self.room.allTraitButtons+1] = b
            end
            
            local t = self.room.traits[name]
            self.room.traits[name] = {(t and t[1] or 0)+1, t and t[2] or #self.room.allTraits}
            
            if t and t[1] == 1 then
                self.room.allDoubleTraits[#self.room.allDoubleTraits+1] = name
            end
        end
        
        return oldAddAbility(self, name, ...)
    end
    
        pl:addAbility(traits.fireforce._id)
        pl:addAbility(traits.vampirism._id)
        pl:addAbility(traits.vampirism._id)
        
        for x = 1, 9 do
            local t = nil--map:getRandomTile()
            while not t do
                t = map:getRandomSpaceTile()
                if lume.distance(t._x, t._y, pl.tile._x, pl.tile._y)>40 then
                    t = nil
                end
            end
            
            local c = map:spawn(x<=2 and "orc" or x<=4 and "goblin" or getValue(lst),t)
            local cls = getValue({"warrior","warrior","scout","warrior","gunner"})--warrior","archer",false,"bomber","warrior","pyromaniac","none","scout","scout","scout","archer",false})
            
            if math.random()>(cls=="gunner" and .7 or .9) then c:addSkill("bombThrow") end
            if cls then c:addClass(cls, getValue({1,1,2,2})) end
            
            c.hostility = 3
            c.team = c.name == "orc" and math.random()>-.4 and "?" or map.player.team
        end
    end)
end

--error(inspect(loadPrefab(prefabs[1])))

local _Path = class:extend("_Path")
function _Path:__init__(x,y)
    self.x = x
    self.y = y
end

function _Path:getX()
    return self.x
end

function _Path:getY()
    return self.y
end

function _Path:getPos()
    return self.x, self.y
end

getSpaceTile = function(self)
    local tile
    local count = 0
    local found = false
    local ttile
    room = room or self
    
    while not tile and count < 100 do
        tile = lume.randomchoice(self:getSpaceTiles())--checkIsPosition(position, lume.eliminate(aTiles), notHave)
        ttile = tile
        
        if tile and not tile.unit then --position == "center" then
            break
        else
            tile = nil
        end
        count = count + 1
    end
    return tile or ttile
end

Map = toybox.Room("Map")
Object = toybox.BaseObject("Object")
req "map.dungeonMaker"

local BaseObject = toybox.BaseObject("Base")

function Object:create(k)
    k = k or {}
    k.solid = k.solid == nil and false or k.solid
    k.static = k.static == nil and true or k.static
    k.w, k.h = k.w or tw, k.h or th
    
    BaseObject.create(self, k)
   -- self.debug = 1
    self.solid = k.solid == nil and false or k.solid
    self:center()
    
end

local Tile = Object:extend("Tile")

function Tile:create(k)
    k.w, k.h = tw, th
    Object.create(self, k)
    self._x = k._x
    self._y = k._y
    self.fires = 0
    self.lights = 0
    self.gases = {}
    self.gasesAmount = 0
    
    self.myLights = {}
    self.lightIDs = {}
    self.enchantingLights = {}
    self.light = 0
    
    self.life = 10
    
    self.isTile = true
    self.isEntity = true
    
    self.puddles = {}
    self.puddlesLen = 0
    self.puddlesTable = {}
    
    self.temperature = k.temperature or 7
end

function Tile:getAttacked(att, attacker)
    if not self.solid or self.chasm then
        return
    end
    
    
    if type(att) == "table" then
        attacker = att
        att = att.attack
    end
    
    att = att or 1
    self.life = self.life - att
    
    self.crack = self.life <= 2 and 3 or self.life <= 5 and 2 or self.life <= 8 and 1 or nil
    
    self:shake(30,.3,35)
    -- self:flash(.15)
        
    if self.life <= 0 then
        self.solid = false
        
        if self.onDestroyed then
            if self:canBeSeen() then
                Entity.spawnDebris(self)
            end
            self:onDestroyed(attacker)
        end
        
        local source = string.format("effects/scorch_%d.png",math.random(1,2))
        
        local t = self
            
        local i = t:add_image(source)
        i.color = {1,1,1,.8}
        self.room.timer:tween(45,i.color,{[4]=.01})
        
    end
end

function Tile:canBeSeen()
    return self.drawID == self.room.drawID
end

function Tile:__draw()
    if self.oldSolid ~= self.solid then
        self.depth = self.solid and DEPTHS.WALLS or DEPTHS.FLOOR
        self.oldSolid = self.solid
    end
    
    if self.empty then
        return --self.source = nil
    end
    
    local drawn
    
    if self.drawID == self.room.drawID or (self.liglht or 0) >=.5 or lightAll then
        drawn = true
        
        Object.__draw(self)
    elseif self.unit or self.item then
        if self.unit then
           self.unit.light_alpha = 0
           self.room:unsee(self.unit)
        end
        
        if self.item then
            self.item.light_alpha = 0
            self.room:unsee(self.item)
        end
    end
    
    if not drawn and self.seen and not noSee then
        if self.source then
            local nn = .2--.1
            local r,g,b,a = set_color(nn,nn,nn)
            self:simpleDraw(r,g,b,a,nil,true)--draw_image(self.source)
            set_color(r,g,b,a)
        end
    end
    
    self:drawThrowing()
    -- self.name_tag = math.floor(self:getTemperature()*100)/(100).." (from )"..math.floor(self.temperature*100)/100
end

function Tile:drawThrowing()
    
    if self.throwing then
        local r,g,b,a = set_color(getColor((self.room.throwTooFar or self.throwingBad) and "red" or colors.lime,.5))
        self:draw_image(self.throwingDest and "tileSelectLast.png" or "tileSelect.png")--draw_rect("line",self.x,self.y,self.w,self.h)
        set_color(r,g,b,a)
    end
end

function Tile:increaseTemperature(val)
    log("[Tile] Increasing temperature by "..val)
    self.temperature = self.temperature + val
end


function Tile:decreaseTemperature(val)
    log("[Tile] Decreasing temperature by "..val)
    self.temperature = self.temperature - val
end

function Tile:getTemperature()
    local l = 0
    for ll = 1, #self.myLights do
        l = l + self.myLights[ll][1]
    end
    
    return self.temperature + l
end

function Tile:isCold()
    return self:getTemperature() <= 3
end

function Tile:get_X()
    return self._x
end

function Tile:get_Y()
    return self._y
end

function Tile:isFree(except)
    if self.item and self.item.isObstacle and self.item ~= except then
        return
    end
    
    if self.item and self.item.isWall then error() end
    
    if self.item and self.pedestalLocked and (not self.pedestalLocked.unlocked) and not self.takenPedestalItem then
        -- return
    end
    
    if self.empty then
        -- return
    end
    
    
    return not self.solid and (not self.unit or self.unit == except)
end

local nn = 7

maxdis = lume.distance(0,0,nn*tw2,nn*th2)

function Tile:addLight(l)
    self.myLights[#self.myLights+1] = l
    self.lightIDs[l[3]] = l
    self.lights = self.lights + 1
    self.light = (self.light or 0)+ l[1]
end

function Tile:removeLight(light)
    local l = self.lightIDs[light] assert(l)
    self.lights = self.lights - 1
    self.lightIDs[light] = nil
    self.light = (self.light or 0) - l[1]
    assert(lume.remove(self.myLights, l))
end

local waterEdges = {}
local mask_shader =
love.graphics.newShader[[
vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
      if (Texel(texture, texture_coords).rgba == vec4(0.0)) {
         // a discarded pixel wont be applied as the stencil.
         discard;
      }  if (Texel(texture, texture_coords).rgb == vec3(1.0)) {
         // a discarded pixel wont be applied as the stencil.
         discard;
      }
      return vec4(1.0);
   }
]]

local toWater

local function drawWaterEdge()
    love.graphics.setShader(mask_shader)
    toWater:draw_image(toWater.waterEdge)
    love.graphics.setShader()
end

    local function multitply(cr,c1)
        for x = 1, #cr do
            cr[x]=cr[x]*(c1[x] or 1)
        end
    end
    
function Tile:draw() --self.name_tag=self.lights..": "..(self.light or "0")
    local player = self.room.player
    local dis = lume.distance(self.x, self.y, player.x, player.y)
    self.dis = dis
    local r,g,b,a = lg.getColor()
    
    if self.solid and (self.nextFloor or self.previousFloor) then
        self.solid = nil
    end
    if not lightAll then
        local aa = dis/(maxdis+(self.room.addedSight or 0))
        local light = 1
        local light2 = 0
     --   if ddis then
       --     light2 = 1
    --    end
    
        local oc = self.color
        
        local lenm = #self.myLights --debugp
        if lightAll or lenm>0 or self.myLight then--??
            light = myLight or light or lightAll and 1 or 0--self.myLight or light or 1
            light2 = lightAll and 1 or 0--1
            local donec= {}
            local col = self.color
            for i = 1, lenm do
                --i = math.random(1,lenm)
                local addc = addc
                local l = self.myLights[i]
                if l[3].source and l[3].source.oiRemoved then
                    self.room:removeLight(l[3])
                end
                local ii =(((1-aa)*light)+(self.light or 0))/((self.light or 0) + 1)-- l[4]
                local iii = l[6]--addLight---1--lightth
                --local ii = 1
                ii = lume.min(ii, .9)
                local color = l[2] or colors.green--getColor(l[2] or "black")--, l[3].alpha)
                if l[3].alpha then
                    color = lume.copy(getColor(color))
                    for x = 1, 3 do
                        color[x] = color[x]--*l[3].alpha assert(color[x]>=0) assert(ii<=1,ii)
                    end
                    ii=.5--self.color = color
                    color[4]=lume.max(.4,l[3].alpha)
                    addc = addc2
                    --break
                end
                
                --local color = donec[l[2]] and {0,0,0} or color--
                
                
                local color = {color[1]+1*iii,color[2]+1*iii,color[3]+1*iii}
                self.color = lenm == 1 and color or (not mcc) and multiply(getColor(self.color or "white"),color) or addc(getColor(self.color or "black"),color or color,ii)
                
                donec[l[2]] = true
                light = light + l[1]
                if  l[3].enchanting then
                    self.color = color--addc(getColor(col or "white"),color,ii)
                    break
                end
            end
            
            if lenm == 0 then self.color = nil oc = nil end
        end
        --self.color = self.room:getTileLight(self)--lightcol
        
        local p = lume.max((((1-aa)*light)+(self.light or 0))/((self.light or 0) + 1),.2)
        --self.name_tag = (math.floor(p*100)/100)..","..(math.floor((self.light or 0)*10)/100)
        
            if self.color then for x = 1,#self.color do self.color[x] = math.floor(self.color[x]*100)/100 end
                --self.name_tag = inspect(self.color)
            end
            
        self.lightp = p
        self.colorp = self.color
        
        if self.unit then
            self.unit.light_alpha = lume.max(0,(self.unit.skinAlpha)-(1-p))
            self.unit.color = self.color and getColor(self.color,p+light2)--or self.unit.color
            local p = self.room.player
            if self.unit:isSubmerged() then
                if not p.tile.water then
                    self.room:unsee(self.unit)
                    self.unit.light_alpha = 0
                
                -- partially see unit
                elseif not p.submerged then
                    self.room:see(self.unit)
                    self.unit.light_alpha = self.unit.light_alpha*.6
                
                -- player is fully submerged too
                else
                    self.room:see(self.unit)
                end
                
            elseif p.submerged then
                if self.water then
                    self.room:see(self.unit)
                    self.unit.light_alpha = self.unit.light_alpha*.6
                else
                    self.room:unsee(self.unit)
                    self.unit.light_alpha = 0
                end
            else
                self.room:see(self.unit)
            end
        end
        
        if self.item then
            self.item.light_alpha = p
            self.item.color = self.item.color and addc(getColor(self.item.color),getColor(self.color),.5) or self.color
            self.room:see(self.item)
            if self.item.isDestroyed then
                self.item = nil
                cwarn("hm, item was lurking in tile","yellow")
            end
            
        end
        
        local tile = self
        --tile.name_tag=tile.light and ((tile.light)/1)..","..self.lights
        
        if not self.color then
            local pp = p
            local p = 1
            love.graphics.setColor(p,p,p,pp+light2)
        else
            love.graphics.setColor(getColor(self.color,(((nil and self.color[4]) or p+light2))/2))
        end
        self.color = oc
        self.image_alpha = p+light2
    end
    
    
    local tr, tg, tb, ta = lg.getColor()
    local ta = self.image_alpha
    
    self.colorUsed = {tr*ta, tg*ta, tb*ta, 1}
    if self.userCol then warn(": "..inspect(self.colorUsed)..","..inspect(self.userCol)) end
    
    self.seen = true
    
    local keepLeftChasmLine, keepRightChasmLine
    
    if self:isSolid() or self.doored then
        self.source = self.hasWall and nil
        if not self.hasWall then
            self.source = "tile.png" or nil--self.source or "warcrawl/sacks4.png"--tile.png"--draw_rect("line",self.x,self.y,self.w,self.h)
            if true then
                self.source = nil
                self.s = self:add_image("warcrawl/sacks4.png")
                self.s._h = self._h*2--= self.h*#
                self.s.offset_y = 00--self.h/4
            end
        end
        if nil then
        
        local ro = self.room
        local t = self.room:getTile(self._x, self._y-1)
        local tr = ro:getTile(self._x+1, self._y)
        local tl = ro:getTile(self._x-1, self._y)
        local td = ro:getTile(self._x, self._y+1)
        if (not t or not t:isSolid()) and (not tr or tr:isSolid()) and (not tl or tl:isSolid()) then
            --self.source = "toptile.png"
        end
        
        local self = self.item and self.item.isWall and self.item or self
        
        local border = "borders_straight"
        if (not tr or not tr:isSolid()) and not self.drawRightBorder then
            self.drawRightBorder = true
            self:add_image(string.format("tiles/%s/right.png", border))
        end
        
        if (not tl or not tl:isSolid()) and not self.drawLeftBorder then
            self.drawLeftBorder = true
            self:add_image(string.format("tiles/%s/left.png", border))
        end
        
        if (not td or not td:isSolid()) then 
            if not self.drawBottomBorder and (not td or not td:isChasm()) then
                self.drawBottomBorder = self:add_image(string.format("tiles/%s/bottom.png", border))
            elseif td and td:isChasm() and self.drawBottomBorder then
                self:remove_image(self.drawBottomBorder)
                self.drawBottomBorder = nil
            end
        end
        
        if (not t or not t:isSolid()) and not self.drawTopBorder then
            self.source = self.isItem and self.source or "toptile2.png"
            self.drawTopBorder = true
            self:add_image(string.format("tiles/%s/top.png", border))
        end
        end
    elseif self:isChasm() then
        if self.water then
            for t, d in pairs(self.waterSurrounds) do
                t.waterSurrounding[d] = nil
            end
            
            self.water, self.waterSurrounds = nil
        end
        local m = mmm or .05
        local nn = 0
        local r,g,b,a = set_color(.25,.25,.25,.25)--m,m,m)--colors.white)
        draw_rect("fill",self.x+nn,self.y+nn,self.w-nn,self.h-nn)
        set_color(r,g,b,a)
        
        local ro = self.room
        local t = self.room:getTile(self._x, self._y-1)
        local tr = ro:getTile(self._x+1, self._y)
        local tl = ro:getTile(self._x-1, self._y)
        local td = ro:getTile(self._x, self._y+1)
        if (not t or not t:isSolid()) and (not tr or tr:isSolid()) and (not tl or tl:isSolid()) then
            --self.source = "toptile.png"
        end
        
        self.grass = nil
        self.source = nil
        local self = self.item and self.item.isWall and self.item or self
        
        
    
        local border = "borders_straight"
        if (tr and not tr:isSolid()) then
            if not self.drawRightBorder and not tr:isChasm() then
                self.drawRightBorder = self:add_image(string.format("tiles/%s/right.png", border))
            elseif tr:isChasm() and self.drawRightBorder then
                self:remove_image(self.drawRightBorder)
                self.drawRightBorder = nil
            end
            
            if tr:isChasm() and not tr.drawTopBorder and self.drawTopBorder then
                local n = self.w-2
                self.rightChasmLine = self.rightChasmLine or self:add_image("tiles/right_chasm_line.png")
                keepRightChasmLine = true
                
                --lg.line(self.x+n, self.y, self.x+n, self.y+self.h/3)
            end
            
        end
        
        if (tl and not tl:isSolid()) then
            if not self.drawLeftBorder and not tl:isChasm() then
                self.drawLeftBorder = self:add_image(string.format("tiles/%s/left.png", border))
            elseif tl:isChasm() and self.drawLeftBorder then
                self:remove_image(self.drawLeftBorder)
                self.drawLeftBorder = nil
            end
            
            if tl:isChasm() and not tl.drawTopBorder and self.drawTopBorder then
                local n = 2
                self.leftChasmLine = self.leftChasmLine or self:add_image("tiles/left_chasm_line.png")
                keepLeftChasmLine = true
                
                --lg.line(self.x+n, self.y, self.x+n, self.y+self.h/3)
            end
        end
        
        if (td and not td:isSolid()) then 
            if not self.drawBottomBorder and not td:isChasm() then
                self.drawBottomBorder = self:add_image(string.format("tiles/%s/left.png", border))
                local d = self.drawBottomBorder
                d.offset_y = self.offset_y+self.h-2
                d.angle = 90
                
                
            elseif td.isChasm and self.drawBottomBorder then
                self:remove_image(self.drawBottomBorder)
                self.drawBottomBorder = nil
            end
        end
        
        if (t and not t:isSolid()) then
            if not t:isChasm() and not self.drawTopBorder then
                --self.source = self.isItem and self.source or "toptile2.png"
                self.drawTopBorder = true
                local border = "borders"
                self.drawTopBorder = self:add_image(string.format("tiles/%s/top.png", border))
                local k = self:add_image(string.format("tiles/chasm_top.png", border))
                --k.offset_y = self.offset_y + self.h/3
                self.drawTopBorder2 = k
            elseif t:isChasm() and self.drawTopBorder then
                self:remove_image(self.drawTopBorder)
                self:remove_image(self.drawTopBorder2)
                self.drawTopBorder = nil
                self.drawTopBorder2 = nil
            end
            
        end
    
    
    else
        self.images = {}
        self._imagesLen = 0
        self.imId = self.imId or getValue({1,2,3,4,4,5,5,5,6,6,6,6,6,6,6}) math.random(1,5)
        self.source = self.floorSource or string.format("tiles/floors/floor%s.png",self.imId)
    end
    
    if (self.rightChasmLine) and (not keepRightChasmLine) then
        self:remove_image(self.rightChasmLine)
        self.rightChasmLine = nil
    end
    
    if (self.leftChasmLine) and (not keepLeftChasmLine) then
        self:remove_image(self.leftChasmLine)
        self.leftChasmLine = nil
    end

    
    if true then
        for x, i in pairs(self.noises or {}) do
            local alpha = lume.min(1.5,i[1])
            i.val = (i.val or i[1] or 1) - 1/2
            if i.val > 0 then
            lg.setColor(1,0,0,(i.val+alpha/2)/2)
            local n = 0
            local n2 = n/2
            draw_rect("fill",self.x+n2,self.y+n2,self.w-n,self.h-n)
            end
        end
    end
    
    if true then
        for x = 1, #self.enchantingLights do
            i = self.enchantingLights[x]
            local alpha
            if i then
                alpha = i[3].alipha or lume.min(1.5,i[1])
                i.val = (i.val or i[3].lifeTime or (i[1] or 1)/3) - (self.room.dt or 1/30)--lifeTime
            end
            
            if i and i.val > 0 then
                lg.setColor(getColor(i[2],(i.val+alpha)/2))
                local n = 0
                local n2 = n/2
                draw_rect("fill",self.x+n2,self.y+n2,self.w-n,self.h-n)
            elseif i then
                table.remove(self.enchantingLights, x)
            end
        end
    end
    
    local rr,gg,bb,aa=r,g,b,a
    local r,g,b,a = lg.getColor()
    do local rr,gg,bb,aa =set_color(r*a,g*a,b*a,1) end
    self:simpleDraw(rr,gg,bb,1,true)
end

function addCarpetsToRoom(room)
    local x = room.minTileX
    local y = room.maxTileY
     
    for x, i in ipairs(room.allTiles) do
    
        local carpet2 = true
        local c2 = 0
        local free = not i:isSolid()
        
        for d = 1, not free and 0 or 4 do
            local dd = dirs4[d]
            local t = i.room:getTile(i._x+dd[1], i._y+dd[2])
            local t2 = i.room:getTile(i._x+dd[1]*2, i._y+dd[2]*2)
            if (
                ((t and not t:isSolid()) and (t2 and t2:isSolid() or not t2)) or
                (t and t.hasDoor or t2 and t2.hasDoor)
            ) then
                
                c2 = c2 + 1
                
                
            end
            
            if t and t:isSolid() then
                c2 = 5
            end
        end
        
        carpet2 = c2 == 1 or c2 == 3 or c2 == 2
        
        if free and not i:isChasm() then
            i.isCorridor = true
            i.isEntrance = true
            i.room:spawnItem(carpet2 and "carpetFloor2" or "carpetFloor", i)
        end
    end
end
                

function chasm() for x = 1, 8 do for y=1,2 do local d = dirs8[x]
    local xx = toybox.room:getTile(pl.tile._x+d[1]*y, pl.tile._y+d[2]*y)
    if xx then xx.chasm = true end end end
end

function Tile:isChasm()
    return self.chasm
end

Tile.dhraw=function(self)
    local r,g,b,a = set_color(getColor(self.color or self.solid and "white" or "black",self.image_alpha))
    draw_rect(self.solid and "line" or "fill",self.x,self.y,self.w,self.h)
    set_color(r,g,b,a)
end

-- where r,g,b,a are the origional colour values to return to
function Tile:simpleDraw(r,g,b,a,notSimple,notSeen)
    -- set_color(r,g,b,a)
    
    if self.colorUsed and not notSeen then
        set_color(self.colorUsed)
    end
    
    --assert(a>=1,a)
    local i = {}
    if self.room.player.submeruged and not self.water then
    
        local n = colors.black--royalblue
        local rr,gg,bb,aa = set_color(n[1],n[2],n[3],.7)
        
        draw_rect("fill",self.x,self.y,self.w,self.h)
        
        set_color(rr,gg,bb,aa)--r,g,b,a)
        --return
    end
    
    
    if self.water then
        self.source = currentWaterSource
        if self.water.isDeep then
            local r,g,b,a = lg.getColor()
            local v = .2
            set_color(r*v, g*v, b*v, a)
        end
    end
    local lr,lgg,lbb,la = lg.getColor()
   -- self.color = {lr,lgg,lbb,la}
    
    if self:isChasm() then
        self.source = nil
        self.water = nil
    end
    
    if self.floor then
        self:draw_image(self.floor.source)
    else
        self:draw_source_image()
    end
    
    if self.water then
        if not self.water.isDeep  then
            local ii = self.colorUsed
            --assert(ii[1]==lr and ii[2]==lgg and ii[3]==lbb,inspect(ii)..","..inspect({lr,lgg,lbb}))
        end
        --self.source = currentWaterSource
    elseif self.waterSurrounding and not self.solid then
        for x, i in pairs(self.waterSurrounding) do
            
            if i.water and i.water.isDeep then
                i.water.isDeep = false
            end
            
            local source = string.format("water_edges/%s.png", x)
            
            toWater = self
            
            local r,g,b,a
            
            if self:isChasm() then
                if (x == "bottom" and self.drawTopBorder) then
                else
                    goto skip
                end
            end
            
            if i.colorUsed then
                r,g,b,a = set_color(i.colorUsed)
               -- set_color(r*a,g*a,b*a,1)
            end
            
            -- local dd,gg,bv,aa=lg.getColor() assert(aa>=1,aa..","..inspect(i.colorUsed))
            
            -- no draw border of water
            --if 1 then self:draw_image(source) end
            
            self.waterEdge = source
            
            local r2,g2,b2,a2 = set_color(1,1,1)
            lg.stencil(drawWaterEdge, "replace", 1)
            lg.setStencilTest("greater", 0)
            
            -- mj =mj or i tjj=tjj or self
            -- i.userCol = i==mj and self==tjj and {r2,g2,b2,a2,i.colorUsed and true or false}
            
            set_color(r2,g2,b2,a2)
            
            if 1 then self:draw_image(currentWaterSource) end
            
            lg.setStencilTest()
            self.source = nil
            toWater = nil
            
            if r then
                set_color(r,g,b,a)
            end
            
            ::skip::
        end
    end
    
    self:draw_images()
    
    if self.crack and self.solid then
        local img = game:getAsset(string.format("tiles/cracks/%s.png",self.crack-1))
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, tw, th)
        local gww, ghh = tw, th
        lg.draw(img, self.x+gww/2, self.y-(ghh-th)+ghh/2, 0, gw, gh, iw/2, ih/2)
    end
    
    -- chess effect
    if false then
    if (self._x+self._y)%2 == 0 then
    local r,g,b,a = set_color(getColor("grey",.3))
    draw_rect("fill",self.x,self.y,self.w,self.h)
    set_color(r,g,b,a)
    end
    end

    self:drawPuddles()
    self:drawVent()
    
    
    if self.grass then
        local g = self.grass
        local img = game:getAsset(g.source)
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, g.w or tw, g.h or th)
        lg.draw(img, self.x+g.w/2, self.y-(g.h-th)+g.h/2, 0, gw, gh, iw/2, ih/2)
    end
    
    
    if self.pedestal then
        local img = game:getAsset("pedestal.png")
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, tw, th)
        local gww, ghh = tw, th
        lg.draw(img, self.x+gww/2, self.y-(ghh-th)+ghh/2, 0, gw, gh, iw/2, ih/2)
    end
    
    self:drawDoor()
    
    if self.nextFloor or self.previousFloor then
        self:draw_source_image()
        local img = game:getAsset(self.previousFloor and "upstairs.png" or "downstairs.png")
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, tw, th*2)
        local gww, ghh = tw, th*2
        lg.draw(img, self.x+gww/2, self.y-(ghh-th)+ghh/2, 0, gw, gh, iw/2, ih/2)
    end
    
    self:drawWeb()
    
    
    if self.ice then
        local img = game:getAsset("ice.png")
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, tw, th)
        local gww, ghh = tw, th
        lg.draw(img, self.x+gww/2, self.y-(ghh-th)+ghh/2, 0, gw, gh, iw/2, ih/2)
    end
    
    --self.color = oc
    lg.setColor(r,g,b,a)
    
    local currentTurn = self.room.currentTurn--(self.room.player.currentTurn or 0)
    local toUpdate = (self.lastUpdated or 0) == currentTurn
    
    local temp = self:getTemperature()
    local lowTemp = temp<=3
    lowLowTemp = temp<0
    
    if lowTemp and notSimple and toUpdate then
        if math.random() > .8 then
            spawnFrost(self)
        end
    end
    
    if toUpdate and self.hasDoor and self:doorIsOpen() then
    
        if self.item or self.unit then
            self.leaveOpen = 3
        end
        
        self.leaveOpen = (self.leaveOpen or 2)-1
        
        if (self.leaveOpen or 0) <= 0 then
            self.leaveOpen = nil
        end
        
    end
    
    
    if (self.water or self.puddlesLen>0) and lowLowTemp and not self.ice and toUpdate then
        self:spawnIce(temp)
    end
    
    if toUpdate then
        local t = self.temperature
        if t > 8 and self.fires<1 then
            t = t - .5
        elseif t < 4 and not self.ice then
            t = t + .5
        end
        self.temperature = t
    end
    
    self.lastUpdated = currentTurn

end

function Tile:spawnIce(v)

        self.ice = self.room:spawnItem("ice", self, nil, true)--self.water
        assert(self.room.items[self.ice])
        self.ice:addLog("Some ice forms!")
        
         
        if self.ice then
            self.ice.water = self.water
        
            self.ice.color = self.water and self.water.color or self.puddleColor or self.ice.color
            
            
            self.ice.lifeTime = v or math.abs(temp)
            self.ice.life = self.ice.lifeTime
            self.iceLifeTime = nil
            

            self.ice.itemColor = self.ice.color
            warn(inspect(self.ice.color).." ice color ")
        
            if self.water then
                if self.water.isWaterBody then
                    self.ice.isObstacle = false
                    self.ice.isThrowObstacle = true
                    self.iceFloor = true
                end
            
                self:removeWater()
            end
        end
end

local wdirs = {{1,0},{-1,0},{0,-1},{0,1}}
local dirNames = {"right", "left", "top", "bottom"}
function Tile:addWater(data, spread, isWaterBody, isDeep) -- addpuddle
    local sp = type(data) ~= "table" and data
    if sp then
        data = nil
    end
    
    sp = sp or spread
    
    local water = data or {
        spread = sp or false,
        color = nil
    }
    

    
    if self.water then
        local w = self.water
        w.value = (w.value or 0)+(water.value or 0)
        
        if w.value == 0 then
            w.value = nil
        end
        
        w.spread = water.spread or w.spread
        
    else
    
    self.waterSurrounds = {}
    for x = 1, 4 do
        local d = wdirs[x]
        local t = self.room:getTile(self._x+d[1], self._y+d[2])
        if t and not t.water then
            t.waterSurrounding = t.waterSurrounding or {}
            t.waterSurrounding[dirNames[x]] = self
            self.waterSurrounds[t] = dirNames[x]
        end
    end
    
    self.water = water
    end
    
    
    self.water.isDeep = isDeep or self.water.isDeep
    self.water.isWaterBody = isWaterBody or self.water.isWaterBody
    
    self.room.checkPuddles[self] = true
end

function Tile:removeWater()
    local w = self.water
    
    if not w then
        return
    end
    
    
    for x = 1, 4 do
        local d = wdirs[x]
        local t = self.room:getTile(self._x+d[1], self._y+d[2])
        if t and t.waterSurrounding then
            t.waterSurrounding = t.waterSurrounding or {}
            t.waterSurrounding[dirNames[x]] = nil
        end
    end
    
    if self.puddlesLen <= 0 then
        self.room.checkPuddles[self] = nil
    end
end


function Tile:doorIsOpen()
    return self.item or self.unit or self.leaveOpen
end

function Tile:drawDoor()

    if self.hasDoor then
        local r,g,b,a = lg.getColor()
        
        if self.isLocked then
            --self.solid = true----set_color(colors.darkgrey)
        else
            self.solid = false
        end
        
        local nn = 1
        local img = game:getAsset(self:doorIsOpen() and "door_open.png" or self.isLocked and "locked_door.png" or "doork.png")
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, tw, th*nn)
        local gww, ghh = tw, th*nn
        lg.draw(img, self.x+gww/2, self.y-(ghh-th)+ghh/2, 0, gw, gh, iw/2, ih/2)
        
        set_color(r,g,b,a)
        
    elseif self.doored then
        self.doored:drawDoor()
    end
end

function Tile:blocksView()
    return self:isSolid() or (self.hasDoor and not self:doorIsOpen())
end


function Tile:drawVent()
    if self.pressurePlate then
        local r,gg,b,a = set_color(getColor(self.pressurePlate.color or "white"))
        
        local g = self
        
        local img = game:getAsset(
            (self.unit or self.item) and (self.pressurePlate.onSource or "items/buttons/on.png") or
            self.pressurePlate.offSource or self.pressurePlate.source or "items/buttons/off.png"
        )
        
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, g.w or tw, g.h or th)
        lg.draw(img, self.x+g.w/2, self.y-(g.h-th)+g.h/2, 0, gw, gh, iw/2, ih/2)
        
        set_color(r,gg,b,a)
        
    end
    
    if self.vent then
        local g = self.vent
        local img = game:getAsset(g.source or "vent.png")
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, g.w or tw, g.h or th)
        g.w, g.h = g.w or tw, g.h or th
        
        lg.draw(img, self.x+g.w/2, self.y-(g.h-th)+g.h/2, 0, gw, gh, iw/2, ih/2)
    end
    
end

function Tile:drawWeb()
    if self.web then
        local r,gg,b,a = set_color(getColor(self.web.color or "white"))
        local g = self.web
        local img = game:getAsset(g.source or "web.png")
        local iw, ih = img:getDimensions()
        local gw, gh = resizeImage(img, g.w or tw, g.h or th)
        g.w, g.h = g.w or tw, g.h or th
        lg.draw(img, self.x+g.w/2, self.y-(g.h-th)+g.h/2, 0, gw, gh, iw/2, ih/2)
        set_color(r,gg,b,a)
    end
end

function Tile:addWeb(w)
    if self.fires > 1 or (self.unit and self.unit.onFire) then
        self.web = nil
        return
    end
    
    if not self.web then
        self.web = w
    else
        self.web.color = w.color or self.web.color
        self.web.strength = self.web.strength + w.strength
    end
end

function Tile:isWebbable()
    if self.solid or self.fires > 1 or (self.unit and self.unit.onFire) then
        return false
    end
        
    return true
end

function Tile:splashPuddles()
    local done
    for x = 1, self.puddlesLen do
        done = true
        local p = self.puddles[x]
        
        self:drawSplash(p.color, p.value+.2)
        
        if p.value >= .25 then
            local value = p.value/2
            local newValue = p.value/8
            for d = 1, 4 do
                local dir = dirs4[d]
                local tile = self.room:getTile(self._x+dir[1], self._y+dir[2])
                if not tile.solid then
                    p.value = p.value - newValue
                    tile:addPuddle(lume.copy(p))
                end
            end
        end
    end
    
    return done
end

function Tile:spreadWater()
    local w = self.water
    
    if w and w.spread and not w.spreaded then
    
        local v = w.value or type(w.spread) == "number" and w.spread or 1
        
        local p = w
        p.value = v
        
        if v >= .125 then
            local newValue = v/4
            for d = 1, 4 do
                local dir = dirs4[d]
                local tile = self.room:getTile(self._x+dir[1], self._y+dir[2])
                if tile and not tile.solid then
                    local pp = lume.copy(p)
                    pp.value = newValue
                    tile:addWater(pp)
                end
            end
            
            p.value = p.value - newValue
            w.spreaded = true
        end
        
        
    end
end


function getPuddle(potion, force, value)
    if potion.data and potion.data.doGas or force then
        local puddle = {}
    
        puddle.data = potion
        puddle.color = (potion.data or potion).color
        
        puddle.uuid = lume.uuid()
        
        puddle.value = value or 1
        
        puddle.source = string.format("effects/stain/stain_%s.png", math.random(1,4))
        
        return puddle
    end
end

function puddleEvaporate(puddle)
   do
       local self = puddle.data or {}
       puddle.data = puddle.data or {}
            Gas:new({
                source = puddle.tile,
                buff = self.buff,
                buffIntensity = self.intensity,
                buffTime = self.buffTime,
                lifeBonus = -(self.gasAttack or 0),
                corrosive = self.corrosive or nil,
                color = self.pcolor or puddle.pcolor
            })
    end
end

function condenseGas(tile, gas)
    local parent = gas[3]
    
    local puddle = getPuddle(parent, true)
    
    tile:addPuddle(puddle)
    parent:releaseTile(tile)
    
end


function Tile:addPuddle(puddle)
    local data = self.puddlesTable[puddle.uuid]
    if data then
        data.value = data.value + puddle.value
    end
    
    self.puddles[self.puddlesLen+1] = puddle
    self.puddlesLen = self.puddlesLen + 1
    
    self.puddlesTable[puddle.uuid] = puddle
    
    self.room.checkPuddles[self] = true
    
    
    local col = lume.copy(getColor("white"))
    local v = 0
    for x = 1, self.puddlesLen do
        local p = self.puddles[x]
        v = v + p.value
        if p.color or p.data.color then
            col = addc(col, getColor(p.color or p.data.color), .5)
        end
    end
    
    self.puddleColor = {col[1],col[2],col[3],lume.min(v, 1/.75)*.75}
    
    self:drawSplash(puddle.color)
end

function Tile:removePuddle(puddle, x)
    if x then
        table.remove(self.puddles, x)
    else
        lume.remove(self.puddles, puddle)
    end
    
    self.puddlesTable[puddle.uuid] = nil
    
    self.puddlesLen = self.puddlesLen - 1
    
    
    local col = lume.copy(getColor("white"))
    local v = 0
    for x = 1, self.puddlesLen do
        local p = self.puddles[x]
        v = v + p.value
        if p.color or p.data.color then
            col = addc(col, getColor(p.color or p.data.color), .5)
        end
    end
    
    self.puddleColor = v ~= 0 and {col[1],col[2],col[3],lume.min(v, 1/.75)*.75}
    
    if self.puddlesLen <= 0 and not self.water then
        self.room.checkPuddles[self] = nil
    end
end

function Tile:drawPuddles()
    if self.puddlesLen <= 0 or self.ice then
        return
    end
    
    self.puddleSource = self.puddleSource or string.format("effects/stain/stain_%s.png", math.random(1,4))
    
    local col = lume.copy(getColor("white"))
    local v = 0
    for x = 1, self.puddlesLen do
        local p = self.puddles[x]
        v = v + p.value
        if p.color or p.data.color then
            col = addc(col, getColor(p.color or p.data.color), .5)
        end
    end
    
    self.puddleColor = {col[1],col[2],col[3],lume.min(v, 1/.75)*.75}
    set_color(self.puddleColor)
    
    local img = game:getAsset(self.puddleSource)--getValue(self.puddles).source)
    local iw, ih = img:getDimensions()
    local gw, gh = resizeImage(img, tw, th)
    lg.draw(img, self.x+tw/2, self.y-(th-th)+th/2, 0, gw, gh, iw/2, ih/2)
    
end

function Tile:drawSplash(color, alpha)
        
        local o = self
        
        local vv = 1.1*.5*(math.random(8,13))/10
        local tx = self.x+self.w/2
        local ty = self.y+self.h/2
        
        local obj = toybox.NewBaseObject({x=tx, y=ty, w = self.w*vv, h=self.w*vv})
        obj.solid = false
        obj.sprite = toybox.new_sprite(obj, {
            animations = {
                idle = {
                     source = "setpieces/splash",
                     delay = (nil and .03 or 0.05)/1.5,
                     mode = "once",
                     useImages = true,
                     onAnimOver = function()
                         obj:destroy()
                     end
                }
            }
        })
        obj.color = color
        obj.image_alpha = alpha or 1
        obj:center()--obj.offset_x=0 obj.offset_y=0
end

function Tile:checkPuddles()
    -- only actively evaporate if above normal temperature
    local evaporate = self:getTemperature() >= 10
    
    for x = 1, self.puddlesLen do
        local p = self.puddles[x]
        
        if p then
            p.value = p.value - .1
            
            local evaporate = p.value <= 0 or evaporate
            if evaporate then
                puddleEvaporate(p)
                self:addLog("A puddle evaporated")
                self:removePuddle(p, x)
            end
        end
            
    end
    
    self:spreadWater()
end

function Tile:addLog(...)
    return self.room:addLog(...)
end

function Tile:isAntiFire()
    local liquid = (self.water or self.puddle)
    hasFab = liquid and liquid.flammability
    
    if liquid and not hasFab then
        return true
    end
    
    return false
end

function Tile:isFlammable(noGrass)
    local tile = self
    local liquid = (self.water or self.puddle)
    hasFab = liquid and liquid.flammability
    
    if liquid and not hasFab then
        return false
    end
    
    do
        local burn = (
            --tile.unit and tile.unit:isFlammable() or
            tile.item and (tile.item.flammable or ((tile.item.flammability or 0)>0 and tile.item.flammability))
            or (not noGrass) and ((tile.grass and ((tile.grass.flammability or 0)>0 and tile.grass.flammability)))
            or self.explode and lume.distance(ogg._x,ogg._y,tile._x,tile._y)<=(self.range) and (log("expppp") or 1)
        )
        local ffl = type(burn) == "number" and burn or 0
        local fl = 0
        for x, i in pairs(tile.gases) do
            local f = i.flammability or i[3].flammability
            if f and f > 0 and x ~= self.uuid and i[1] > .01 then
                fl = lume.max(fl, f)
            end
        end
        fl = fl + ffl
    
        return fl>0 and fl or false
    end
end

function Tile:getFlammability(noGrass)
    return self:isFlammable(noGrass) or 0
end

function Tile:setType(name)
    if name == "stone" then
        self.solid = true
    elseif not self.edge and not self.keepSolid then
        self.solid = false
    end
end

function Tile:isLastWall()
    return self.edge
end

function Tile:solidify()
    self.solid = true
end

local morph = {
    rat = 150,
    goblin = 50,
    skeleton = 30,
    angel = 1
}

-- Trap:new(gas, fire, vents = int, ventDistance = {min,max}, onStep = null)
traps = {
    polymorphTrap = {
        name = "polymorphing trap",
        color = "lightgreen",
        
        onStep = function(tile)
            if tile.unit then
                tile.unit:polymorph(getValue(morph),5)
            end
        end
    },
    
    poisonGasTrap = {
        name = "poisonous gas",
        vents = {0,0,1,1,2},
        ventDistance = {2,6},
        color = "purple",
        
        gas = {
            intensity = 7,
            flammability = 2,
            color = gasColors.poison,
            range = 3,
            lifeBonus = -3
        },
    },
    
    
    paralysisGasTrap = {
        name = "paralysis gas",
        vents = {0,1,2,2,3},
        ventDistance = {2,6},
        
        gas = {
            intensity = 7,
            flammability = 2,
            color = gasColors.peach,
            range = 3,
            lifeBonus = -3
        },
    },
    
    confusionGasTrap = {
        name = "confusion gas",
        vents = {0,0,1,1,2},
        ventDistance = {2,6},
        color = "yellow",
        
        gas = {
            intensity = 7,
            flammability = 2,
            color = gasColors.yellow,
            range = 3,
            lifeBonus = -3
        },
    },
    
    fireTrap = {
        name = "fire trap",
        vents = {0,0,0,2,2},
        ventDistance = {2,6},
        color = "red",

        
        fire = {
            range = 2,
            inteneity = 4,
            forceSpread = true
        }
    },
    
    explosiveTrap = {
        name = "explosive gas",
        vents = {0,0,2,2},
        ventDistance = {2,6},
        color = "orange",
 
        
        fire = {
            range = 2,
            inteneity = 4,
            explode = true,
            forceSpread = true
        }
    }
}

Trap = class:extend("Trap")

function Trap:__init__(k)
    self.gas = k.gas
    self.fire = k.fire
    self.name = k.name
    
    self.color = k.color or nil
    
    self.ventsNumber = getValue(k.vents or 0)
    self.ventDistance = k.ventDistance or {5,10}
    
    self.onStep = k.onStep or k.onSteppedOn or null
    self.onRelease = k.onRelease or k.onReleased or k.onOff or null
    
    self.pressurePlate = {parent=self, color=self.color or nil}
    self.vents = {}
end

function Trap:deactivate()
    self.activated = false
    self.onRelease(self.pressurePlate.tile)
end

function Trap:activate()
    local vents = #self.vents
    
    self.onStep(self.pressurePlate.tile)
    self.activated = true
    
    if vents > 0 then
        self.pressurePlate.tile:addLog(
            self.gas and string.format("%s creeps out from underneath %s vent%s!",
                self.gas.name or self.name or "gas", vents > 1 and "some" or "a", vents > 1 and "s" or ""
            ) or
            self.fire and string.format("%s roar out from underneath %s vent%s!",
                self.fire.name or self.name or "flames", vents > 1 and "some" or "a", vents > 1 and "s" or ""
            )
        )
    else
        self.pressurePlate.tile:addLog(
            self.gas and string.format("%s seeps out from the pressure plates!",
                self.gas.name or "gas"
            ) or
            self.fire and string.format("%s roar out from underneath the pressure plate!",
                self.fire.name or "flames"
            ) or
            "A pressure plate clicked"
        )
    end
    
    for x = 1, lume.max(#self.vents, 1) do
        local v = self.vents[x] or self.pressurePlate
        
        if self.gas then
            self.gas.source = v.tile
            Gas:new(self.gas)
        end
        
        if self.fire then
            self.fire.source = v.tile
            Fire:new(self.fire)
        end
    end

end

function Trap:setup(room, pos)
    room = room or toybox.room
    self.room = room
    
    local pos = pos and pos.isTile and pos or (pos or room):getRandomSpaceTile()
    
    self.tile = pos
    
    self.pressurePlate.x = pos.x
    self.pressurePlate.y = pos.y
    self.pressurePlate.tile = pos
    
    pos.pressurePlate = self.pressurePlate
    
    local min = self.ventDistance[1]
    local max = self.ventDistance[2]
    local ventsToMake = self.ventsNumber
    
    while ventsToMake > 0 do
        local tile = pos
        local count = 0
        local notPlaced = true
        
        while (notPlaced) do
        
            if count > 30 then
                tile = self.room:getRandomSpaceTile()
            else
                tile = pos.roomData:getRandomSpaceTile()
            end
            
            count = count + 1
            
            notPlaced = false
            for x = 1, #self.vents + 1 do
                local vent = self.vents[x] or pos
                local dis = lume.distance(vent._x, vent._y, tile._x, tile._y)
                
                if (dis > max or dis < min) then
                    notPlaced = true
                    break
                end
            end
                
            if count > 100 then
                error("Vents are shizzy")
            end
        end
        
        ventsToMake = ventsToMake - 1
        self:addVent(tile)
    end
    
    
end

function Tile:isSolid()
    return self.solid or self.item and self.item.isWall
end

function Tile:isFreeSpace()
    return not self:isSolid() and
    not self.pressurePlate and
    not self.chasm and
    (not self.water or not self.water.isDeep)
end

function Tile:unlock()
    if not self.isLocked then
        return
    end
    
    self.isLocked = false
    self.solid = false
end

function Tile:makeDoor(locked)
    self.hasDoor = true
    self.isEntrance = true
   -- self.doored = true
   -- self.source = "tile.png"
   
    if self.hasWall then
        self.room:destroyItem(self.hasWall)
    end
    
    local t = self.room:getTile(self._x, self._y-1)
    if nil and t then
        t.doored = self
        t.source = "tile.png"
    end
    
    if locked then
        self.isLocked = true
        -- no! (for proper drawing) self.solid = true
    end
    
    local dung = self
    local doneIt = 0
                for ii = 1, 2 do
                    for x = 1,8 do
                        local d = dirs8[x]
                        local tt = self.room:getTile(dung._x+d[1], dung._y+d[2])
                        if tt and (not tt:isSolid()) then
                            tt.isEntrance = true
                            tt.isCorridor = true
                            doneIt = doneIt+1
                            -- tt.draw=function(self) draw_rect("fill",self.x,self.y,self.w, self.h) end
                        end
                    end
                end
                
                if doneIt < 4 then error(doneIt.." cleared is not enough space made for doors") end
end

function Trap:addVent(tile)
    local v = {
        _x = tile._x, _y = tile._y,
        tile = tile
    }
    
    -- doesn't really matter if a tile has more than 1 vent from different traps
    tile.vent = v
    self.vents[#self.vents+1] = v
    
    return v
end

function Trap.loadTrap(data, pos)
    local trap = Trap:new(data)
    trap:setup(toybox.room, pos)
    
    return trap
end

BACKGROUND = 0
GOOI = 4
FOREGROUND = 10


local n = "nearest"
love.graphics.setDefaultFilter(n,n)

tw, th = 125
th = tw

Room = class:extend("Room")
function Room:__init__(k)
    toybox.make_grid(self)
    self.getRandomSpaceTile = getSpaceTile
    
    
    self.parent = k.parent or toybox.room
    self.data = k.data
    
    self.onEnter = k.onEnter or null
    self.onLeave = k.onLeave or null
    
    self.room = self.parent
    
    self.walls = {}
    self.tiles = {}
    self.spaces = {}
    
    self.digOffsetx = 0
    self.digOffsety = 0
    
    local room = self.data
    
    if k.simple then return end
    
    --if #room.walls>0 then return {floors = room.spaces, walls = room.walls} end
    
    --check Bottom should actually be top(in kivy coords) else switch
    local spaces = {}
    local walls =  {}
    local color = getValue(colors)
    local function dd(self)
        local r,g,b,a = set_color(color)
        draw_rect("line",self.x,self.y,self.w,self.h)
        set_color(r,g,b,a)
    end
    
    local top = room:getTop()+self.digOffsety
    local bottom = room:getBottom()+self.digOffsety
    local left = room:getLeft()+self.digOffsetx
    local right = room:getRight()+self.digOffsetx
    for t = top-1,bottom+1 do
        for r = left-1,right+1 do
            local dung = self.parent:getTile(r,t)
            
            if dung then
                --dung.__draw = dd
                
                dung.roomData = self
                dung.realRoom = k.real and self
                if dung.solid then-- == "wall" then
                    table.insert(self.walls,{x=r,y=t,[1]=r,[2]=t})
                else
                    table.insert(self.spaces,{x=r,y=t,[1]=r,[2]=t})
                    for x = 1,8 do
                        local d = dirs8[x]
                        local tt = self.parent:getTile(dung._x+d[1], dung._y+d[2])
                        if tt and (tt.isCorridor or tt.hasDoor) then
                            dung.isEntrance = true
                            break
                        end
                    end
                end
            end
            
            self:storeTile(dung)
        end
    end
    
    self.doors = {}
    local function addDoor(x,y)
        local tile = self.parent:getTile(x,y)
        self.doors[#self.doors+1] = tile
        self.parent.doors[#self.parent.doors+1] = tile
    end
    
    self.data:getDoors(addDoor)
    self.roomTypes = {}
    
    self._x = self.minTileX
    self._y = self.minTileY
    self.w  = right-left+2
    self.h  = bottom-top+2
end

--data.grasses = {}
grasses = {}
grasses.grass = {
    source = "grass/grass.png",
    variant = "tallGrass",
    variantChance = 50,
    flammability = 1
}

grasses.tallGrass = {
    source = {"grass/tallgrass.png","grass/tallgrass2.png"},
    flammability = 1,
    h = th*2
}

local roomy, ggrass
local function grassy(x,y,v)
    ggras = 
        (ggrass.variant and math.random(100)<=(ggrass.variantChance or 10) and 
        grasses[ggrass.variant] )
        or ggrass
    
    ggras.w, ggras.h = ggras.w or tw, ggras.h or th
    
    if v == 1 then
        local t = roomy.isTile and roomy or roomy:getTile(roomy.minTileX-1+x, roomy.minTileY-1+y)
        if t and not t.solid then
            t.grass = lume.copy(ggras)
            t.grass.source = getValue(ggras.source) --elseif t then t.solid = false
         elseif t then t.solid=true end
    end
end

function Map:makeGrass(tile, grass)
    roomy, ggrass = tile, grass or grasses.grass
    grass = ggrass
    grass.w, grass.h = grass.w or tw, grass.h or th
    
    grassy(nil,nil,1)
end

function Map:grassify(room, grass)
    roomy, ggrass = room, grass
    grass.w, grass.h = grass.w or tw, grass.h or th
    
    local r = toybox.rot().Map.Cellular(self.digW, self.digH/(z==3 and 2 or 1), {
        --caveChance = z==3 and 1 or 0
    })
    
    r:randomize(.6)
    
    r:create(grassy)
    
    roomy, ggrass = nil
end


    local draws = function(self)
        local s = self
        local r,g,b,a = set_color(1,1,1,self.alpha)
        lg.circle("line",s.x+s.b.shake_x,s.y+s.b.shake_y,s.size1)
        -- so alpha of 1 plus .5 equals .5
        set_color(getColor("white",(self.alpha+.5)/3))
        lg.circle("fill",s.x+s.b.shake_x,s.y+s.b.shake_y,s.size)
        lg.circle("fill",s.x+s.b.shake_x,s.y+s.b.shake_y,s.size2)
        set_color(r,g,b,a)
    end
    
function Map:shout(tile,max)
    
    local s = {x=x,y=y,draw=draws}
    s.max = max or tw
    max = s.max
    s.size1 = 0
    s.size = 0
    s.size2 = 0
    
    
    s.x = tile.x+tw/2
    s.y = tile.y+th/2
    
    s.alpha = 0
    
    local time = 1*(max/(tw*10))
    
    local out2 = function()
        self.sounds[s] = nil
        s.b:destroy()
    end
    
    local function out()
        -- self:after(.1,out2)
        self:tween(.2,s,{alpha=0},"out-quad",out2)
    end
    
    local function out3()
        self:tween(time,s,{size2=s.max},"out-quad",out)
    end
    
    local function out1()
        self:tween(time*.7,s,{size=s.max},"out-quad")
        self:after(time*.25, out3)
    end
    
    local function start()
        self:tween(time*.5,s,{size1=s.max},"out-quad")
        self:after(time*.25, out1)
    end
    
    local b = toybox.NewBaseObject({x=s.x,y=s.y,solid=false})
    self:must_update(b)
    b.__drakw = null b.debug=1
    self:must_draw(b)
    s.b = b
    b:shake(35,time,300)
    
    self:tween(.02,s,{alpha=1},"in-quad",start)
    
    self.sounds = self.sounds or {}
    self.sounds[s] = true
end
    


function Map:fixCorridors()
    for x, i in ipairs(self.digger._corridors) do--:getRooms()) do
        --for xx, cor in ipairs(i.corridors) do
    self.map = self
    local sx, sy, length, dx, dy = i._sx, i._sy, i._length, i._dx, i._dy
    local digCallback = function(x,y,nn,ii) 
       local t = self.map:getTile(x,y) --t.debug=1
       if t then 
       --t.crazy = 4 
       t.isCorridor = ii 
       --if t._cdug then return end
       end
       self.digC(x,y,nn,ii)
       --local r = self.digger:saveTunnel(x,y,nn,ii)
       --if ii then assert(t.isCorridor) end
    end
    
    local fillUp = math.random(1,100)>35
    local fillDown = math.random(1,100)>(not fillUp and 20 or 70)
    if math.random(1,100)>50 then
        local filUp = fillUp
        fillUp = fillDown
        fillDown = filUp
    end
    
    local stair, dos, _nildos, nildos = math.random(2,3), true, math.random()>.5
    
    for i=0,length-1 do
        local x=sx+i*dx
        local y=sy+i*dy
    
        local lx = 1--lume.max(3,length) 
        
        if dy~=0 then
            --Make roof and floor corridors
            if fillUp or truek then
            digCallback(x-1,y,0,1)
            end
            if fillDown or truek then
            digCallback(x+1,y,0,1)
            end
            
            
            --make corridors extend into rooms
            for ll = 0, mm0 or lx do
                digCallback(x,y+ll,nil,1)
                digCallback(x,y-ll,nil,1)
            if fillUp or truek then
            digCallback(x-1,y+ll,0,1)
            end
            if fillDown or truek then
            digCallback(x+1,y-ll,0,1)
            end
            if fillUp or truek then
            digCallback(x-1,y-ll,0,1)
            end
            if fillDown or truek then
            digCallback(x+1,y+ll,0,1)
            end
            end
            
            if fillUp and fillDown then
                if dos and stair == 3 then
                    local t = self.map:getTile(x+3,y+2)
                    if t then
                        --t:solidify(nil,true)
                        t._cdug = true
                    end
                    stair = 2
                    dos = false
                elseif dos and stair == 2 then
                    local t = self.map:getTile(x-1+2,y+2)
                    if t then
                        --t:solidify(nil,true)
                        t._cdug = true
                    end
                    stair = 3
                    dos = false
                elseif dos==false then
                    dos = nil
                    nildos = _nildos
             --   elseif nildos then
                    nildos = nil
                else
                    dos = true
                end
            elseif fillUp or fillDown then

                if dos and stair == 3 then
                    local t = self.map:getTile(x+2,y+2)
                    if t then
                       -- t:solidify(nil,true)
                        t._cdug = true
                    end
                    stair = 2
                    dos = false
                elseif dos and stair == 2 then
                    local t = self.map:getTile(x+(fillUp and -1 or 1)+2,y+2)
                    if t then
                        --t:solidify(nil,true)
                        t._cdug = true
                    end
                    stair = 3
                    dos = false
                elseif dos==false then
                    dos = nil
                    nildos = _nildos
                --elseif nildos then
                    nildos = nil
                else
                    dos = true
                end
            end
        end
        if dx~=0 then
            if fillUp then
            digCallback(x,y-1,0,1)
            end
            if fillDown then
            digCallback(x,y+1,0,1)
            end
            
            for ll = 1, lx do
                digCallback(x-ll,y,nil,1)
                digCallback(x+ll,y,nil,1)
            if fillUp then
            digCallback(x-ll,y-1,0,1)
            end
            if fillDown then
            digCallback(x-ll,y+1,0,1)
            end
            if fillUp then
            digCallback(x+ll,y-1,0,1)
            end
            if fillDown then
            digCallback(x+ll,y+1,0,1)
            end
            end
        end
        
        if nil then--i == length-1 or i == 0 then
            if dy ~= 0 then
                local diff = 1
                if up then
                    diff = -1
                end
                
                digCallback(x+diff, y,0,1)
            else
                local diff = 1
                if up then
                    diff = -1
                end
                
                digCallback(x,y+diff,0,1)
            end
        end
    end
    end
end


local function getOld(name)
    return oldMap and oldMap[name]
end

function Map.depth_sorter(a, b)
  if not a.depth then error(inspect(a,1)) end
  if not b.depth then error(inspect(b,1)) end
  
  local bd, ad = b.depth, a.depth
  
  local ay, by = a.tile and a.tile.y or a.y or 0, b.tile and b.tile.y or b.y or 0
  
  bd = bd + by/tw
  ad = ad + ay/tw
  
  if bd == ad then
      b.time_alive = b.time_alive or 1
      a.time_alive = a.time_alive or 0
      return b.time_alive > a.time_alive
  end
  

  return bd > ad--.depth
end

function Map:setup(k)
    self.camera._flash = self.camera.flash
    
    k = k or {}
    currentWaterSource = "wat/0.png"
    local c = 0
    self.timer:every(.3, function()
        c = c + 1
        if c > 3 then c = 0 end
        currentWaterSource = string.format("wat/%s.png",c)
    end)
    
    self.items = {}
    
    toybox.make_grid(self)
    self.getRandomSpaceTile = getSpaceTile
    
    self.rooms = {}
    self.doors = {}
    
    --self.player:move_to(t.x,t.y)
    local m = req "map.mutation"
    mmm=m({})
    self.mutator = mmm
    
    self.binaryGrid = {}
    local n, nh = 3,2,10, 10--addsk
    self.digW, self.digH = n*8+2,nh*8+2,60,35,50,40,70, 50,50,30--250,30--scale =
    nn = 0
    local gridTmp = {}
    local function rmake(x,y,v,isCorridor)
        --gridTmp[x] = gridTmp[x] or {}
        
        gridTmp[#gridTmp+1] = {x,y,v,isCorridor}
    end
    
    local function make(x,y,v,isCorridor,e,xx,yy)
        if  xx > self.maxSpaceX+5 or x < self.minSpaceX-5 or
            yy > self.maxSpaceY+5 or y < self.minSpaceY-5 then
            
            return
        end
        
        local t = self:getTile(x,y) or Tile:new({
            _x = x,
            _y = y,
            x = (x-1)*tw-nn,
            y = (y-1)*th,
            solid = v == 1
        })
        t.space = v ~= 1
        t.isCorridor = isCorridor
        t.isEntrance = isCorridor
        t.isEntrance = v == 2
        
        
        
        if v ~=0 and v~=1 then error() end
        t.edge = t._x == 1 or t._y == 1 or t._x == self.digW or t._y == self.digH
        
       -- tv==1
        if t.solid and t.space and (self.caving and not t.realRoom or not self.caving) 
        and not t.isCorridor then
            t.solid = v==1--false
        end
        if v==0 and not t.keepSolid then
            t.solid = false
        end
        
        if t.edge then
            t.solid = true
        end
        
        self:storeTile(t)
        t.roomData = self
        
    end assert(items)
    self.digC = make
    
    local maps = {"Cellular","Brogue","IceyMaze","Brogue"}
    local okay
    local r
    
    for xx = 1, 4 do
    local countm = 0
    
    while not okay do
        countm = countm + 1
        local function nm()
            self.minSpaceX, self.minSpaceY, self.maxSpaceX, self.maxSpaceY = nil
            -- fps
            local allTiles = {}
            local function rmake(x,y,v,c,e)
            
        if v ~= 1 then
            self.minSpaceX = lume.min(self.minSpaceX or math.huge, x)
            self.maxSpaceX = lume.max(self.maxSpaceX or -10, x)
            
            self.minSpaceY = lume.min(self.minSpaceY or math.huge, y)
            self.maxSpaceY = lume.max(self.maxSpaceY or -10, y)
        end
                allTiles[#allTiles+1] = {x,y,v,c,e}
            end
            local z = 1
            if z == 2 then self.caving = true end
            r = toybox.rot().Map[xx==55 and "IceyMaze" or maps[z]](self.digW, self.digH/(z==3 and 1 or 1), {
                caveChance =1,--xx==2 and 1 or 0, z==2 and 1 or 0,
                chavePasses = 14,
                maxRooms = 12, 
                minRooms=8,
                roomWidth = {3,4,5,7},--{3,4 or 6},
                croussWidth = {0,0},
                crossHieight = {0,0},
                -- maxRooms = 11
     
                 corridorWidth = {1,1,1,2,2,2,4,5},--,10},
                 corridorHeight = {1,1,1,1,1,3,5,2},--10},
                 corridorChance = .3 or .9,
            })
            
            if maps[z] == "Cellular" then
                r:randomize(.25)--floorProb
            end
            for x = 1, z<3 and 1 or z==2 and 1 or 1 do
                r:create(rmake)
            end
            r.getRooms = r.getRooms or function() return {} end
            
            if #r:getRooms() <= 5 and countm<50 then
                gridTmp = {}
                goto skip--return nm()
            end
            
            if #r:getRooms() >= 10 and countm<50 then
                goto skip
            else
                okay = true
                for x, i in ipairs(allTiles) do
                    local xx, yy = 0, 0--self.minSpaceX-5, self.minSpaceY-5
                    make(i[1]-xx, i[2]-yy, i[3], i[4], nil, i[1], i[2])
                end
            end
            
            local d = {}
            for _, door in ipairs(r.getDoors and r:getDoors() or {}) do
                local t = self:getTile(door.x, door.y)
                if t and not t.door then
                    t:makeDoor()
                    d[#d+1] = t
                end
            end
            
            for x , room in ipairs(z==4 and {} or r.getRooms and r:getRooms() or {}) do
                local ro = Room:new({
                    parent = self,
                    data = room,
                    real = true, math.random()>.9,--true
                })
                --ro.doors = d
                mmm.cave=null--:cave(ro)
                local room = ro
                --mmm:dig({x=room._x,y=room._y,w=room.w,h=room.h,type="Brogue",caveChance=0,room=room})
                
                --room mutation
                --mmm:random(ro)
                self.rooms[#self.rooms+1] = ro
                self:grassify(ro, grasses.grass)
            end
            
            self.digger = r
            --self:fixCorridors()
            self.caving = false
            
            ::skip::
        end
    
        if z == 2 then
            nm()--self:after(5,nm)
        else
            nm()
        end
    
    end
    
    -- fixing blocked passages
    for i, tile in ipairs(self.allTiles) do
        if tile.solid then
            local r = tile.roomData
            local continue = false
            for x = 1, 8 do
                local d = dirs8[x]
                local t = self:getTile(tile._x+d[1], tile._y+d[2])
                if t and not t.solid then
                    continue = true
                    break
                end
            end
            
            continue = continue and tile.roomData ~= self
            
            for ii, x in ipairs(tile.roomData.doors) do
            
                if not continue then
                    break
                end
            
                -- finding which side of the door is open
                local t2 = self:getTile(x._x+1,x._y)
                if (t2 and t2.solid) then
                    if tile._y == x._y and tile._y ~= r.maxTileY and tile._y ~= r.minTileY then
                        tile.solid = false
                        break
                    end
                else
                    if tile._x == x._x and tile._x ~= r.maxTileX and tile._x ~= r.minTileX then
                        tile.solid = false
                        break
                    end
                end
            end
            
            if not tile.solid then
                warn("[MAP GEN] Fixed blocked tile!")
                tile.fixed = true
            end
        end
    end
    
    
    for x = 1,#gridTmp do
        local i = gridTmp[x]
        --make(i[1],i[2],i[3],i[4],i[5])
    end
    gridTmp = {}
    end
    
    --[[for x, t in ipairs(self.allTiles) do
    
        if t.solid then
            t.solid = false
            items.sack = {
            source = "warcrawl/sacks4.png",
            isObstacle = true,
            h = th*2, life=5
            }
            self.sack = self:spawnItem("sack", t)
        end
    end]]
    
    
    local function closeness(r,r2)
        return r.allTiles[1].x<r2.allTiles[1].x
    end
    
    table.sort(self.rooms, closeness)
    local mid = self:getTile(math.floor(self.maxTileX/2), math.floor(self.maxTileY/2))
    --self.timer:every(.1,function() self.camera.scale = .1 lightAll=1 self:set_target(mid) end)
    
    self:grassify(self, grasses.grass)

    
    self.mapGrid = {}
    --local t = self.rooms[1]:getRandomSpaceTile()--:getPosition("space",self.rooms[1])
    
    for x,c in ipairs(self.allTiles) do
        local x,y = c._x, c._y
        self.mapGrid[y] = self.mapGrid[y] or {}
        self.mapGrid[y][x] = c
    end

	function isOpen(t)
        if t.solid then
            return false
        else
            return true
        end
	end

    self._grid = JumperGrid(self.mapGrid)
    self.pathfinder = PathFinder(self._grid,"ASTAR",
        isOpen
    )

    self.pathfinder:setMode("ORTHOGONAL")
    
    self.stateMachine = StateMachine:new({
        map = self
    })
    
    self.level = k.level
    self.hasUpstairs = k.next
    self.first = not k.next
    
    self.cameraMan = {x=0,y=0,scale=.5}
    self.cameraMan.scale = .5
    self:set_target(self.cameraMan)
    self.set_target = self.Y
    self:set_target(t)
    
    self.creatures = {}
    self.currentCreature = 0
    
    
    
    self.gases = {}
    self.fires = {}
    
    self.trapsToActivate = {}
    
    self.checkPuddles = {}
    
    self.playerData = {
        inventory = {},
        inventoryItems = {},
    }
    
    self.traits = {}
    self.allTraits = {}
    self.allTraitButtons = {}
    self.allDoubleTraits = {}
    
    self.useFunc = function()
        local self = toybox.room
        local item = self.currentItem
        
        self:removePopUp()
        
        if item.useText == "equip" then
            self.inventoryUser:equipItem(item)
        end
        
        if not item:onUse(self.inventoryUser, self) then
            self:playNextCreature()
        end
    end
    
    self.dropFunc = function()
        local self = toybox.room
        local item = self.currentItem
        self.inventoryUser:removeItem(item, nil, 10)
        
        self:removePopUp()
        
        self:playNextCreature()
    end
    
    self.throwFunc = function()
        local self = toybox.room
        self.throwing = self.currentItem
        self.clicked = true
        self:removePopUp()
    end
    
    
    self.chooseItemFunc = function(button)
        local self = toybox.room
        self.choosingItem.action(self.currentItem, self)
        self.choosingItem = false
        self:removePopUp()
    end
    
    local g = "inv"
    self:activate_gooi()
    gooi.currentGroup = g
    local iw, ih = W()/3.4, H()*.95
    local inv = 16
    self.inventoryPanel = getOld("inventoryPanel") or gooi.newPanel({
        group = g,
        x = W()-iw-10, y = H()/2-ih/2,
        w = iw, h = ih, paddingY=0,
        layout = string.format("grid %sx1",inv)
    })
    --gooi.removeComponent(self.inventoryPanel)
  
    --[[local iw, ih = W()/3.4, H()*.95
    local inv = 16
    self.inventoryPanel = gooi.newPanel({
        group = g,
        x = 10, y = H()/2-ih/2,
        w = iw, h = ih,
        layout = string.format("grid %sx1",inv)
    })]]
    
    local invp = self.inventoryPanel
    invp.opaque = true
    
    self.inventoryHeader = getOld("inventoryHeader") or gooi.newPanel({group=g, layout="grid 1x7",padding=3,paddingY=2})
    
    self.inventoryCancel = getOld("inventoryCancel") or gooi.newButton({
        group = g,
        text = "[X]", -- [amount] (size)",
    }):center():onRelease(function()
        toybox.room:closeInventory()
    end)
    
    self.inventoryButton = getOld("inventoryButton") or gooi.newButton({
        group = g,
        text = "Inventory", -- [amount] (size)",
    }):center():onRelease(function()
      --  self:closeInventory()
    end)
    
    if not oldMap then
        local font = font10
        self.inventoryButton.font = font
        self.inventoryPanel:add(self.inventoryHeader)
       
        self.inventoryHeader:setColspan(1,2,4)
    
        -- self.inventoryButton.showBorder = false

        self.inventoryHeader:add(self.inventoryCancel)
        self.inventoryHeader:add(self.inventoryButton)
    end
    
    local function moveRight(b)
        local self = toybox.room
        local c = self.currentInvPage or 1
        local max = self.invPages
        if (c+1) <= max then
            self.lastPage = c+1
            self:reloadInventoryUI(nil, c+1)
        end
    end
    
    local function moveLeft(b)
        local self = toybox.room
        local c = self.currentInvPage or 1
        local max = self.invPages
        if (c-1) > 0 then
            self:reloadInventoryUI(nil, c-1)
        end
    end
    -- reloadinv
    self.invRight  = getOld("invRight") or gooi.newButton({text=">"}):onRelease(moveRight)
    self.invLeft   = getOld("invLeft") or gooi.newButton({text="<"}):onRelease(moveLeft)
    
    if not oldMap then
        self.inventoryHeader:add(self.invLeft)
        self.inventoryHeader:add(self.invRight)
    end
    
    self.inventoryUI = getOld("inventoryUI") or {}
    
    local function popUpItem(inv)
        if inv.data then
            toybox.room:itemPopUp(inv.data[1])
        end
    end
    
    for x = 1, oldMap and 0 or inv-1 do
        local invP = gooi.newPanel({group=g,layout="grid 1x5",padding=3,paddingY=0})
        local invB = gooi.newLabel({text="", font=lg.getFont()}):left():onRelease(popUpItem)
        invB.opaque = true
        invB.borderRadius = 0
        invB.yOffset = 0
        local invS = gooi.newButton({font=lg.getFont(),text=""})
        invS.showBorder = true
    
        self.inventoryPanel:add(invP)
        invP:setColspan(1,1,5)
        invP:add(invB)
        -- invP:add(invS)
        invP.b = invB
        invP.s = invS
        invB.panel = invP
        --invB.showBorder = true--false
        if x == 1 then
            self.inventorySpace = invB
            invB.opaque = false
        else
            self.inventoryUI[x-1] = invB
        end
        invB.font = font
        --invS.font = font
    end
    
    if oldMap then
        self.inventorySpace = getOld("inventorySpace")
    end
    
    local oow, ooh = 50
    self.openInvButton = getOld("openInvButton") or gooi.newButton({
        text = "()",
        w = oow, h = ooh or oow,
        x = W()-oow-10,
        y = 10, group = g
    }):onRelease(function()
        toybox.room:openInventory()
    end)
    
    gooi.removeComponent(self.openInvButton)
    self:closeInventory()
    
    local slot
    
    local function quickedItem(item, sl)
        local self = toybox.room
        slot = slot or sl or self.freeQuickSlots[1]
        
        if not slot then
            return
        end
        
        if slot.item then
            slot.item.quickslot = nil
        end
        
        if item.quickslot then
            item.quickslot.item = nil
        end
        
        --self:toast(item.name, "skyblue")
        
        slot.item = item
        lume.remove(self.freeQuickSlots, slot)
        --slot.icon = item.sprite and item.sprite.source or game:getAsset(item.source)
        item.quickslot = slot
        if self.player then
            -- self.player:cry(item.name)
        end
        slot:shake(25,.5,35,"Y")
        slot = nil
    end
    
    self.putItemInQuickSlot = quickedItem
    
    local function selectQuickItem(n)
        local self = toybox.room
        if n.item then
            self:toast(n.item.name, "skyblue", nil, nil, nil, -50)
        end
        
        if n.item and self.quickItem == n.item then
            
            
            local ni = n.item
            --self.player:cry(n.item.name)
            local throw = (ni.isPotion and data.knownPotions[ni._id] or not ni.isPotion) and ni.utility<0 and not ni.isScroll and not ni.isWand
            
            n.borderColor = getColor("green")
            self:addLog(string.format("%s %s", throw and "throwing" or "using", n.item.title))
            
            local function nullc()
                n.borderColor = nil
            end
            
            self:after(.2,nullc)
            if throw then
                self.currentItem = n.item
                self.throwFunc()
            else
                n.item:onUse(self.inventoryUser, self)
            end
            
            self.quickItem = nil
            return
        elseif n.item then
            local useText = n.item.useText or "use"
            local ni = n.item
            if (ni.isPotion and data.knownPotions[ni._id] or not ni.isPotion) and ni.utility<0 and not ni.isScroll and not ni.isWand then
                useText = "throw"
            end
            
            self:toast(string.format("click again to %s",useText))
            self.quickItem = n.item
            return
        end
        
        self.quickItem = nil
        
        slot = n
        self:reloadInventoryUI(self.player)
        self:openInventory()
    
        self.choosingItem = {
            chooser = self.player,
            canCancel = true,
            tile = self.player.tile,
            cancelText = "...",
            noPrompt = true,
            text = "enchant",
            action = quickedItem
        }
    end
    
    local qpad = 5
    local sc = .6
    local qw = W()*.6*sc
    local qh = 116.3*sc+20--(qw/6)--+qpad*5--H()/10
    qw = qw + (10+qh)*2
    self.quickslots = oldMap and oldMap.quickslots or gooi.newPanel({group = g,
        w = qw,
        x = invp.x - qw - 10,--W()/2-qw/2,
        y = H()-qh-10, 
        h = qh,
        layout = "grid 1x8", padding = qpad
    })
    self.quickslotButtons = getOld("quickslotButtons") or {}
    self.freeQuickSlots = getOld("freeQuickSlots") or {}
    
    local b
    for x = 1, oldMap and oldMap.quickslots and 0 or 8 do
        b = gooi.newButton({text=""})
        self.quickslots:add(b)
        b:onRelease(selectQuickItem)
        self.quickslotButtons[x] = b
        self.freeQuickSlots[x] = b
    end
    
    local function skipTurn()
        local self = toybox.room
        if self.player.playing then
            self:playNextCreature()
        end
    end
    
    local function re_equip(r)
        if self.player.playing then
            local n = self.player.equipped
            if n then
                self.player.oldEq = n
                self.player:unequipItem(self.player.equipped)
                r:shake(20,.2,14,"Y")
            elseif self.player.oldEq and self.player:hasItem(self.player.oldEq) then
                self.player:equipItem(self.player.oldEq)
                self.player.oldEq = nil
                r:shake(20,.2,14,"Y")
            else
                self:toast("No item to re-equip")
                r:shake(20,.2,20)
            end
        end
    end
            
    self.waitButton = getOld("waitButton") or gooi.newLabel({text="...",group=g,w=b.w,h=b.h,y=b.y,x = 10})
        :onRelease(skipTurn)
    self.waitButton.opaque = true
    
    self.equipButton = getOld("equipButton") or gooi.newLabel({text="",group=g,w=b.w,h=b.h,y=b.y-5-b.h, x = 10})
        :onRelease(re_equip)
    
    self.equipButton.opaque = true
    
    local eq = self.equipButton
    self.eqImage = getOld("eqImage") or eq:addImage("fist.png")
    
    
    self.noiseManager = NoiseManager:new({})
    self.nm = self.noiseManager
    self.noise = self.nm
    self:getFov()


    local function reflectivityCB(lighting, x, y)
        local t = self:getTile(x,y)--local key=x..','..y
        return t and not t.solid and .3 or .4
    end
    
    local function lightTile(x, y, light)
        local t = self:getTile(x,y)
        if t then
            t.lightColor = {light[1]/10,light[2]/10,light[3]/10} if nnt then warn(inspect(light)) end
        end
    end
    
    self.lightTile = lightTile
    
    self.lighting=ROT.Lighting(reflectivityCB, {range=12, passes=1})
    self.lighting:setFOV(self.fov)


    
    self.exploding = 0
    self.currentTurn = 1
    
    self.logs = {}
    
    self._x, self._y = 0,0
    self.w, self.h = self.maxTileX, self.maxTileY
    self.rooms = {self}

    
    loadPrefabs(self)
    
    --self:getCavern()
    local ddone, oCount, tilesCount = self:getLake()
    
    --self:build(dungeon[self.level or self.next and error() or 1])

    
    if not ddone then
        warn("[LAKE GEN] "..tilesCount.." smaller than "..oCount..", "..(didDoor and "didDoor" or "no door"))
    end
    
    self:spawnPlayer(k.player or self.player, self.previousTile or self.rooms[1]:getRandomSpaceTile())
    
    
     --Trap.loadTrap(traps.poisonGasTrap, self.rooms[1])
    
    local v = VelocityController:new()
    v:attach(self.player)
    self.player.controller = v
    
    self.classic = false and true
    
    --self:gass()
    self:playNextCreature()
    
    self.player.canPickItems=1
    self.player.title = "you"
    self.player.name = "human"
    self.player.article = ""
    self.player.titlePossessive = "your"
    self.player.pronoun = "your"
    
    _G.pl = self.player
    
    --self.nm:addNoise("step",5,self.player.tile) --
    self:every({3,10},function() 
    --self:spawn("pig",nil,{self.player.team,"pig",false}) 
    end)-- error(self.nm:giveInfo()) end)
     
     
    if not oldMap then
        self:addDebugControls()
    end
end

function Map:toast(text, color, xx, yy, x2, y2)
    local f = lg.getFont()
    local s= (2)*math.random(90,120)/100
    local x,y = self.camera:toWorldCoords(
        W()/2-f:getWidth(text)*s*.5+(x2 or 0),
        H()-100-f:getHeight()*s+(y2 or 0)
    )
    
    local t = Text:new({
        x = xx or x,
        y = yy or y,
        text = text,
        color = color,
        scale = s,
        b = "",
        angle = math.random(-15,15)
    })
    t.vy=-50
    self:must_update(t)
end



function Map:alert(text, color, xx, yy, x2, y2)
    local f = font20 or lg.getFont()
    local s= (2)*math.random(90,120)/100
    
    local tt = Sentence:new({instant=true,x=0,y=0,w=W()})
    tt:newText(text)
    
    local ttext = tt.shortText
    
    local x,y = self.camera:toWorldCoords(
        W()/2-f:getWidth(ttext)*s*.25+(x2 or 0),
        H()/2-f:getHeight()*s*.5+(y2 or 0)
    )
    
    local t = Text:new({
        x = xx or x,
        y = yy or y,
        text = text,
        color = color or "crimson",
        scale = s,
        b = "",
        background = .5,
        backgroundColor = "darkred",
        alpha = .8,
        angle = 0,--math.random(-15,15),
        font = f,
        life = 1.6
    })
    
    local function fadeAway()
        self:tween(.6,t,{alpha=0},"out-quad")
    end
    
    self:after(1.0, fadeAway)
    
    t.vy=0
    self:must_update(t)
end

function Map:getTileLight(tile)
    local c = getColor(tile.ambient or {0.1,.1,.1})
    local c = getColor(tile.color or {1,1,1})
    if tile.lightColor then
        c = t.lightColor--toybox.rot().Color.multiply(cc, t.lightColor)--.add(c, tile.lightColor)
    end
    local final= c--toybox.rot().Color.multiply(cc, c)
    
    return final
end
function Map:computeLight()
    self.lighting:compute(self.lightTile)
end

function Map:addDebugControls()
    local g = gooi.currentGroup
    local debug = gooi.newPanel({group=g,x=100,w=W()-W()/3,y=100,h=H()/12,layout="grid 1x8"}):
        setColspan(1,1,7)
    
    local text = gooi.newText({text=""})
    self.debugText = text
    
    debug:add(text)
    
    local function doSubmit(b)
        _G["self"] = self
                
        local txt = text:getText()
        if txt == "r" then
            text:setText(oldText or "no old text")
            return
        end
                
        oldText = txt
                
        l,e = loadstring(text:getText())
        if e then
            cwlog(e,"red")
            self:addLog(string.format("&colors.orange %s", e))
            pl:cry(e,"orange")
        end
        
        if l then
            local n,e = --l()--
            pcall(l)
            if not n and type(e) == "string" then
                cwlog(e,"orange")
                self:addLog(string.format("&colors.peach %s", e))
                pl:cry(e,"peach")
            end
        end
                
        local s = self
        _G["self"] = nil
        local self = s
                
        text:setText("")
    end
    
    local submit = gooi.newButton({text="submit"}):onRelease(doSubmit)
    debug:add(submit)
    
    self.debugPanel = debug
end

function Map:getCavern() 
    if 1 then return self:getLake(true) end
    
    local caveSize = {10, 10, 10, 16, 12, 20}
    local caveH = 1--{1,2,.5,1.5}
    local caveH2 = {3,1,1,1,2,.5,1.5}
    
    
    local tilesCount, oCount = "",""
    for xxx = 1,2 do
        -- lake
        local t
        local w = getValue(caveSize)--10--20
        local r = getValue(self.rooms)
        local xw = r.minTileX
        local yw = r.minTileY
        local allTiles, map = {}, {}
        local allSpacedTiles = {}
    
        local function rmake(x, y,v)
            local xs = x + xw
            local sy = y + yw
            local tt = self:getTile(t._x+x-w/2, t._y+y-w/2) assert(v==1 or v==0, v)--self:getTile(x,y)
            local x, y = tt and tt._x, tt and tt._y
            if v == 0 and tt and not tt.edge then
                if not tt.solid then
                    allSpacedTiles[#allSpacedTiles+1] = tt
                end
            
                allTiles[#allTiles+1] = tt
                map[x] = map[x] or {}
                map[x][y] = {solid=true}
                map[tt] = true
            end
        end
    
        local function make(x, y, v)
            local tt = self:getTile(t._x+x-w/2, t._y+y-w/2) assert(v==1 or v==0, v)
            if tt and v==0 and not tt.edge and not tt.keepSolid then
                tt.solid = false tt.water = 1 tt.debug = 1 tt.__draw=nil
            end
        end
        t = getValue(self.rooms)--self:getRandomSpaceTile()
        if 1 then-- not t.door do
            didDoor = math.random() > .6 
            local nm = 0
            t = didDoor and getValue(self.doors) or  t:getTile(t._x+math.floor(t.w/2)*nm, t._y+math.floor(t.h/2)*nm)--(self.doors)--self:getRandomSpaceTile()
        end
        local r = toybox.rot().Map.Brogue(w, math.floor(w*getValue(caveH2)), {
            caveChance = 1,--z==2 and 1 or 0,
            cavePasstes = 4,
            --maxRooms = 20, minRooms=12,
            roomWidth = {4,8},
           -- maxRooms = 11
           minRooms=0,maxRooms=0,
        
           -- corridorWidth = {3,6}
        })
        if maps[z] == "Cellular" then
                r:randomize(.55)--floorProb
        end
    
        for x = 1, 1 do
            r:create(rmake)
        end
        local tm = self:getRandomSpaceTile()
        while map[tm] do
            tm = self:getRandomSpaceTile()
        end
    
        --local tiles,q,con = floodFill(tm, map)
        if true then--#tiles >= (#spacedTiles-#allSpacedTiles) or con then
            for x = 1, #allTiles do
                local t = allTiles[x]
                local tile = t--[1]
                if nil and t[2] == 1 then
                   tile.debgug=1-- self:solidify(tile)
                else --tile.water=1
                    mmm:clear(tile) --tile.debug=1
                end
            end
    
           -- break
        end
    end
end

function Map:getLake(pit)
    local done
    pit = pit or false
    local spacedTiles = {}
    for x, i in ipairs(self.allTiles) do
        if not i.solid then
            spacedTiles[#spacedTiles+1] = i
        end
    end
    
    local tilesCount, oCount = "",""
    
    for xxx = 1,20 do
        -- lake
        local t
        local w = 20--getValue(caveSize)--20
        local r = getValue(self.rooms) or self
        local xw = r.minTileX
        local yw = r.minTileY
        local allTiles, map = {}, {}
        local allSpacedTiles = {}
    
        local function rmake(x, y,v)
            local xs = x + xw
            local sy = y + yw
            local tt = self:getTile(t._x+x-w/2, t._y+y-w/2) assert(v==1 or v==0, v)--self:getTile(x,y)
            local x, y = tt and tt._x, tt and tt._y
            if v == 0 and tt and not tt.edge then--and not tt.isCorridor then
    
                --[[local tm = self:getRandomSpaceTile()
                local mmap = lume.copy(map)
                mmap[x] = mmap[x] or {}
                mmap[x][y] = {solid=true}
                mmap[tt] = true
                while mmap[tm] do
                    tm = self:getRandomSpaceTile()
                end
                local tiles,q,con = floodFill(tm, mmap)]]
                if true or #tiles >= (#spacedTiles-#allSpacedTiles) or con then
    
                if not tt.solid then
                    allSpacedTiles[#allSpacedTiles+1] = tt
                end
            
                allTiles[#allTiles+1] = tt
                tt.doWater = true
                map[x] = map[x] or {}
                map[x][y] = {solid=true}
                map[tt] = true else log("[LAKE NOT GEN] nope")
                end
            elseif tt then
                map[x] = map[x] or {}
                map[x][y] = tt
            end
        end
    
        local function make(x, y, v)
            local tt = self:getTile(t._x+x-w/2, t._y+y-w/2) assert(v==1 or v==0, v)
            if tt and v==0 and not tt.edge and not tt.keepSolid then
                tt.solid = false tt.water = 1 tt.debug = 1 tt.__draw=nil
            end
        end
    
        t = getValue(self.rooms)--self:getRandomSpaceTile()
        if 1 then-- not t.door do
            t = t:getTile(t._x+math.floor(t.w/2), t._y+math.floor(t.h/2))--(self.doors)--self:getRandomSpaceTile()
        end
    
        local r = toybox.rot().Map.Brogue(w, math.floor(w*getValue(1 or caveH)), {
            caveChance = 1,--z==2 and 1 or 0,
            cavePasstes = 4,
            --maxRooms = 20, minRooms=12,
            roomWidth = {4,8},
           -- maxRooms = 11
           minRooms=0,maxRooms=0,
            
           -- corridorWidth = {3,6}
        })
        if maps[z] == "Cellular" then
            r:randomize(.55)--floorProb
        end
    
        for x = 1, 1 do
            r:create(rmake)
        end
        local tm = self:getRandomSpaceTile()
        while map[tm] do
            tm = self:getRandomSpaceTile()
        end
    
        local tiles,q,con = floodFill(tm, map)
        if true or #tiles >= (#spacedTiles-#allSpacedTiles) or  con -- or true
        then
            local rooms = {}
            for x = 1, #allTiles do
                local t = allTiles[x]
                local tile = t--[1]
                if nil and t[2] == 1 then
                    tile.debgug=1-- self:solidify(tile)
                else
                    local isDeep = true
                    for xx = 1, math.random()>.6 and 3 or 2 do
                        for i = 1, 4 do
                            local d = dirs4[i]
                            local tt = self:getTile(t._x+d[1]*xx, t._y+d[2]*xx)
                            if tt and (not tt.doWater) and not tt.solid then
                                isDeep = false
                                break
                            end
                        end
                    
                        if not isDeep then
                            break
                        end
                    end
                    
                    rooms[tile.roomData] = (rooms[tile.roomData] or 0)+1
                
                    if pit then
                        tile.chasm = true
                    else
                        tile:addWater(nil, nil, true, isDeep)
                        tile.deepWater = isDeep
                    end
                    
                    mmm:clear(tile) -- tile.debug=1
                end
            end
            
            for room, x in pairs(rooms) do warn("Yes "..x.."/"..(#room.allTiles*.7))
                if not room.roomTypes then
                    -- error(inspect(room,1))
                end
                room.roomTypes = room.roomTypes or {}
                room.roomTypes.hasWater = true
                if x >= (#room.allTiles*.7) then
                    warn(tostring(lume.remove(self.rooms, room)).."!")
                end
            end
                
            
            done = done and 1 or true
        
            if true then break end
        
            ---- Bah Bah Black Sheep ... ----
        
            spacedTiles = {}
            
            for x, i in ipairs(self.allTiles) do
                if not i.solid and not i.water then
                    spacedTiles[#spacedTiles+1] = i
                end
            end
        end
    
        tilesCount = #tiles
        oCount = (#spacedTiles-#allSpacedTiles)
    
    end
    
    return done, oCount, tilesCount
end


function Map:setCameraTarget(t)
    self.cameraTarget = t
    self:updateCamera()
end

function Map:updateCamera()
    local t = self.cameraTarget
    if t then
        self.cameraMan.x, self.cameraMan.y = t.x, t.y
    end
    
    self.camera.scale = self.cameraMan.scale or self.camera.scale
end

function Map:closeInventory()
    if not self.inventoryIsOpen then
        self:openInventory()
    end
    
    if self.choosingItem then
        if self.choosingItem.canCancel then
            gooi.dialog({
                text = self.choosingItem.cancelText,
                divide = 1.5,
                ok = function()
                    self.choosingItem = nil
                    self:closeInventory()
                end
            })
        end
        
        return
    end
    
    self.choosingItem = nil
    
    self.inventoryIsOpen = false
    gooi.removeComponent(self.inventoryPanel)
    gooi.addComponent(self.openInvButton)
end

function Map:openInventory()
    if self.inventoryisOpen then
        self:closeInventory()
    end
    self.inventoryIsOpen = true
    if self.player then
        self:reloadInventoryUI(self.inventoryUser or self.player)
    end
    gooi.removeComponent(self.openInvButton)
    gooi.addComponent(self.inventoryPanel)
end

local logTime = .3

function Map:newLog(color, txt, skip)
    local l = lume.copy(self.logs)
    local logLen = skip == 0 and 0 or #self.logs
    
    local reduceLog = (not skip and logLen > 0) and function()
        self.doingLog = self.doingLog - 1
    end
    
    for x = 1, skip and 0 or logLen do
        local item = l[x]
        self.logs[x+1] = item
        local y = -lg.getFont(l[x].font):getHeight()+item.y-5
        
        local func = x == #self.logs and function()
            self.doingLog = self.doingLog - 1
            return newLog(color, txt, true)
        end or reduceLog
        
        self:tween(logTime, item, {y=y}, "out-quad", func)
        item.alpha = (5-x)/4
    end
    
    self.logs[5] = nil
    
    local ww = W()*.5
    local yyt = Sentence:new({
        x = W()-ww-self.inventoryPanel.w-10,
        y = 10+30,
        w = ww, instant=true
    })
    yyt.color = color or yyt.color
    
    self.logs[1] = yyt
    
    local i = yyt
    self.doingLog = (self.doingLog or 0)+1
    i:newText(txt)
    
    return yyt
end

function Map:addLog(txt, color, skip)
    if not self.player then
        return
    end
    
    if type(txt) ~= "string" then
        txt = tostring(txt)
    end
    
    if self.doingLog and self.doingLog > 0 and not skip then
        local func = function()
            self:addLog(txt, color, true)
        end
        return self:after(self.doingLog*logTime, func)
    end
    
    self.player:speak(txt)
    local i = self:newLog(color, txt)
    -- i:newText(txt)
end

function Map:addText(...)
    return self:addLog(...)
end


function Map:startCoroutine(func, ...)
    self.coroutine = coroutine.create(func)
    coroutine.resume(self.coroutine, ...)
end

function Map:yieldCoroutine(...)
    coroutine.yield(...)
end

function Map:updateCoroutine(dt)
    if self.coroutine then
        if coroutine.status(self.coroutine) == "suspended" and not coroutine.resume(self.coroutine) then
            self.coroutine = nil
        end
    end
end
function Map:itemPopUp(data)
    self:removePopUp()
    
    local gr = gooi.currentGroup
    self.currentItem = data
    
    self.inventoryUser:wieldItem(data)
    
    local nn = 1.2
    local w, h = (W()*nn)/2.4, (H()*nn)/4
    
    local row = 5
    local v = 2
    local g = gooi.newPanel({
        x = self.inventoryPanel.x-w-10 or (W()/2-w/2), y = 0+h/2,--H()/2-h/2,
        w = w, h = h,
        layout = "grid 6x10",
        padding = 7,
        paddingY = 2,
        group = gr
    }):
    setRowspan(1,1,row):-- -1
    setColspan(1,1,10):
    setColspan(row,2,v):
    setColspan(row,4,v):
    setColspan(row,6,v):
    setColspan(row,8,v)
    
    g.opaque = true
    
    local info = gooi.newLabel({
        text = string.format("%s\n%s", data.name, data.info or "An item")
    }):left()
    info.yOffset = 2
    
    local ch = self.choosingItem
    
    if ch and ch.noPrompt then
        self.chooseItemFunc()
        gooi.removeComponent(g)
        gooi.removeComponent(info)
        return
    end
    
    local use = ch and gooi.newButton({
            text = string.format("%s", self.choosingItem.text or "choose")
        }):onRelease(self.chooseItemFunc) or
    
        gooi.newButton({
            text = data.useText or "use"
        }):onRelease(self.useFunc)
        
    local drop = not ch and gooi.newButton({
        text = "drop"
    }):onRelease(self.dropFunc)
    
    local throw = not ch and gooi.newButton({
        text = "throw"
    }):onRelease(self.throwFunc)
    
    local cancelFunc = function()
        self:removePopUp()
    end
    
    local cancel = gooi.newButton({
        text = "cancel"
    }):onRelease(cancelFunc)
    
    g:add(info)
    g:add(use,row,2)
    
    if drop then
        g:add(drop,row,4)
    end
    
    if throw then
        g:add(throw,row,6)
    end
    
    g:add(cancel,row,8)
    
    self.popUp = g
    g.aboutItems = true
end

function Map:removePopUp()
    self.buying = false
    
    if not self.popUp then
        return
    end
    
    if self.popUp.aboutItems then
        self:reloadInventoryUI()
    end
    
    gooi.removeComponent(self.popUp)
    self.popUp = nil
end
    
local function sortItemData(a, b)
    local am = (INV_DEPTH[a.itemType] or error("No registered item type: "..a.itemType..","..a._id))+(a.equipped and 121 or 0)+(a.count or 1)/100
    local bm = (INV_DEPTH[b.itemType] or error("No regustered item tyoe: "..b.itemType..","..b._id))+(b.equipped and 121 or 0)+(b.count or 1)/100
    
    return am>bm
end

function rmm() for x=1,10 do pl:removeItem(getValue(pl.allItems)) end end

function Map:reloadInventoryUI(user, page)
    self.inventoryUser = user or self.inventoryUser
    user = self.inventoryUser
    
    table.sort(user.inventoryItems, sortItemData)
    
    --self.inventoryButton:setText(string.format("Inventory (room for %s more)", user.inventorySpace))
    
    self.maxItems = #user.inventoryItems
    self.invPages = math.floor(self.maxItems/14)
    if ((self.maxItems/14)-self.invPages) ~= 0 then
        self.invPages = self.invPages + 1
    end
    
    local ogp = page or "-"
    self.lastPage = page or self.lastPage
    
    local last = self.lastPage or "? "
    
    local page = page or self.lastPage or 1
    
    
    self.lastPage = page
    self.currentInvPage = page or 1
    
    self.invLeft.enabled = true
    self.invRight.enabled = true
    self.invLeft.visible = true
    self.invRight.visible = true
    
    if page == 1 then
        self.invLeft.enabled = false
        -- self.invLeft.visible = false
    end
    
    if page == self.invPages then
        self.invRight.enabled = false
        -- self.invRight.visible = false
    end
    
    local skip, old
    local nxt = 0
    local invBy = 0
    local bck = 0
    local count = 0
    
    local items = {}
    local page = 0
    local pages = {}
    
    local nxtt = 0

    while count < #user.inventoryItems do
    
    page = page + 1
    bck = 0
    
    local s = user.inventorySpace
    local c = s<5 and "red @" or s<=10 and "orange" or s>=30 and "lime" or "white"
    self.inventorySpace:setText(s <= 0 and "&colors.red Your pack is full" or string.format("(room for &colors.%s %s ~ more items)", c, user.inventorySpace))
    log("shout")
    for x = 1, #self.inventoryUI do
        local invB = self.inventoryUI[x]
        local i = not skip and user.inventoryItems[x+nxtt]--(x+nxt)+(15*(page-1))]
        log(" -- item .."..(i and i.name or "nil"))
        if skip then invBy = invBy + 10 end-- invB.h/3 end
        invB.oy = invB.oy or invB.y
        --invB.y = invB.oy+invBy
        
        skip = false
        
        
        if i then
            if old and old.itemType ~= i.itemType and not i.equipped then
               -- skip = true
                bck = bck + 1
                items[x+bck-1] = i.itemType
                
                if lume.max(bck+x,#items)>=#self.inventoryUI then
                    break
                end
                --nxt = nxt - 1
            end
            old = i
            count = count + 1
        end
        
        items[x+bck] = i and i or "?"
        if #items == #self.inventoryUI then break end
    end
    pages[page] = items
    items = {}
    nxtt = count
    end
    
    --local nn = {}
    --for x, ii in ipairs(user.inventoryItems) do nn[x]  = ii.name end
    
    --if nmm then error(inspect(nn).."\n"..inspect(pages)..#pages[1]..","..#pages[2]) end
    
    
    --inventoryui =
    
    self.invPages = page
    
    page = self.lastPage
    
    if page > (self.invPages) then page = self.invPages end
    self.currentInvPage = page
    
    local page = self.currentInvPage
    
    self.invLeft.enabled = true
    self.invRight.enabled = true
    self.invLeft.visible = true
    self.invRight.visible = true
    
    if page == 1 then
        self.invLeft.enabled = false
        -- self.invLeft.visible = false
    end
    
    if page == self.invPages then
        self.invRight.enabled = false
        -- self.invRight.visible = false
    end
    log(page.." is page out of "..self.invPages)
    local items = pages[self.currentInvPage] or {}
    local nxt = 0
    local x = 0
    while true do
    --for x = 1, #self.inventoryUI do
        x = x+1
        local invB = self.inventoryUI[x+nxt]
        if not invB then break end
        
        invB.opaque = true
        
        local i = items[x] --user.inventoryItems[(x+nxt)+(15*(page-1))]
        
        invB.oy = invB.oy or invB.y
        invB.y = invB.oy + invBy
        
        if type(i) == "table" then
            invB.data = user.inventory[i]
            local item = user.inventory[i][1]
            invB:setText(string.format("%s%s \n [x%s]", item:getDurabilityTitle(), item:getName(), #invB.data))
            invB.panel.s:setText(string.format("(%s)",#invB.data*item.space))
            
            if old and old.itemType ~= i.itemType then
                skip = true
                --nxt = nxt-1
            end
            
            old = i
        
        elseif type(i) == "string" and i ~= "?" then
            invB.opaque = false
            invB:setText("")
            invB.data = nil
            invBy = invBy+invB.h/1.7
            nxt = nxt - 1
        else
            invB.opaque = false
            invB:setText("")
            invB.data = nil
            
        end
    end
end

function Map:shopPopup(cr, item)

    self:removePopUp()
    
    local data = item
    
    local gr = gooi.currentGroup
    self.currentItem = data
    
    -- self.inventoryUser:wieldItem(data)
    
    local nn = 1.2
    local w, h = (W()*nn)/2.4, (H()*nn)/4
    
    local row = 5
    local v = 2
    local g = gooi.newPanel({
        x = self.inventoryPanel.x-w-10 or (W()/2-w/2), y = 0+h/2,--H()/2-h/2,
        w = w, h = h,
        layout = "grid 6x10",
        padding = 7,
        paddingY = 2,
        group = gr
    }):
    setRowspan(1,1,row):-- -1
    setColspan(1,1,10):
    setColspan(row,2,v):
    setColspan(row,4,v):
    setColspan(row,6,v):
    setColspan(row,8,v)
    
    g.opaque = true
    
    local info = gooi.newLabel({
        text = string.format("%s\n \n%s\n \nThis %s is for sale at &colors.gold %s gold", data.name, data.info or "An item",data.type,data.price)
    }):left()
    info.yOffset = 2
    self.buying = true
    
    -- shopkeeper
    
    local function buyFunc()
        item.shopkeeper = nil
        cr:addItem(item)
        self:removePopUp()
    end
    
    local function pickupFunc()
        cr:addItem(item)
        self:removePopUp()
    end
    
    local buy = gooi.newButton({
            text = "buy"
        }):onRelease(buyFunc)
        
    local pickup = gooi.newButton({
        text = "pickup"
    }):onRelease(pickupFunc)

    local cancelFunc = function()
        self:removePopUp()
    end
    
    local cancel = gooi.newButton({
        text = "cancel"
    }):onRelease(cancelFunc)
    
    g:add(info)
    
    g:add(buy,row,2)
    g:add(pickup,row,6)
    pickup.x = pickup.x - pickup.w/2
    g:add(cancel,row,8)
    
    self.popUp = g
end


function Map:pedestalPopup(cr, item)

    self:removePopUp()
    
    local data = item
    
    local gr = gooi.currentGroup
    self.currentItem = data

    
    local nn = 1.2
    local w, h = (W()*nn)/2.4, (H()*nn)/4
    
    local row = 5
    local v = 2
    local g = gooi.newPanel({
        x = self.inventoryPanel.x-w-10 or (W()/2-w/2), y = 0+h/2,--H()/2-h/2,
        w = w, h = h,
        layout = "grid 6x10",
        padding = 7,
        paddingY = 2,
        group = gr
    }):
    setRowspan(1,1,row):-- -1
    setColspan(1,1,10):
    setColspan(row,2,v):
    setColspan(row,4,v):
    setColspan(row,6,v):
    setColspan(row,8,v)
    
    g.opaque = true
    
    local info = gooi.newLabel({
        text = string.format("%s\n \n%s\n \nThis %s is sitting on a pedestal.", data.name, data.info or "An item",data.type)
    }):left()
    info.yOffset = 2
    self.buying = true
    
    
    local function pickupFunc()
        cr:addItem(item)
        self:removePopUp()
    end
        
    local pickup = gooi.newButton({
        text = "pickup"
    }):onRelease(pickupFunc)

    local cancelFunc = function()
        self:removePopUp()
    end
    
    local cancel = gooi.newButton({
        text = "cancel"
    }):onRelease(cancelFunc)
    
    g:add(info)

    g:add(pickup,row,2)
    pickup.x = pickup.x - pickup.w/2
    g:add(cancel,row,8)
    
    self.popUp = g
end

function Map:addItemTo(cr, item)
    if item.tile and item.tile.pedestalLocked and not item.tile.pedestalLocked.unlocked then
        self:addLog(string.format("%s is @ stuck ~ to the pedestal", item.title))
        return
    end
    
    if item.tile and item.tile.pedestalLocked and cr.isPlayer then
        return self:pedestalPopup(cr, item)
    end
    
    if item.shopkeeper and item.shopkeeper.died then
        item.shopkeeper = nil
    end
    
    if item.shopkeeper and cr.isPlayer then
        return self:shopPopup(cr, item)
    end
    
    return cr:addItem(item)
end

local checkDirs = {
    {1,0},{-1,0},{0,-1},{0,1},
    {1,-1},{1,1},{-1,-1},{-1,1}
}

function Map:getFreeTileAround(tile, check, check2)
    local check = check or "unit"
    local check2 = check2 or "gibberishGo goonsndksjsjsje"
    
    if true then
        local newTile
        for x = 1, 8 do
            local c = checkDirs[x]
            local t = self:getTile(tile._x+c[1],tile._y+c[2])
            if t and (not t[check] or t[check].noPickup) and not t:isSolid() and not t[check2] then
                newTile = t
                break
            end
        end
        if not newTile then
            for x = 1, 8 do
                local c = checkDirs[x]
                local t = self:getTile(tile._x+c[1],tile._y+c[2])
                if t then
                    for y = 1, 8 do
                        local cc = checkDirs[y]
                        local tt = self:getTile(tile._x+cc[1], tile._y+cc[2])
                        if tt and (not tt[check] or tt[check].noPickup) and not tt:isSolid() and not tt[check2] then
                            newTile = t
                            break
                        end
                    end
                    if newTile then
                        break
                    end
                end
            end
        end
        
        if not newTile then
            return
        end
        
        return newTile
    end
end

function Map:spawnItem(item, tile, dropped, forcePosition)
    
    tile = tile or getValue(self.rooms):getRandomSpaceTile()

    if not item.isItem then
        item = _G[(items[item] or item).class or "Item"]:new(items[item] or item)
    end
    
    if tile.item and (tile.item.isAnvil and #tile.item.mixes<2 or (tile.item.anvil and not tile.item.isFixing)) then
    
        if item.tile then
            item.tile = nil--.item = nil
        end
        return tile.item:onRecieve(item, dropped)
    end
    
    local dItem
    local user = item.user
    
    if dropped then
        item:onDrop(self.inventoryUser or user, self)
    end
        
    if tile.item and (tile.item.data == item.data) and not item.noPickup then
        log("[ITEM] ".. (item.name or "?") .. " item stacked!")
        tile.item.stack = (tile.item.stack or 1)+1
        return tile.item
    end
    
    
    if dropped == 10 and user and (tile.item and not tile.item.noPickup) and (true or user.inventorySpace>=tile.item.space) then
        user:addItem(tile.item)
    end
    
    if tile.takenPedestalItem == item then
        local pLock = tile.pLock
        self:addLog("You hear a clicking sound.")
        
        pLock.taken = nil
        pLock.unlocked = true
        tile.takenPedestalItem = nil
    elseif tile.takenPedestalItem then
        self:addLog("That Item doesn't belong there...")
    end
    
    
    if ((tile.item and not tile.item.noPickup and not item.noPickup) or (tile.unit and item.unitBlocks)) and not forcePosition then
        
        local newTile = self:getFreeTileAround(tile, "item", item.unitBlocks and "unit")
        --assert(not item.isWall)
        if not newTile then
            if dropped then
                self:addLog(string.format("%s got forgotten by the world", item.name))
            end
            local problem = (tile.item and not tile.item.noPickup and tile.item) or 
              (tile.unit and item.unitBlocks and tile.unit)
            log("No space for item "..item.name.." due to "..(problem and problem.title or "?"))
            
            return problem
        end
        
        tile = newTile
    end
    
    if item.tile then
        item.tile.item = nil
    end
    
    if true then--not self.world:hasItem(item) then
        self:store_instance(item)
    end
    
    local x = tile.x - (item.w/2-tile.w/2)
    local y = tile.y - (item.h/2-tile.h/2)
    
    item:set_box(x,y,item.w, item.h)
    item.x, item.y = x,y
    item.debug = nil
    item.depth = DEPTHS.ITEMS+love.timer.getTime()/100000
    tile.item = item
    item.tile = tile -- if item.remm then error(item.name) end
    
    if item.isWall then
        tile.hasWall = item
    end
    
    if true then -- not item.isFloor and not item.isWall then
        self.items[item] = item
    end
    
            
    if tile.pressurePlate and tile.pressurePlate.parent and self.currentTurn > 0 and not tile.unit then
        tile:addLog(string.format("A pressure plate clicks underneath %s...", item.title))
        self.trapsToActivate[#self.trapsToActivate+1] = tile.pressurePlate.parent
        tile.toActivateTrap = true
    end
    
    return item
end

function Map:destroyItem(item)
    if item.tile and item.tile.item == item then
        item.tile.item = nil
    end
    
    if item.tile and item.isWall then
        item.tile.hasWall = nil
    end
    
    item.isDestroyed = true
    
    if item.user and item.isCarried then
        item.user:removeItem(item, true)
        item.rrro = true
    end
    
    self:destroy_instance(item)
end

function Map:draw_instance(obj)
    local sh
    if obj.shader then
        sh = love.graphics.getShader() or true
        love.graphics.setShader(obj.shader)
    end
    
    local olda
    if obj == self.player and obj:isInvisible() then
        olda = obj.image_alpha
        obj.image_alpha = olda/2
    elseif obj.isCreature and obj:isInvisible() and not obj:isAlly(self.player) then
        olda = false
    end
    
    if olda ~= false and not obj.isFloor then
        if obj.isItem then
            obj.color = obj.itemColor or obj.color
        end
        obj:__draw()
    end
    
    if olda then
        obj.image_alpha = olda
    end
    
    if sh then
        love.graphics.setShader(sh~=true and sh or nil)
    end
end

local randomDrops = {
            wand = {
                weight = 10,
                item = getRandomWand,
                enchants = {0,0,0,1,1,1,1,2},
            },
            
            weapon = {
                weight = 30,
                durability = {30,60},
                enchants = {-1,0,0,0,2,1,1},
                buffs = {false, false, false, "random"},
                item = {"dagger", "sword"},
                max = 0
            },
            
            potions = {
                weight = 40,
                items = getRandomPotion,--{"potion_of_healing","potion_of_incineration"}
            },
                
            misc = {
                weight = 40,
                item = {z,"flamesprout_seed","pooleaf_seed","stone"}
            }
        
}
function spp()
    local o for x=1,1 do o = self:spawn("orc",pl.tile.roomData:getRandomSpaceTile()) end
    local g for x=1,1 do g = self:spawn("goblin",pl.tile.roomData:getRandomSpaceTile()) end
    -- self:spawn("goblin_conjurer",pl.tile.roomData:getRandomSpaceTile())
    -- self:after(2,function() g.liking.o=g.liking[o] g.liking.pl=g.liking[pl] error(inspect(g.liking,1)) end)
    return g
end

function Map:spawnPlayer(pl) -- spawnit
    pl = pl or Creature:new({
        sourcje="boi.png",anim = "tmp", frameDelay = .3, health = 25, sight=5+2+3,--2,
        isPlayer = true, steaylth = 10, speed = 1,inventorySpace = 30,
        defense = 5,
        armour = "leather_armour",
        weapon = "dagger",inventory=
{
        {"scroll_of_collection"},{"bullets",130},{"shells",30},{"explosives",20},{"shotgun",1},{"nuke_launcher"},"pistol",{"grenade",4},
        "plate_mail","beetle_helmet","space_helmet","advanced_helmet",
        -- {"scroll_of_summoning",5},{"wand_of_hasting"},{"wand_of_mind_switch"},
        -- {"potion_of_teleportation",2},{"wand_of_tunneling"},{"wand_of_conjuring"},
        --{"potion_of_levitation"},
        {"matchstick",5},{"scroll_of_duplication",1,10}},
        
        invjentory = {
        --[["wizard_cap",
        "leather_armour",
        "wand_of_blinking",
        "wand_of_flames",
        "wand_of_teleportation",
        "scroll",
        "wand_of_webbing",]]
        {"scroll_of_enchanting",1},
        --{"charm_of_fire",1,3},
        --"crossbow",
        {"matchstick",5},
        {"potion_of_frost",2},{"potion_of_ice"},
        
        {"scroll_of_enchanting",3},
        
        "flamesprout_seed",
        "watersprout_seed",
        "frostflower_seed",
        "poisonleaf_seed",
        
        {"potion_of_polymorphing",2},
        {"potion_of_blinding",2},
        
        "wand_of_beckoning",
        {"potion_of_invisibility",2},
        {"potion_of_might",2},
        {"potion_of_haste",2},
        {"wand_of_blinking"},
        {"wand_of_flames"},
        {"arrow",10},
        {"stone",10}}
    })
    
    self.inventoryUser = pl
    
    local team = self.player and self.player.team or "player"
    self.player = self.player or pl
    
    pl.team = team
    local tile
    
    if not pl.notMoved then
        tile = self.rooms[1]:getRandomSpaceTile()
        self:spawn(pl, tile)
        pl.isPlayer = true
        pl.ogPlayer = true
        pl:applyBuff("paralyse",4)
        pl.name = "player"
        pl._id = "player"
    end
    
    local c = pl:getItem("scroll_of_collection")
    if c then
        revealScroll(pl, c, true)
    end
    
    if self.first then
        for x = 1, math.random(6,8) do
            self:spawnItemFromPool(randomDrops, tile.roomData:getRandomSpaceTile())
        end
        self:addLog("You dropped some of your @ &colors.gold items.")
    
        pl.tile:addWater(1)-- = {}
    end
    
    --[[for i = 1,2 do
    local a = self:spawnItem("spear",pl.tile)--doatt
    a:enchant("knockback",3)
    self:spawnItem("shotgun",pl.tile)--2)--anvil
    end
    --self:spawn("skeleton",self:getTile(pl.tile._x+2, pl.tile._y)).stats.hehalth = 3
    --self.spawn = function () return {} end
    --local p = self:spawn("pig",self:getTile(pl.tile._x+2, pl.tile._y))
    --p.stats.health=100
    --self.spawn = null
    self:spawnItem("scroll",pl.tile)
    for x = 1, 2 do self:spawnItem("potion_of_confusion",pl.tile) end
    for x = 1, 2 do self:spawnItem("potion_of_incineration",pl.tile) end
    for x = 1, 3 do self:spawnItem("stone",pl.tile) end
   -- for x = 1, 3 do 
   self:spawnItem("angel_statue",pl.tile.roomData:getRandomSpaceTile())
   ]]
    --[[self:spawn(
        "goblin",--Creature:new(creatures.ruat or {anim="creatures/goblin", frameDelay=.3,sight=2}),
        self.player.tile.roomData:getRandomSpaceTile()
    ):addClass("warrior")
    self:spawn(
        "skeleton",--Creature:new(creatures.ruat or {anim="creatures/goblin", frameDelay=.3,sight=2}),
        self.player.tile.roomData:getRandomSpaceTile()
    )--:die()--.stats.health=2
    
    ]]
    
    nn = lume.max(pl:getSight(), 5) --sight 2, nn=7
    maxdis = lume.distance(0,0,nn*tw2,nn*th2)
    
    
    self:set_target(pl)
    self:reloadFov()
end
    
function Map:spawn(cr, tile, team)
    if not cr.isCreature then
        cr = Creature:new(creatures[cr] or cr)
    end
    
    if tile and tile.unit then
        tile = self:getFreeTileAround(tile,"unit")
        if tile and tile.unit then
            warn("No SPACE!")
        end
    end
    
    local t = tile or getValue(self.rooms):getRandomSpaceTile()

    if t.unit then
        return--assert(not t.unit)
    end
    
    if not t.x then error(inspect(t,2)) end
    
    cr:move_to(t.x,t.y)
    cr.x, cr.y = t.x, t.y
    cr.solid = false
    cr.team = getValue(team or cr.team or false)
    
    if cr.died then
        cr.play = cr.__beforeDeathPlayFunction
        cr.updateTurn = cr.__beforeDeathUpdateTurn
    end
    
    cr.died = false
    cr.dying = false
    cr.playing = false
    cr.done = false
    
    t.color=getValue(colors)
    
    cr._added = cr._added or {}
    local s = tostring(self)
    local added
    
    if not cr._added[s] then
        self.creatures[#self.creatures+1] = cr
        cr._added[s] = true
        added = true
        --nextfloor(
    end
    
    self:setTile(cr, t)
    return cr, added
end

function Map:drarw_instance(obj) if not obj.x then return end
if obj.isCreature and  obj.tile and not obj.tile:canBeSeen() and not obj.isPlayer then return end
    local r,g,b,a = set_color(getColor(obj.isCreature and getValue("orange","green") or obj.isItem and (obj.pcolor or obj.itemColor or obj.color or "cyan") or obj.chasm and "darkblue" or obj.water and "blue" or obj.solid and "darkgrey" or obj.isTile and "black" or "grey", obj.isTile and not obj:canBeSeen() and .3))
    draw_rect("fill",obj.x+obj.offset_x,obj.y+obj.offset_y,obj.w or tw,obj.h or th)
    set_color(r,g,b,a)
    draw_rect("line",obj.x+obj.offset_x,obj.y+obj.offset_y,obj.w or tw,obj.h or th)
    if obj.name then
        lg.print(obj.name, obj.x+obj.offset_x, obj.y)
    end
end

function Map:unsetTile(cr, tile)
    if cr.tile == tile then
        cr.tile = nil
    end
    
    if tile.unit == cr then
        tile.unit = nil
    end
    
    
    local n =  tile.pressurePlate and tile.pressurePlate.parent
    if n and n.activated and not tile.item then
        n:deactivate()
    end
end

-- https://www.thenews.com.pk/latest/1032169-jennifer-lawrence-sizzling-dress-once-spark-google-images-creation

function Map:setTile(cr, tile)
    local ot = cr.tile
    
    if cr.tile then
        self:unsetTile(cr, cr.tile)
    end
    
    if cr.isPlayer and tile.fixed then
        self:addLog("&colors.pink This tile was fixed!!!")
        cwarn("[TILE] This tile was once fixed!", "pink")
        self.camera:shake(50,.3,24)
    end
    
    cr.tile = tile
    tile.unit = cr
    
    if cr ~= self.player then
        if (tile.nextFloor and nil) or (tile:isChasm() and not cr:isFlying()) then
            self:moveToNextFloor(cr, tile.nextFloor, tile)
        end
    end
    
    if cr == self.player then
        self.submergedAlpha = self.submergedAlpha or 0
        if tile.water and tile.water.isDeep then
            if not cr.submerged then
                self:tween(.5, self, {submergedAlpha=.5}, "in-quad")
            end
        elseif cr.submerged then
            self:tween(.3, self, {submergedAlpha=0}, "out-quad")
        end
        
        if ((tile.nextFloor and not cr.cantChangeFloor) or (tile:isChasm() and not cr:isFlying())) and (not tile.item or tile.item.noPickup) then
            self:moveToNextFloor(cr, tile.nextFloor, tile)
            return
        end
        
        if tile.previousFloor and not cr.cantChangeFloor and (not tile.item or tile.item.noPickup) then
            self:moveToPreviousFloor(cr, tile)
            return
        end
    end
    
    
    if not tile:isChasm() then
        cr._kayoteTime = cr.kayoteTime+(cr.armour and cr.armour.kayoteTime or 0)+(cr.helmet and cr.helmet.kayoteTime or 0)
    end

    
    if ot and ot.roomData ~= tile.roomData then
        if ot.roomData.onLeave then
            ot.roomData:onLeave(cr, ot)
        end
        
        if tile.roomData.onEnter then
            tile.roomData:onEnter(cr, tile)
        end
    end
    if not jk then jk=1 self:after(.1,function() pl.tile.nextFloor=1 end) end
    
    if not (tile.isTile) then error( inspect(tile,2)) end
    local f = tile:isAntiFire()
    if f then
        if cr:removeBuff("burn") then
            cr:addLog(string.format("%s is no longer on fire.", cr.title))
        end
    end
end

function Map:moveToPreviousFloor(cr, tile)
    tile = tile or cr.tile
    assert(not cr.cantChangeFloor)
    cr.cantChangeFloor = true
    if cr.isPlayer then
            local next = function()
                oldMap = self
                local oc = self.player.controller
                local new = self.previous or error() or Map:new({player = self.player, level = tile.nextLevel, next = true})
                local nc = self.player.controller
                
                --self.player.controller = oc
                
                game:set_room(new)
                
                local op = self.player
                local tt = new.nextFloorTile
                
                self.player:change_room(new, tt.x, tt.y)
                self:removeCreature(cr, true)
                
                new:spawn(self.player, tt)
                
                for x, item in ipairs(self.player.inventory) do
                    item.room = new
                    item.world = room.world
                end
                
                --new:add_controller(self.player.controller)
                
                self.player.debug = 1
                self.player.controller.room = new
                
                --new:remove_controller(nc)
                
                new:set_target(self.player)
                new:reloadFov()
                new:playNextCreature()
                
                --new.camera:fade(.01,{0,0,0,1})
                --new.camera:update(1)
                
                local w = W()*.7
                local h = H()/12
            
                --new.nexting = self.nexting
                --new.nexting2 = gooi.newLabel({text="@Tap any key to continue", x=W()/2-w/2, w=w, h=h, y=H()/2-h/2+font13:getHeight()*2,font=font8}):center()
                
                --local n = new.nexting2
                --n.fgColor = {1,1,1,0}
                --new.timer:tween(1.4, n.fgColor,  {1,1,1,1}, "in-quad")
                --new.creatures[#new.creatures+1] = new.player
                --new:setTile(cr, op.tile) warn()
                --moveobj
                if not tile.nextFloor then
                    cr:addLog(string.format("%s is damaged from the fall.",cr.title))
                    cr:getAttacked({name="fall",attack=2})
                end
                self.camera:fade(.1,{0,0,0,0})
                cr.cantChangeFloor = false
            end
            
            local text = '"The world was made for the mad."'
            local w = W()*.7
            local h = H()/12
            --self.nexting = gooi.newLabel({text=text, x=W()/2-w/2, w=w, h=h, y=H()/2-h/2}):center()
            
            self.camera:fade(1,{0,0,0,1},function()
                self:after(.1, next)
            end)
            
            
            return
    end
end

function Map:getEquivalentTile(new, tile)
    local x, y = tile._x, tile._y -- storet
    local xx, yy = 0,0
    
    local t = new:getTile(x,y)
    
    while not t  or t:isSolid() or t:isChasm() do
        t = new:getTile(x+xx, y+yy)
        
        if not t or t:isSolid() or t:isChasm() then
            t = new:getTile(x-xx, y-yy)
        end
        
        xx = xx - 1
        yy = yy - 1
        
        if yy < -100 then
            error("BAD EQUAL TILE")
        end
    end
    
    warn("got t at "..yy.." for "..x..","..y)
    
    return t
end

function Map:moveToNextFloor(cr, tookStairs, tile)
    tile = tile or cr.tile
    cr.cantChangeFloor = true
    
    if cr.isItem then
    
        -- prevents changning the players location on this map
        self.player.notMoved = true
        local new = self.next or Map:new({player = self.player, level = self.dungeon.nextLevel, next = true})
        self.player.notMoved = nil
            
        cr:addLog(string.format("%s fell to the floor below!", cr.title))
        self:removeCreature(cr, true)
    
        local op = self.player
        
        local tt = new.previousFloorTile
        
        cr:change_room(new, op.x, op.y)
                
        self:removeItem(cr, true)
        new:spawnItem(cr, tt)
        self.next = new
    
    end
    
    if cr.isPlayer then
            local next = function()
                oldMap = self
                local oc = self.player.controller
                local new = self.next or Map:new({player = self.player, level = self.dungeon.nextLevel, next = true})
                new.previous = self
                self.next = new
                local nc = self.player.controller
                
                --self.player.controller = oc
                
                game:set_room(new)
                
                local op = self.player
                
                local tt = tile and tile.nextFloor and new.previousFloorTile or self:getEquivalentTile(new, tile or cr.tile)
                
                cr:change_room(new, op.x, op.y)
                self:removeCreature(cr, true)
                local c, d = new:spawn(self.player, tt)
                if not d then
                    for x = 1, #new.creatures do
                        local c = new.creatures[x]
                        if c.isPlayer then
                            d = 1
                        end
                    end
                end
                assert(d)
                
                for x, item in ipairs(self.player.inventory) do
                    item.room = new
                    item.world = room.world
                end
                
                --new:add_controller(self.player.controller)
                
                self.player.controller.room = new
                
                --new:remove_controller(nc)
                
                new:set_target(self.player)
                new:reloadFov()
                --lume.remove(new.creatures, new.player)
                --new.creatures[#new.creatures+1] = new.player
                new:playNextCreature()
                
                --new.camera:fade(.01,{0,0,0,1})
                --new.camera:update(1)
                
                local w = W()*.7
                local h = H()/12
            
                new.nexting = self.nexting
                new.nexting2 = gooi.newLabel({text="@Tap any key to continue", x=W()/2-w/2, w=w, h=h, y=H()/2-h/2+font13:getHeight()*2,font=font8}):center()
                
                local n = new.nexting2
                n.fgColor = {1,1,1,0}
                new.timer:tween(1.4, n.fgColor,  {1,1,1,1}, "in-quad")
                
                --new:setTile(cr, op.tile) warn()
                --moveobj
                if not tile.nextFloor then
                    cr:addLog(string.format("%s is damaged from the fall.",cr.title))
                    cr:getAttacked({name="fall",attack=2})
                end
                
                self.camera:fade(.1,{0,0,0,0})
                cr.cantChangeFloor = false
            end
            
            local text = '"The world was made for the mad."'
            local w = W()*.7
            local h = H()/12
            self.nexting = gooi.newLabel({text=text, x=W()/2-w/2, w=w, h=h, y=H()/2-h/2}):center()
            
            
            self.camera:fade(1,{0,0,0,1},function()
                self:after(.1, next)
            end)
            
            return
    end
    
    if 1 then return end
    
    cr:addLog(string.format("%s fell to the floor below!", cr.title))
    self:removeCreature(cr, true)
    
    if true then
                -- prevents changing the player's location on this map
                self.player.notMoved = true
                local new = self.next or Map:new({player = self.player, level = self.dungeon.nextLevel, next = true})
                self.player.notMoved = nil
                
                local op = self.player
                local tt = tile and tile.nextFloor and new.previousFloorTile or self:getEquivalentTile(new, tile or cr.tile)
                cr:change_room(new, op.x, op.y)
                self:removeCreature(cr, true)
                new:spawn(cr, tt)
                
                for x, item in ipairs(cr.inventory) do
                    item.room = new
                    item.world = room.world
                end
                
                self.next = new
    end
end

function Map:removeCreature(cr, noDestroy)
    lume.remove(self.creatures, cr)
    
    cr._added = cr._added or {}
    cr._added[tostring(self)] = nil
    
    cr.isRemoved = true
    
    if cr.tile then
        local ot = cr.tile
        self:unsetTile(cr, ot)
        cr.tile = ot -- just to allow it to wrap up AI related to tile, no harm ... right?
    end
    
    if cr.lightData then
        self:removeLight(cr.lightData)
        cr.lightData = nil
    end
    
    if not noDestroy then
        cr:destroy()
    end
    
    cr.done = true
    if cr.isPlayer then
        self:playNextCreature()
    end
    
end

function Map:teleport(cr, tile, doMessage)
    local ot = cr.tile or self:getTileP(cr.x, cr.y)
    local ti = tile and tile.getRandomSpaceTile and tile:getRandomSpaceTile() or tile or self:getRandomSpaceTile()
    local max = 10
    
    if not tile then
        while (ti == ot) or ((ot and ot.roomData and ot.roomData == ti.roomData) and max>0) do
            ti = self:getRandomSpaceTile()
            max = max - 1
        end
    end
    
    local new = ti and ti.tile or ti
    
    if doMessage then
        cr:addLog(string.format("%s was teleported!", cr.title))
    end
    
    do
        if cr.isCreature then
            self:setTile(cr, new)
            
            cr:move_to(new.x,new.y)
            if new.item then
                self:addItemTo(cr, new.item)
            end
            
            cr.x, cr.y = new.x, new.y
            if cr == self.player then
                self:reloadFov()
                self.cameraMan.x = cr.x
                self.cameraMan.y = cr.y
            end
            
            if cr.lightData then
                self:removeLight(cr.lightData)
                cr.lightData = nil
            end
            
            if cr.light then
                local l = cr.light
                cr.lightData = self:addLight(cr.tile, l[1], l[2])
            end
            
            if cr.playTeleport then
                cr:playTeleport()
            end
        else
            self:removeItem(cr)
            self:spawnItem(cr, ti)
        end
        
    end
end

function Map:switchPlaces(obj1, obj2, ...)
    if obj2 == obj2.tile.unit then
        obj2.tile.unit = nil
    end
    
    local t1 = obj1.tile
    local t2 = obj2.tile
    
    if math.abs(t1._x-t2._x)>1 or math.abs(t1._y-t2._y)>1 then
        self:teleport(obj1, t2)
        self:teleport(obj2, t1)
    else
        self:moveObject(obj1, t2._x-t1._x, t2._y-t1._y, ...)
        self:moveObject(obj2, t1._x-t2._x, t1._y-t2._y, ...)
    end
    
    
    obj1:addLog(string.format("%s switched places with %s!", obj1.title, obj2.title))
end

function Map:moveObject(cr, vx, vy, speed, tile, getAttacked, attacker, byForce, noAffectAngle, prompt)

    if cr.moving and not speed then warn("cr already moving!") return end
    if cr.tile and cr.tile.ice then warn("Cr has iced tile!") return end
    if not cr.playing and not speed then cwarn("yoh, cr not playinf","pink") return end
    
   
    
    if cr:isParalyzed() and not speed then
        self:playNextCreature() -- no need
        return
    end
    
    if cr:isConfused() and not speed then
        local d = getValue(math.random()>.4 and dirs4 or dirs8)
        vx, vy = d[1], d[2]
    elseif cr.unsteady and math.random() > .7 then
        local d = getValue(math.random()>.4 and dirs4 or dirs8)
        vx, vy = d[1], d[2]
    end
    
    local t = cr.tile
    local new = tile or self:getTile(t._x+vx, t._y+vy)
    
     if cr.tile.web and cr.tile.web.strength >= 0 and not cr.nimble and 
     ( (new and new:isFree()) or (new and new.solid) or (not new) )
     then
        cr:addLog(string.format("%s struggles against the web!", cr.title))
        cr.tile.web.strength = cr.tile.web.strength - lume.max(.5, cr.stats.strength)
        if cr.tile.web.strength <= 0 then
            cr.tile.web = nil
            cr:addLog(string.format("%s broke free from the webbing!", cr.title))
        end
        
        self:playNextCreature()
        return
    end
    
    local freeTile = new and new:isFree()
    
    local range = cr:getMeleeRange()
    if range and range > 1 and freeTile and not byForce then
        for i = 2, range do
            local t = self:getTile(t._x+vx*i, t._y+vy*i)
            local u = t and (t.unit or (t.item and t.item.isObstacle and t.item))
            if u then
            
                if not cr.isPlayer and u ~= cr.target then
                    cr:addLog(string.format("%s bumped into %s", cr.title, u.title))
                end
                
                return cr:doAttack(u)
            end
        end
    end
    
    if freeTile then
        if new:isChasm() and prompt == 1 and cr.isPlayer and not cr:isFlying() then
            local func = function()
                self:moveObject(cr, vx, vy, speed, tile, getAttacked, attacker, byForce, noAffectAngle, false)
            end
            
            
            gooi.dialog({
                text = "Really jump into that chasm?",
                ok = func
            })
            
            return
        end
        
        if cr.tt then
            self.timer:cancel(cr.tt)
            cr.tt = nil
            cr.angle = cr.flipX == 1 and 1 or 180
        end
        cr.moving = true
        log("moving")
        self:setTile(cr,new)
        local d = -15
        local oa = cr.angle
        cr.flipX = vx ~= 0 and getDir(vx) or cr.flipX
        cr.angle = cr.flipX == 1 and 1 or 180
        cr.oangle = cr.angle+d*(vx == 0 and 1 or vx)+(cr.flipX==-1 and 0 or 0)
        local function finish(nl,noTt)
            cr.tweening = false
            cr.moving = false
            if not noTt then
                cr.tt = self.timer:tween(.1,cr,{angle = cr.flipX == 1 and 1 or 180},"out-quad")
            end
            
            cr:move_to(new.x,new.y)
            
            if new.pressurePlate and new.pressurePlate.parent and (not new.item or not cr.canPickItems) then
                new:addLog(string.format("A pressure plate clicks underneath %s...",cr. title))
                self.trapsToActivate[#self.trapsToActivate+1] = new.pressurePlate.parent
                new.toActivateTrap = true
            end
            
            local item = new.item
            
            if new.item then
                self:addItemTo(cr, new.item)
            end
            
            if new:splashPuddles() then
            
            end
            
            cr.x, cr.y = new.x, new.y
            if cr == self.player then
                self:reloadFov()
            end
            
            if cr.lightData then
                self:removeLight(cr.lightData)
                cr.lightData = nil
            end
            
            if cr.light then
                local l = cr.light
                cr.lightData = self:addLight(cr.tile, l[1], l[2])
                cr.lightData.source = cr
            end
            
            if getAttacked then
                cr:getAttacked(cr.thrower or attacker, getAttacked)
            end
            
              
            if item then
                if item.onSteppedOn then
                    item:onSteppedOn(cr)
                end
            end
            
            if ((cr.equipped and cr.equipped.lungeAttack) or cr.lungeAttack) and not byForce then
                local tile = self:getTile(new._x+vx, new._y+vy)
                local u = tile and (tile.unit or (tile.item and tile.item.isObstacle and tile.item))
                if u then
                    local ac = cr.stats.accuracy
                    cr.stats.accuracy = ac + 100
                    cr:doAttack(u)
                    cr.stats.accuracy = cr.stats.accuracy - 100
                    return
                end
            end
            
            if cr == self.player then
               -- self:after(1, function()
               self:playNextCreature() --end)
            else
                cr.done = true
            end
        end
        local ox, ow = t.x,t.w
        t.w = t.w*1.2
        t.x = t.x - (t.w-ow)/2
        t.y = t.y+th/2
        if cr.isSeen or cr.isPlayer then
            --cr.spawnDebris(t,cr.color,1/5)
        end
        t.y = t.y-th/2
        t.w = ow
        t.x = ox
        if cr==self.player or (self.player.stats.speed>cr.stats.speed and cr.isSeen) or speed then---or cr.isSeen then
            cr.tweening = true
            local pSpeed = cr.isPlayer and 1 or (self.player.stats.speed/1.5)
            self:tween(speed and (speed*pSpeed) or cr==self.player and .4*pSpeed or .2*pSpeed,cr,{x=new.x, y=new.y, angle=not noAnffectAngle and cr.oangle or nil},"in-quad",finish)
        else
            finish(nil,true)
        end
        
    elseif new.ice then--new.item and new.item.isObstacle then
        cr:doAttack(new.ice)
        if cr == self.player then
            cr.playing = false log("ahhhhhhh noooo")
        end
        self.stall = true
        self:playNextCreature()
        
    elseif new.item and new.item.isObstacle then
        cr:doAttack(new.item)
        if cr == self.player then
            cr.playing = false
        end
        self.stall = true
        self:playNextCreature()
        
    elseif cr and new.unit and cr:isEnemy(new.unit) then
        --cr.attack = cr:getDamage()
        cr:doAttack(new.unit)--new.unit:getAttacked(cr)
        log("att mov")
        if cr == self.player then
            cr.playing = false
        end
    elseif cr and new.unit and (new.unit.lastSwitched <= cr.lastSwitched and not new.unit.isPlayer or cr.isPlayer) then
        -- prevents creatures from keeping on swithing
        
        cr.lastSwitched = cr.lastSwitched + 2
        self:switchPlaces(cr, new.unit, speed, getAttacked, attacker, byForce, noAffectAngle, prompt)
        
    elseif cr ~= self.player then
        cr.done = true
    elseif new and new.isLocked then
        self:addLog("&colors.orange This door is &colors.red locked, %colors.orange and You don't have a matching key!")
        -- tile is solid
    end
    
    if new and not new:isFree() and cr.isPlayer then
        log("[Space occupied] "..(new.solid and "tile is solid" or "..."))
        log(string.format("unit: %s, item:%s ", new.unit and tostring(new.unit._id) or "none",
            new.item and new.item._id or "none")
        )
    end
    
    if new and not new:isFree() and new.isLocked and new.key and cr:hasItem(new.key) and (cr.isPlayer or cr.isSeen) then
        new:unlock()
        local k = new.key
        cr:removeItem(new.key)
        new.key:destroy()
        new.key = nil
        
        assert(not cr:hasItem(k))
        -- assert(cr.isPlayer, cr.title..","..tostring(cr._id))
        
        cr:addLog(string.format("%s unlocked %s door.",cr.title,cr.isPlayer and "the" or "a"))
    end
    
    if not new and cr.isPlayer then
        log("[Space is not existing]")
    end
    
    return freeTile
end

function Map:lightCallback(fov, x, y)
    local t = self.tiles[x] and self.tiles[x][y]
    
    if not t then return end
    if t:isSolid() then return end
    if t.hasDoor and not t:doorIsOpen() then return end
    
    return true
end

function Map:getFov()
    local rot = toybox.rot()
    local fov = function(fov,x,y) return self:lightCallback(fov,x,y) end
    self.fov = rot.FOV.Precise:new(fov, {topology=4})
    
    local tfov = function(fov,x,y) return self:lightCallback(fov,x,y) end
    self.terrainFov = rot.FOV.Precise:new(tfov)

end

local seemTiles

local function seeFunc(x,y)
    local room = toybox.room
    local t = toybox.room:getTile(x,y)
    if t then
        t.drawID = room.drawID
        seenTiles[#seenTiles+1] = t
    end
end

function Map:reloadFov()
    self.drawID = lume.uuid()
    local pl = self.player
    local t = pl.tile
    local l = pl.tile.light or 0
    local added = (l>=.1 and 3 or l>=.5 and 8 or l>=.8 and 12 or 0)*2
    self.addedSight = added
    seenTiles = {}
    self.fov:compute(t._x, t._y, (pl:getSight() or 10)+added+1, seeFunc)
    pl.seenTiles = seenTiles
    seenTiles = nil
    self:computeLight()
end

local oobj

function Map:isWalkable(x,y)
    local t = self:getTile(x,y)
    local flight = oobj and oobj:isFlying()
    
    return t and t:isFree(self.except) and (flight or not t:isChasm())
end

function Map:findPathTo(obj,x,y)

    local obj = obj
    local x = x
    local y = y
    if type(obj) ~= "table" then
        x = obj
        y = x
        obj = y
    end
    
    oobj = obj
    
    obj = obj.tile or obj
    
    local floor = math.floor
    local _x,_y = (obj.getPos and obj:getPos()) or obj._x, obj._y
    
    --start = {x=floor(_x),y=floor(_y)}
    
    if not self.grid[floor(x)] then log("no tile,returning") return end
    if not self.grid[floor(x)][floor(y)] then log("no tile, returning") return end
    if self.grid[floor(x)][floor(y)].collidable == true then
        log("collidable")
        return
    end
    obj._goto = self.grid[floor(x)][floor(y)]
    self.c_unit = obj


    local function check(x,y)
        return self:isWalkable(x,y)
    end
    
    local path = {}
    local function buildPath(x,y)
        local pp = _Path:new(x,y)
        pp.tile = self:getTile(x,y)
        table.insert(path,pp)
    end
    
    goal = {x=x,y=y}
    start = {x=_x,y=_y}
    local pth = rot.Path.AStar(goal.x,goal.y,check)
    pth:compute(start.x,start.y,buildPath)
    return path
end

function Map:playNextCreature()
    log("=== starting turn ===")
    
    if self.player and self.player.room ~= self then
        return
    end
    
    -- do
    if self.doingPlay and self.doingPlay > 20 then
        self.stall = true
        self.doingPlay = nil
    end
    
    if self.stall then
        return
    end
    
    log("============ new turn =============")
    
    if self.currentPlaying then
        self.currentPlaying:playEndTurn()
        
    
        if self.currentPlaying.isPlayer then
            -- check poison at end of turn for player
            self.currentPlaying:checkPoisonDamage()
        end
        
        self.currentPlaying.playing = false
        self.currentPlaying:updateStatusEffects()
    end
    
    self.playing = (self.playing or 0)--1
    if self.player and self.player.died then
        self.doingPlay = (self.doingPlay or 0)+1
    end
    
    local c = self.creatures[self.currentCreature+1]
    if c == self.currentPlaying and c then
        for xx = 1,#self.creatures do self.creatures[xx] = self.creatures[xx].name..", ".. self.creatures[xx].id end error(inspect(self.creatures))
    end

    if not self.gasked and (self.currentPlaying == self.player or (self.player:isReallyDead() and not self.creatures[self.currentCreature+1])) then
        log("UPDATING GASES")
        self:updateGases()
        log("gases dkne")
        self.noiseManager:update(1)
        self:updateItems()
        log("items done")
        
        self:updatePuddles()
        
        -- traps to activate on next turn?
        for x = 1, #self.trapsToActivate do
            self.trapsToActivate[x]:activate()
            self.trapsToActivate[x].tile.toActivateTrap = nil
        end
        
        self.trapsToActivate = {}
       -- self.currentCreature = self.currentCreature + 1
        local pl = self.currentPlaying-- = nil
        log(string.format("PLAYING NUM: %s", self.playing))
        --self.currentPlaying.name  = self.playing pl:cry("gass")
        self.playing = 0
        if self.exploding > 0 or trukke then
            log("PAUSE G")
          --  self.gased = true
            self.toPlay = true pl:cry("rr")
            return
        end
        
    
    end
    --player play
    
    self.gased = nil
    local cr = self.currentPlaying
    
    
    
    if cr then
        self.currentPlaying.turnSpeed = lume.max(0,(cr.turnSpeed)-(not cr.didTurn and 0 or cr.attackedThisTurn and 2 or 1))
        self.currentPlaying.currentTurn = self.currentTurn
    end
    
    if not cr or self.currentPlaying.turnSpeed < 1 then
        log("step up!! "..(cr and "no cr!" or " cr!"))
        self.currentCreature = self.currentCreature+1
        cr = self.creatures[self.currentCreature]
        
        if cr then
            cr.turnSpeed = cr.turnSpeed + cr.stats.speed
            cr.attackedThisTurn = false
            cr.didTurn = false
        end
    else
        log("no step up"..(cr and cr.turnSpeed)..tostring(cr and cr.didTurn)..tostring(cr.title or cr.name or cr.class).." died: "..tostring(cr.died))
    end
    
    cr = self.creatures[self.currentCreature]
    self.currentPlaying = cr
    if cr then
        cr.didTurn = true
    end
    
    
    
    
    if not cr then
        local o = self.currentCreature
        self.currentCreature = 0
        
        self.currentTurn = (self.currentTurn or 0)+1
        log("[TURN] !! restart turn order at max "..o.." of total "..#self.creatures)
        
        if self.player.died then
            self.stall = true
            --self:after(.15,function() self.stall = false end)
        end
        
        return self:playNextCreature()
    end
    
    self.logText = "Playing "..cr.title
    
    if (self.pausedPlay or 0)>3 and not cr.isPlayer and nil then
        self.pausedPlay = 0
        self.toPlay = true
        self.currentCreature = self.currentCreature - 1
        self.currentPlaying = nil
        log("pause!! "..self.pausedPlay)
        return
    elseif not cr.isPlayer then
        self.pausedPlay = (self.pausedPlay or 0)+1
        --log("not pause "..self.pausedPlay)
    end
    
    cr.playing = true
    
    
    
    if cr == self.player then if ppol then error() end
        log("[TURN] PLAYER IS THE ONE CURRENTLY playing "..tostring(self), "lightgreen")
    end
    
    cr.done = false
    
    
    cr:updateTurn()
    log("updateturn")
    
    if cr then-- ~= self.player then
        cr:play()
        if cr.isPlayer and self.moveToTile then
            cr:moveTo(self.moveToTile)
            if cr.tile == self.moveToTile then
                self.moveToTile = nil
            end --isseen =
        end
    elseif cr.died then
        return self:playNextCreature()
    end
end

function Map:see(obj)
    if not obj.isSeen and obj.isCreature then
        self.moveToTile = nil
        self.player:addLog(string.format("You spot %s", obj.unspecific))
    end
    
    obj.isSeen = true
end

function Map:unsee(obj)
    obj.isSeen = false
end

function Map:er() local i = {} for x, m in ipairs(self.creatures) do i[tostring(m)] = (i[tostring(m)] or 1)+1 end error(inspect(i)) end

function Map:updateItems()
    for _, item in pairs(self.items) do log(item.name)
        item:playStartTurn() log('start done, yoh')
        item:updateTurn()
        
        if item.tile and not item.tile.isChasm then
            error("Item "..item.name..", has a bad tile: "..inspect(item.tile,2))
        end
        
        if item.tile and item.tile:isChasm() then
            self:moveToNextFloor(item, false, tile)
        end
    end
end

function Map:updatePuddles()
    for tile, _ in pairs(self.checkPuddles) do
        tile:checkPuddles()
    end
end

local d_i = Map.destroy_instance
function Map:destroy_instance(i, ...)
    if i.tile and i.isItem then
        i.tile.item = nil
        
        if i.tile.floor == i then
            i.tile.floor = nil
        end
    
        local n =  i.tile.pressurePlate and i.tile.pressurePlate.parent
        if n and n.activated and not i.tile.unit then
            n:deactivate()
        end
    end
    
    if i.lightData then
        self:removeLight(i.lightData)
        i.lightData = nil
    end
    
    
    if i.isItem and pl and ccr and nil then
        if not self.items[i] then
            local ii = {}
            for x,pi in pairs(self.items) do
                ii[pi.name..","..pi.id] = true
            end
            error(inspect(i.remm)..","..inspect(ii)..","..i.data.name..","..i.id)
        end
    end
    
    
    i.remm = true
    
    self.items[i] = nil
    
    if i.user then
        lume.remove(i.user.toUpdateItems, i)
    end
    
    return d_i(self, i, ...)
end

function Map:removeItem(item)
    return self:destroy_instance(item)
end

function Map:addGas(gas)
    if gas.isFire then
        return self:addFire(gas)
    end
    self.gases[#self.gases+1] = gas
end

function Map:removeGas(gas)
    if gas.isFire then
        return self:removeFire(gas)
    end
    
    local removed = lume.remove(self.gases, gas)
    self:destroy_instance(gas)
    
    return removed
end

function Map:addFire(fire)
    self.fires[#self.fires+1] = fire
end

function Map:removeFire(fire)
    local removed = lume.remove(self.fires, fire)
    self:destroy_instance(fire)
    
    return removed
end

--Map.addFire = Map.addGas
--Map.removeFire = Map.removeGas

function Map:gass()
    local t = self.player.tile
    Gas:new({
        source = self:getTile(t._x+3,t._y+3),--room:getRandomSpaceTile(),
        map = self,
        flammability = 1
    })
  --  Fire:new({source=self.player.tile})
end

local ldirs = {"/","\\"}
local lColors = {"grey"}--,"cyan","purple","maroon"}
function Map:update(dt)
    self:updateCamera()
    self.creatureDt = dt/(self.player and self.player.stats.speed)
    self.doingPlay = nil
    
    if self.stall then
        self.stallTime = (self.stallTime or .15)
        if self.stallTime <= 0 then
            log("stall cleared")
            self.stallTime, self.stall = nil
        else
            self.stallTime = self.stallTime - dt
        end
    end
    
    if not self.player.playing then
        self.changeLoadingDir = (self.changeLoadingDir or 0)+dt
        self.loadingDirs = self.loadingDirs or 1
        if self.changeLoadingDir > .2 then
            self.loadingDir = self.loadingDir == #ldirs and 1 or (self.loadingDirs + 1)
            self.waitButton:setText(string.format("&colors.%s %s",getValue(lColors),ldirs[self.loadingDir]))
            self.changeLoadingDir = 0
        end
    else
        self.waitButton:setText("...")
    end
    
    
    if self.player.equipped then
        self.eqImage.source = self.player.equipped.source
    else
        self.eqImage.source = "fist.png"
    end
        
    if self.currentPlaying and self.currentPlaying.isPlayer and self.currentPlaying.died and self.exploding<=0 then
        log("player play next")
        self:playNextCreature()
    elseif self.currentPlaying and self.currentPlaying.died and not self.world:hasItem(self.currentPlaying) and self.exploding <=0 then
        log("[Complication] Dead, next")
        self:playNextCreature()
    elseif self.exploding<=0 and self.toPlay then
        self.toPlay = nil
        self:playNextCreature()
    end
    
    if self.oldStall and not self.stall then
        log("play from stall")
        self.oldStall = self.stall
        self:playNextCreature()
    end
    
    self.oldStall = self.stall
    
    self.dt = dt
    
    self:updateCoroutine()
end

function Map:updateGases()
    for g = 1, #self.fires do
        local gas = self.fires[g]
        if gas then
            gas:updateTurn()
        end
    end
    for g = 1, #self.gases do
        local gas = self.gases[g]
        if gas then
            gas:updateTurn()
        end
    end
end

allLights = {}
lightCount = 0

local map, lighted, tmpItem, enchantingLight
local lightTile = function(x,y)
        local tile = map:getTile(x,y)
        
        if not tile then
            return
        end
        
        local dis = lume.distance(tile.x,tile.y,tmpItem.x,tmpItem.y)/tw
        local newLight = lume.max(0,1-(dis/tmpItem.maxDis))

        tmpItem.newLight[tile] = newLight
        local light = {
            enchantringLight and lume.max(0,(tmpItem.maxDis-dis)) or newLight,
            tmpItem.color,
            tmpItem,
            1-newLight,
            tmpItem.range/(dis+1),
            (dis)/(tmpItem.range*(mcn or 3))  -- lightth
        }
        
        log("light :"..tmpItem.range..":"..dis..": "..(tmpItem.range/(dis+1))..","..((dis)/tmpItem.range))
        
        if enchantringLight then
        
            tile.enchantingLights[#tile.enchantingLights+1] = light
        else
        
            tile:addLight(light)
        
            --tile.light = (tile.light or 0) + newLight
        
            tile.lights = tile.lights + 1
        end
         
        --tile.color = tmpItem.color
        lighted[#lighted+1] = tile
end

function Map:addEnchantLight(tile, range, color, life, ...)

    -- first remove an old enchanting light if it hasn't faded away yet.
    -- enchant lights aren't too important so whatevs, even if it's far
    if self.enchantLight then
        --self:removeLight(self.enchantLight)
    end
    
    enchantingLight = true
    local light = self:addLight(tile, range, color or "lime", life or 1.2, ...)
    light.enchanting = true
    --self.enchantLight = light
    enchantingLight = false
    
    return light
    
end --mcc

function Map:addLight(tile,range,color,lifeTime,alpha)
    if color == "nil" or color == "null" then
        return
    end
    
    map = self
    range = range*2
    local light = {
        source = tile,
        x = tile.x,
        y = tile.y,
        color = getColor(color or "orange"),--getColor(color or "white"),
        newLight = {},
        maxDis = lume.distance(tile.x-range*tw, tile.y-range*th, tile.x, tile.y),
        isLight = true,
        lifeTime = lifeTime,
        alpha = alpha,
        range = range
    }
    lighted = {}
    tmpItem = light
    tmpItem.range = range*.5
    self.fov:compute(tile._x, tile._y, range, lightTile)
    
    --[[local ll = self.lighting
    local c = light.color 
    ll:setLight(tile._x, tile._y, {c[1]*255,c[2]*255,c[3]*255})--light.color)
     self:computeLight()--gettilel
    ]]
    
    light.lighted = lighted
    light.enchanted = enchantingLight
    
    lightCount = lightCount+1
    allLights[light] = 1
    
    if lifeTime then
        local function removeLight()
            if not light.remove and not light.enfchanted then
                self:removeLight(light)
            end
        end
        
        light.alpha = light.alpha or 1
        
        self:tween(lifeTime, light, {alpha = 0}, "out-quad", removeLight)
    end
    
    map = nil
    lighted = nil
    tmpItem = nil
    
    return light
end

 lo = function()
 self:addEnchantLight(pl.tile,3,"cyan") --debugp
end
function Map:removeLight(light)
    if not light then return end
    
    if light.removed then return end
    
    light.removed = true
    lightCount = lightCount-1
    allLights[light] = nil
    
    local lighted = light.lighted or {}
    do
        for x = 1,#lighted do
            local tile = lighted[x]
            
            --[[if tile.light or tile.color then--nil then
                tile.light = tile.light - light.newLight[tile]
                tile.lights = tile.lights - 1 --tile.color = nil
                if tile.light<=0.01 then
                    tile.light = nil
                    tile.newLight = nil
                    tile.color = nil
                end
            end]]
            
            tile:removeLight(light)
        end
    end
    
    light.removed = true
end

function Map:draw_before()
    --lg.setShader(reverseShader)
    shh = lg.setShader
    --self.player.shader = reverseShader
    --lg.setShader = null
end

function Map:after_draw(dt)
    if self.submergedAlpha and self.submergedAlpha~=0 and self.player and self.player.submerged then
        local c = colors.royalblue
        local r,g,b,a = set_color(c[1],c[2],c[3],self.submergedAlpha or .5)
        draw_rect("fill",0,0,W(),H())
        set_color(r,g,b,a)
    end
    
    --lg.print(love.timer.getFPS(),0,0)
    --lg.print("turn: "..self.currentTurn, 0, lg.getFont():getHeight()+3)
    
    self.camera:attach()
    
    for x, i in pairs(self.sounds or {}) do
        x:draw()s.b:__step(dt)
    end
    
    self.camera:detach()
    
    if self.throwing then
        local r,g,b,a = set_color(colors.orange)
        local quickslots = self.quickslotButtons
        local sc = 1.5
        lg.print("[TARGETING]", quickslots[1].x, quickslots[1].y - lg.getFont():getHeight()*1.1*sc - 3, 0, sc, sc)
        set_color(r,g,b,a)
    end
    
    if self.player then
    
        local maxFrames = 3
    
    
        self.heartFrame = (self.heartFrame or 0) + dt/(.15)
    
        local maxFrames = 3
        local currentFrame = math.floor(self.heartFrame%maxFrames)
        local cr = currentFrame
    
        while cr > (maxFrames-1) do
            cr = 0+(cr-(maxFrames))
        end
        
        while cr < 0 do
            cr = 0
        end
    
        local h = game:getAsset(string.format("hearts/%s/%s.png",self.player.poisoned>0 and "purple_heart" or "blood_heart", cr))
        
        local ws = (H()/25)*2
        local wh, hh = resizeImage(h, ws, ws)
        love.graphics.draw(h, 10, 2, 0, wh, hh)
        
        self.hx, self.hy = 10+ws/2, 2+ws/2
        
        local l = self.player.lifebar
        l.angle = 0
        l.w, l.h = (W()*.2)*(1 or self.player.maxHealth/15), H()/25
        l.x, l.y = ws-10,20
        l.healthColor = "red"
        l:draw()
        
        love.graphics.draw(h, 10, 2, 0, wh, hh)
        
        local gg = self.player.gold
        local i = game:getAsset("items/gold.png")
        local w = l.h*2
        -- local ww, hh = resizeImage(i, l.h*3, l.h*3)
        -- love.graphics.draw(i, l.x, l.y, 0, ww, hh)
        local r,g,b,a = set_color(colors.gold)
        -- love.graphics.print(gg, l.x+l.h*3+10, l.y+l.h+5+l.h*3/4, 0, 1.3, 1.3)
        set_color(r,g,b,a)
        
        
    end
    
    gooi.draw(gooi.currentGroup)
    
    if self.player then
        for x = 1, #self.allDoubleTraits do
            local t = self.allDoubleTraits[x]
            local data = self.traits[t]
            local b = self.allTraitButtons[data[2]]
            
            local sc = 1
            love.graphics.print(string.format("x%s", data[1]), b.x+b.w/1.5-5, b.y+5, 0, sc, sc)
        end
    end
    
    for x = 1, #self.quickslotButtons do
        local b = self.quickslotButtons[x]
        b.angle = b.angle or math.random(-45,45)
        if b.item then
            local i = b.item
            i:redraw(b.x+b.shake_x, b.y+b.shake_y, b.angle, b.w, b.w*(i.h/i.w))
        end
    end
    
    self:__draw_controllers()
    --lg.setShader=shh
    --lg.setShader()
    
    --draw_rect("fill",yyt.x,yyt.y,yyt.w,10)
    for i = 1, #self.logs do
        local yyt = self.logs[i]
        yyt:update(love.timer.getDelta())
        yyt:draw()
    end
    
    if self.nexting then
        self.camera:draw()

        if self.nexting2 then
            local r,g,b,a = set_color(0,0,0,1)
            draw_rect("fill",-W(),-H(), W()*3, H()*3)
            set_color(r,g,b,a)
        end
        
        gooi.drawComponent(self.nexting)
        
        if self.nexting2 then
            gooi.drawComponent(self.nexting2)
        end
    end
    
    if self.nextAlpha and self.nextAlpha > 0 then
            local r,g,b,a = set_color(0,0,0,self.nextAlpha)
            draw_rect("fill",-W(),-H(), W()*3, H()*3)--cant
            set_color(r,g,b,a)
    end
    
    --[[local h = lg.getFont():getHeight()+3
    lg.print(string.format("FPS: %s", love.timer.getFPS()),0,0)
    lg.print(string.format("turn: %s", self.currentTurn), 0, lg.getFont():getHeight()+3)
    lg.print(string.format("[MAP] : %s", self.logText or ""), 0, (lg.getFont():getHeight()+3)*2)
    
    love.graphics.print(string.format("garbage count: %smb",collectgarbage("count")/1024),0,h*3)
    love.graphics.print(string.format("Texture mem: %smb",love.graphics.getStats().texturememory/(1024*1024)),0,h*4)
    old_print(inspect(love.graphics.getStats()),0,h*6)]]
end

local function sortThrow(tile)
    return tile.isTile--not tile.solid
end

function Map:mousereleased(x,y)
    if self.nexting2 then
        self.nexting = nil
        self.nexting2 = nil
        self.nextAlpha = 1
        self:tween(.7,self,{nextAlpha=-.01},"out-quad")
        gooi.removeComponent(oldMap.nexting)
        oldMap.nexting = nil
        return
    end
    
    self.player.name = #self.creatures.." creatures on map"
    
    x,y = self.camera:toWorldCoords(x,y)
    local tile = self:getTileP(x,y)
    
    -- Debris.spawn(x,y,"purple")
    if self.clicked then
        self.clicked = false
        return
    end
    
    if self.buttonPressed then
        self.buttonPressed = nil
        return
    end
    
    --spawnitem is called
    
    local txt
    
    if tile and tile.unit and nil then
        local u = tile.unit
        
        local l = {}
        for x, i in pairs(tile.unit.liking) do
            if type(x) == "table" and x.isCreature then
                l[x.name..","..x.id] = i
            end
        end
        local targ = tile.unit.target or tile.unit.foodTarget
        local states = string.format("[STATE] %s, [TARGET] %s", u.currentState, targ and targ.title or "--")
        txt = (txt or "") .. states .. inspect(l) .. "\n"
        
        --tile.unit.title..",\n  [STATE] = "..tile.unit.currentState.."\n[NUTRITION] = "..tile.unit.nutrition.."\n[Target] = "..(targ and targ.title or "None"))
    
    
    elseif tile and tile.item then
        txt = (txt or "").."[ITEM] "..tile.item.unspecific.." of type "..tile.item.type..". Is Obstructing? : "..tostring(tile.item.isObstacle).."\n"..tostring(tile.item.isSeen)
    end
    if tile and tile.item and tile.item.name == "ice" and tile.ice~=tile.item then error() end -- e:isSo
    if tile then
        local colorr, lenm
        lenm = #tile.myLights
        do
            local self = tile
            
            local player = self.room.player
            local dis = lume.distance(self.x, self.y, player.x, player.y)
    
            local aa = dis/(maxdis+(self.room.addedSight or 0))
            local light = 1
            local light2 = 0
            light = myLight or light or lightAll and 1 or 0--self.myLight or light or 1
            light2 = lightAll and 1 or 0--1
            local donec= {}
            local col = self.color
            for i = 1, lenm do
                --i = math.random(1,lenm)
                local addc = addc
                local l = self.myLights[i]
                local ii =(((1-aa)*light)+(self.light or 0))/((self.light or 0) + 1)-- l[4]
                local iii = 1
                ii = lume.min(ii, .9)
                local color = l[2] or colors.green--getColor(l[2] or "black")--, l[3].alpha)
                if l[3].alpha then
                    color = lume.copy(getColor(color))
                    for x = 1, 3 do
                        color[x] = color[x]--*l[3].alpha assert(color[x]>=0) assert(ii<=1,ii)
                    end
                    ii=.5--self.color = color
                    color[4]=lume.max(.4,l[3].alpha)
                    addc = addc2
                    --break
                end
                
                --local color = donec[l[2]] and {0,0,0} or color--{color[1]*iii,color[2]*iii,color[3]*iii}
                colorr = lenm == 1 and color or addc(getColor(self.color or "black"),color or
                color,ii)
            end
        end
        
        txt = (txt or "")..string.format("[TEMP] %s (from %s)",tile:getTemperature(),tile.temperature).."\n"..string.format("[lights] : %s ( %s ) { %s }", lenm, inspect(colorr), inspect(self.color)) -- debugp
    end
    
    if txt then
        -- self:addLog(txt)
    end
    
    self.oldThrows = self.oldThrows or {}
    
    local m = self.moveToTile
    local no
    if m and not m.throwing then
        self.moveToTile = nil
        no = true
    end
    
    if nil then--not no and tile and not self.throwing and self.player.playing and not self.player.moving then
        if not tile:isSolid() and tile.seen then
            if tile == self.moveToTile then
                self.player:moveTo(tile)
                tile.throwing = false
            else
                tile.throwing = true
                self.moveToTile = tile
            end
        end
    end
    
    if self.throwing and tile and tile~=self.throwTile then
        self.throwTile = tile
        local i = self.throwing
        local user = self.inventoryUser
        local tt = user.tile
        local tiles, len = self.world:querySegment(tt.x+tw/2, tt.y+th/2, tile.x+tw/2, tile.y+th/2, sortThrow)
        local lastTile = tt
        for x = 2,#self.oldThrows do
            self.oldThrows[x].throwing = nil
        end
        local bad
        self.oldThrows = {}-- assert(len>0)
        for ii = 1, len do -- #add max throw range
            local t = tiles[ii]
            self.oldThrows[ii] = t
            t.throwing = true
            t.throwingDest = false
            t.throwingBad = false
            if t:isSolid() then
                bad = true
            end
            
            if bad then
                t.throwingBad = true
            else
               lastTile = t.item and t.item.isThrowObstacle and lastTile or (t.unit and i.unitBlocks and lastTile) or t
                if t.item and t.item.isThrowObstacle or (t.unit and t.unit~=user) then
                    bad = true--break
                end
            end
        end
        lastTile.throwingDest = true
        self.throwTooFar = lume.distance(tt._x, tt._y, lastTile._x, lastTile._y) > user:getThrowDistance(i)
        
    elseif self.throwing and tile and self.throwTile == tile and not self.throwTooFar then
        self.throwTile = nil
        local i = self.throwing
        local user = self.inventoryUser
        local tt = user.tile
        local tiles, len = self.world:querySegment(tt.x+tw/2, tt.y+th/2, tile.x+tw/2, tile.y+th/2, sortThrow)
        local lastTile = tt
        for ii = 1, len do -- #add max throw range
            local t = tiles[ii]
            t.throwing = false
            if t:isSolid() then
                break
            end
            
            lastTile = t.item and t.item.isAnvil and t or t.item and t.item.isThrowObstacle and lastTile or (t.unit and i.unitBlocks and lastTile) or t
            if t.item and t.item.isThrowObstacle or (t.unit and t.unit~=user) then
                break
            end
        end
        
        if self.selectingTarget then
            self.throwing = nil
            user.target = lastTile.unit or lastTile
            self.selectingTarget = nil
            
            self.onTarget(i, user, user.target)
            self.onTarget = nil
            return
        end
        
        if lastTile and not lastTile.isChasm then
            error("Not proper last tile "..inspect(lastTile,1))
        end
        
        user:removeItem(i)
        if i.tile then
            i.tile.item = nil
        end
        
        i.throwing = true
        i.tile = lastTile
        --tile.item = nil
        i.throwing = true
        self.throwing = nil
        local function thrown()
            i.throwing = false
            --i.tile = lastTile
            
            if not lastTile.isChasm then error() end
            
            if not (lastTile.item and (lastTile.item.isAnvil or lastTile.item.anvil)) then
                log("thrown")
                i:onThrown(lastTile, user)--onrec
            else
                log("spawned")
                self:spawnItem(i,lastTile)
            end
            
            if i.tile and not i.tile.isChasm then error("tile is wierd "..inspect(i.tile,1)) end
            i.va = 0
            self:playNextCreature()
        end
        --i.debug = 1
        local time = .1*(lume.distance(tt._x, tt._y, lastTile._x, lastTile._y))
        i.va = 360*4--local spin = (time/.3)/3
        i.name_tag=lume.distance(tt._x, tt._y, lastTile._x, lastTile._y)
        self:tween(time, i, {x=lastTile.x, y=lastTile.y}, "in-quad", thrown)
    end
end

function Map:keypressed(k) ---- ppol=1
    if self.nexting2 then
        self.nexting = nil
        self.nexting2 = nil
        self.nextAlpha = 1
        self:tween(.7,self,{nextAlpha=-.01},"out-quad")
        gooi.removeComponent(oldMap.nexting)
        oldMap.nexting = nil
        return
    end
    
    --self.player:knocback(1,0,10)--self.reportDrawPerformance = true if 1 then return end
    if k == "escape" and self.popUp then
        self:removePopUp()
        return
    end
    
    if self.inventoryIsOpen then
        self:closeInventory()
        return
    end
    
    if self.throwing or self.selectingTarget then
        self.selectingTarget = nil
        self.throwing = nil
        
        for x = 1,#self.oldThrows do
            self.oldThrows[x].throwing = nil
        end
        
        self:addLog("selecting canceled")
        return
    end
    
    
    if k == "escape" then
        pl:polymorph("goblin")
    
    
    --error(lightCount..","..inspect(allLights,3))
    if true then--not lightAll then
    lightAll = not lightAll--true
    osse = osse or self.camera.scale
    self:tween(.7,self.cameraMan,{scale=self.cameraMan.scale>.1 and .1 or osse})
    olt = olt or Tile.draw
    --self:set_target(self.allTiles[math.floor(#self.allTiles/2)])
    --Tile.draw = function(self) if self.solid then draw_rect("line",self.x,self.y,self.w,self.h) end end
    else
    Fire:new({source=self.player.tile})
        lightAll = false
        self:tween(.7,self.cameraMan,{scale=osse})
        self:set_target(self.player)
        Tile.draw = olt
    end
    
    end
end

return Map